/*------------------------------------------------------------------- */
 /* Logistic Regression Using the SAS System: Theory and Application  */                                                    /*                                                                   */
 /*                     by  Paul D. Allison                           */
 /*       Copyright(c) 1999 by SAS Institute Inc., Cary, NC, USA      */
 /*                   SAS Publications order # 55770                  */
 /*                        ISBN 1-58025-352-0                         */
 /*-------------------------------------------------------------------*/
 /*                                                                   */
 /* This material is provided "as is" by SAS Institute Inc.  There    */
 /* are no warranties, expressed or implied, as to merchantability or */
 /* fitness for a particular purpose regarding the materials or code  */
 /* contained herein. The Institute is not responsible for errors     */
 /* in this material as it now exists or will exist, nor does the     */
 /* Institute provide technical support for it.                       */
 /*                                                                   */
 /*-------------------------------------------------------------------*/
 /* Questions or problem reports concerning this material may be      */
 /* addressed to the author:                                          */
 /*                                                                   */
 /* SAS Institute Inc.                                                */
 /* Books by Users                                                    */
 /* Attn: Paul D. Allison                                             */
 /* SAS Campus Drive                                                  */
 /* Cary, NC   27513                                                  */
 /*                                                                   */
 /*                                                                   */
 /* If you prefer, you can send email to:  sasbbu@sas.com             */
 /* Use this for subject field:                                       */
 /*     Comments for Paul D. Allison                                  */
 /*                                                                   */
 /*-------------------------------------------------------------------*/



/*
This file contains programs and data sets from the book, "Logistic 
Regression Using the SAS System: Theory and Application" 
by Paul D. Allison, Ph.D.  The file lists, in order,

-- data sets used in the book
-- macro used in the book
-- programs used in the book

*************************************************************************
*************************************************************************

DATA SETS USED IN THIS BOOK

----------------
PENALTY Data Set
----------------


   Data described in Chapter 2 of P.D. Allison, "Logistic Regression
   Using the SAS System: Theory and Application."                 */

data penalty;
input death blackd whitvic serious culp serious2;
datalines;
0 1 0 7.1 2 3.4
1 0 1 11.5 5 4.66666666
0 0 0 6 2 3
0 0 1 8.4 4 3.2
1 1 0 12.2 5 4.2
0 0 0 7.7 1 3.2
1 1 0 3.66666666 2 2.83333333
1 0 1 12.8 5 4.8
0 1 0 7 1 3.2
0 1 0 7.875 5 2.75
0 1 1 3.7 1 2.4
0 1 1 7.3 1 3.4
0 0 1 9.2 1 3.2
0 1 0 8.6 1 3.8
1 1 0 8 5 3.8
0 1 0 3.58333333 1 2.83333333
0 0 1 10.7 2 4
1 0 1 7.2 5 3
0 1 0 4.8 1 2.2
0 1 0 1.6 1 1.8
1 0 1 6.9 2 3
0 0 1 7.4 3 3.8
0 0 1 6.7 1 3.2
0 1 1 6.8 1 2.6
1 1 0 9.8 1 4.2
0 0 1 9.4 1 3.4
0 0 1 1.4 1 1.4
0 1 0 8.1 1 3.2
0 1 0 1.6 1 1
0 1 0 2.25 1 1
0 0 0 10.9 2 4.4
0 0 0 9.3 2 3.8
1 0 0 6 5 2.5
1 1 1 9.8 2 4
0 0 1 4.6 2 2.6
1 1 1 8.4 5 3.6
0 0 0 8.16666666 1 3.83333333
0 1 1 4.6 1 2.4
0 0 1 5.3 1 2.4
1 1 1 7.8 4 3.8
0 1 1 6.5 1 2.8
1 1 0 6.8 3 3.4
1 1 1 11 5 3.8
1 0 1 11.7 3 3.8
0 1 0 8.8 1 4
0 1 1 6.2 1 2.6
1 0 1 4 4 2.4
0 0 1 10.6 2 5
1 0 0 13.6 5 4.6
0 0 1 5.1 1 2.8
1 0 1 10.9 5 3.6
1 1 1 5.8 2 2.8
0 0 1 4.7 1 3
0 0 1 4.8 1 2.4
0 0 1 4.2 4 2
1 0 1 13.5 4 4.8
0 0 1 3.6 1 1.8
0 0 1 2.6 1 2.6
1 1 0 11.6666666 5 4.66666666
0 1 0 5.1 1 2.2
0 0 0 6.6 1 3
0 0 1 6.4 2 3
0 0 1 8.8 2 3.8
1 0 1 9.7 5 4
1 1 0 6.66666666 2 3.33333333
0 0 1 11.2 1 4
0 0 1 4.5 2 2.4
0 1 0 5.16666666 1 3.16666666
0 0 0 11.9 4 4.4
1 1 0 2 5 1.4
0 1 1 10.0833333 1 4.33333333
1 0 1 5.2 4 3
1 1 0 8.1 4 3.4
0 1 0 5.2 1 3
0 0 1 4.7 1 2.4
0 0 1 7.3 1 3.6
0 1 0 10.4 2 3.8
1 1 0 7.58333333 5 3.83333333
1 1 0 9.9 5 3.6
0 0 1 9.2 1 3.8
0 0 1 10.3 1 4.2
0 0 1 7.4 1 3
0 0 0 8 1 3.2
0 0 1 9.25 1 3.75
0 1 1 9.2 1 3.2
1 0 1 7.58333333 3 3.66666666
0 0 1 11.9 1 4
1 1 0 7.5 4 3
0 1 0 3.6 1 2.2
1 0 1 10 4 3.6
0 0 1 1.875 1 1
0 1 0 10 2 4
0 1 1 8.83333333 1 4.16666666
0 1 0 5.8 1 2.4
0 1 1 7.5 2 3
0 1 0 3 1 1.5
0 1 0 1.8 1 1.4
0 1 0 5.75 1 2.5
1 1 0 8.6 4 4.2
0 0 1 12.25 1 4.25
0 1 1 9.3 1 4
0 0 0 2.7 1 2.2
1 0 1 8.9 4 4
0 0 1 8.9 2 3.8
1 0 1 8.3 3 3.6
0 0 1 11.5 5 4.5
1 1 0 11.2 3 4.6
0 0 1 10 3 3.8
1 0 1 13.8 5 4.4
0 0 1 6.25 1 2.25
0 0 0 13.7 5 5
1 0 1 12.8 5 4.8
0 1 0 8.41666666 1 3.83333333
0 1 1 7.6 1 3.2
0 0 1 13.7 5 5
1 0 1 9.75 4 3.75
0 0 1 6.2 1 2.4
0 1 1 11.9 1 4.4
0 0 1 2.3 1 2.4
0 1 1 5.7 1 2.4
0 0 0 9.5 2 3.6
1 0 0 2.2 2 1.2
1 1 0 12 5 4.2
1 1 1 12 1 4.4
0 0 0 4.16666666 1 3.33333333
0 1 1 9.4 2 4
0 1 0 9.25 2 4.16666666
1 1 1 7.1 1 3.4
0 1 0 11.25 1 4
1 1 1 6 3 2.6
0 0 1 3.6 2 2
0 1 0 5.3 1 2.8
0 1 1 13.6666666 3 4.66666666
0 1 1 4.9 1 2.2
0 0 0 12 2 4.6
0 1 0 11 3 4.6
0 1 1 8.9 1 3.6
1 1 1 13 1 4.4
1 1 0 11.6 1 4.4
1 0 1 13.4 3 4.4
0 1 0 10.5 3 4
1 1 1 13.7 5 4.8
0 0 1 5.3 1 2.2
1 0 1 5.7 5 3
0 0 1 10.6 2 4
1 1 1 3.9 3 2.4
1 1 1 9.3 5 4.4
;

/*
----------------
WALLET Data Set
----------------

 Data described in Chapter 5 of P.D. Allison, "Logistic Regression
 Using the SAS System: Theory and Application."                 */

data wallet;
input wallet male business punish explain;
datalines;
2 0 0 2 0
2 0 0 2 1
3 0 0 1 1
3 0 0 2 0
1 1 0 1 1
3 0 0 1 1
3 0 0 1 1
3 1 0 1 1
3 1 0 1 1
3 0 0 2 1
2 0 1 1 1
3 1 1 1 1
3 1 0 1 1
3 1 0 1 1
3 0 0 1 1
3 0 0 1 0
3 0 0 2 1
2 0 0 3 0
1 1 1 3 0
2 0 0 1 1
2 1 0 2 0
3 0 0 1 1
3 1 0 1 1
3 1 1 1 0
3 1 0 1 1
2 0 0 1 0
2 1 0 3 0
1 1 0 2 0
3 1 0 2 0
3 1 0 1 1
3 0 0 1 1
3 1 0 2 1
1 1 0 1 1
3 0 0 2 0
3 1 0 1 0
3 1 1 2 1
3 0 0 2 0
3 0 0 1 1
3 1 0 1 1
3 0 0 1 1
3 0 0 1 1
3 0 0 1 1
3 0 0 2 0
3 1 1 1 1
3 1 0 1 1
3 0 0 1 1
3 0 0 1 1
3 0 0 1 0
3 0 1 3 0
3 1 0 2 0
2 0 0 2 1
3 0 0 1 1
3 1 0 1 1
3 1 0 1 1
3 1 0 1 0
3 1 1 1 0
3 1 0 1 0
2 1 1 3 1
3 0 0 1 1
3 0 0 3 1
3 0 0 1 1
3 0 0 1 0
3 0 0 1 1
1 0 1 1 1
3 0 0 1 0
3 1 0 1 1
1 1 0 1 0
3 1 0 3 1
2 1 0 3 1
1 1 1 2 1
1 1 0 2 1
3 0 0 1 1
3 0 0 3 0
2 1 0 1 1
2 0 0 1 1
2 1 0 1 1
3 0 0 1 0
3 1 1 1 1
3 1 0 1 1
3 0 0 1 1
3 0 1 1 1
3 0 0 1 1
3 0 0 1 1
3 0 0 2 1
2 1 1 1 0
3 1 0 1 1
3 0 0 1 1
2 1 1 1 1
3 0 0 1 1
3 1 1 1 1
3 0 0 1 1
3 0 0 1 1
3 0 0 1 1
3 0 1 1 1
3 0 0 2 1
1 1 1 1 1
1 1 0 2 0
2 1 0 1 1
1 1 1 1 1
2 1 0 1 1
1 1 1 3 0
2 1 1 1 1
1 1 1 3 1
3 0 0 3 1
3 0 0 1 1
2 0 0 1 1
3 0 0 1 1
1 0 1 3 0
3 0 0 1 1
2 0 0 1 0
3 0 0 1 1
3 0 0 1 1
2 1 0 1 1
3 1 0 1 1
3 0 0 1 1
1 1 0 3 0
2 1 0 1 1
2 0 1 1 1
1 0 0 3 0
1 0 1 2 0
3 0 0 1 1
3 0 0 1 1
3 0 0 1 1
3 1 1 1 1
3 0 0 1 0
3 0 0 1 1
3 1 0 1 1
3 1 1 1 1
3 1 0 1 1
2 1 1 1 1
2 0 0 1 0
3 0 0 1 1
2 1 1 2 0
3 1 0 1 0
2 1 0 1 0
3 0 0 2 1
3 1 1 1 1
1 0 0 3 0
3 0 0 1 1
3 1 1 1 1
3 0 0 1 0
3 0 1 1 0
2 0 0 1 1
3 1 0 1 1
2 1 0 1 0
3 0 0 1 0
2 1 0 1 1
3 1 0 1 1
3 1 0 2 0
3 1 1 2 1
3 1 0 1 1
2 1 0 1 0
3 0 0 1 1
3 1 0 1 1
2 1 1 1 0
3 0 0 1 1
3 1 0 1 1
2 1 0 1 0
3 0 1 2 1
2 1 1 2 1
3 0 0 1 1
1 1 0 1 1
3 1 1 3 1
2 1 0 1 1
1 0 0 1 0
2 1 0 3 0
3 0 0 1 1
2 1 1 1 1
3 0 0 1 1
2 0 0 2 0
2 1 0 1 1
1 1 1 2 0
2 1 0 2 0
2 0 0 1 1
1 0 1 3 0
2 1 0 1 1
2 1 0 1 1
3 1 0 1 1
3 0 0 1 1
2 1 0 1 1
1 1 0 2 0
2 0 1 2 1
3 0 0 2 0
2 1 1 1 1
3 0 1 2 1
1 0 0 3 0
2 1 1 1 0
3 0 0 3 1
2 1 0 2 1
3 0 0 1 1
3 1 0 3 1
3 0 0 1 1
3 1 1 1 1
3 1 0 1 1
2 1 0 1 1
;

/*
----------------
TRAVEL Data Set
----------------

 Data described in Chapter 7 of P.D. Allison, "Logistic Regression
 Using the SAS System: Theory and Application."                 */

data travel;
input id mode choice ttme cost time hinc psize;
datalines;
1 1 0 69 59 100 35 1
1 2 0 34 31 372 35 1
1 3 0 35 25 417 35 1
1 4 1 0 10 180 35 1
2 1 0 64 58 68 30 2
2 2 0 44 31 354 30 2
2 3 0 53 25 399 30 2
2 4 1 0 11 255 30 2
3 1 0 69 115 125 40 1
3 2 0 34 98 892 40 1
3 3 0 35 53 882 40 1
3 4 1 0 23 720 40 1
4 1 0 64 49 68 70 3
4 2 0 44 26 354 70 3
4 3 0 53 21 399 70 3
4 4 1 0 5 180 70 3
5 1 0 64 60 144 45 2
5 2 0 44 32 404 45 2
5 3 0 53 26 449 45 2
5 4 1 0 8 600 45 2
6 1 0 69 59 100 20 1
6 2 1 40 20 345 20 1
6 3 0 35 13 417 20 1
6 4 0 0 12 284 20 1
7 1 1 45 148 115 45 1
7 2 0 34 111 945 45 1
7 3 0 35 66 935 45 1
7 4 0 0 36 821 45 1
8 1 0 69 121 152 12 1
8 2 0 34 52 889 12 1
8 3 0 35 50 879 12 1
8 4 1 0 50 780 12 1
9 1 0 69 59 100 40 1
9 2 0 34 31 372 40 1
9 3 0 35 25 417 40 1
9 4 1 0 17 210 40 1
10 1 0 69 58 68 70 2
10 2 0 34 31 357 70 2
10 3 0 35 25 402 70 2
10 4 1 0 7 210 70 2
11 1 0 64 58 68 15 2
11 2 0 44 16 357 15 2
11 3 0 53 13 402 15 2
11 4 1 0 4 210 15 2
12 1 0 64 62 108 35 2
12 2 0 44 34 370 35 2
12 3 0 53 28 415 35 2
12 4 1 0 6 250 35 2
13 1 0 64 45 114 50 4
13 2 0 44 24 378 50 4
13 3 0 53 19 423 50 4
13 4 1 0 5 240 50 4
14 1 0 64 58 94 40 1
14 2 0 44 31 360 40 1
14 3 0 53 25 405 40 1
14 4 1 0 15 285 40 1
15 1 0 64 83 169 26 4
15 2 0 44 70 948 26 4
15 3 0 53 47 938 26 4
15 4 1 0 17 1200 26 4
16 1 0 69 60 127 26 1
16 2 1 20 19 325 26 1
16 3 0 35 25 435 26 1
16 4 0 0 14 350 26 1
17 1 0 69 61 74 26 1
17 2 1 15 38 255 26 1
17 3 0 35 26 389 26 1
17 4 0 0 13 315 26 1
18 1 0 69 67 86 6 1
18 2 1 20 21 300 6 1
18 3 0 35 19 399 6 1
18 4 0 0 17 327 6 1
19 1 0 69 59 148 20 1
19 2 1 45 18 305 20 1
19 3 0 35 14 456 20 1
19 4 0 0 16 427 20 1
20 1 0 64 58 93 72 2
20 2 1 10 28 305 72 2
20 3 0 53 25 346 72 2
20 4 0 0 9 316 72 2
21 1 0 69 61 73 6 1
21 2 1 20 21 305 6 1
21 3 0 35 15 395 6 1
21 4 0 0 13 314 6 1
22 1 0 64 62 235 10 2
22 2 1 45 45 465 10 2
22 3 0 53 17 623 10 2
22 4 0 0 13 559 10 2
23 1 1 90 142 105 50 1
23 2 0 34 71 596 50 1
23 3 0 35 32 590 50 1
23 4 0 0 33 577 50 1
24 1 1 50 120 110 50 1
24 2 0 34 70 596 50 1
24 3 0 35 31 590 50 1
24 4 0 0 33 577 50 1
25 1 1 15 85 65 18 2
25 2 0 34 15 361 18 2
25 3 0 35 12 406 18 2
25 4 0 0 9 296 18 2
26 1 1 30 85 140 60 1
26 2 0 44 90 928 60 1
26 3 0 53 45 918 60 1
26 4 0 0 86 902 60 1
27 1 1 80 75 110 45 1
27 2 0 34 70 638 45 1
27 3 0 35 31 632 45 1
27 4 0 0 39 581 45 1
28 1 1 45 85 140 18 2
28 2 0 44 39 664 18 2
28 3 0 53 35 658 18 2
28 4 0 0 19 592 18 2
29 1 0 64 74 179 8 2
29 2 1 60 43 320 8 2
29 3 0 53 21 345 8 2
29 4 0 0 9 321 8 2
30 1 0 69 59 100 6 1
30 2 1 2 11 285 6 1
30 3 0 35 13 417 6 1
30 4 0 0 13 284 6 1
31 1 0 69 59 101 20 1
31 2 1 5 17 300 20 1
31 3 0 35 25 420 20 1
31 4 0 0 13 297 20 1
32 1 0 69 64 90 45 1
32 2 1 15 32 325 45 1
32 3 0 35 29 405 45 1
32 4 0 0 18 327 45 1
33 1 0 64 59 73 70 2
33 2 1 45 29 290 70 2
33 3 0 53 26 395 70 2
33 4 0 0 9 314 70 2
34 1 0 69 62 66 4 1
34 2 1 10 31 295 4 1
34 3 0 35 19 397 4 1
34 4 0 0 17 307 4 1
35 1 0 69 60 132 40 1
35 2 1 15 15 330 40 1
35 3 0 35 26 373 40 1
35 4 0 0 12 309 40 1
36 1 0 69 60 117 35 1
36 2 1 10 23 325 35 1
36 3 0 35 25 425 35 1
36 4 0 0 17 307 35 1
37 1 0 64 62 184 40 2
37 2 1 45 24 360 40 2
37 3 0 53 28 464 40 2
37 4 0 0 11 427 40 2
38 1 0 64 50 67 4 3
38 2 1 30 31 265 4 3
38 3 0 53 14 393 4 3
38 4 0 0 6 308 4 3
39 1 0 64 48 154 15 4
39 2 1 55 25 360 15 4
39 3 0 53 14 462 15 4
39 4 0 0 4 351 15 4
40 1 1 30 147 100 26 1
40 2 0 34 96 678 26 1
40 3 0 35 57 672 26 1
40 4 0 0 28 629 26 1
41 1 1 75 125 110 26 1
41 2 0 34 70 596 26 1
41 3 0 35 31 590 26 1
41 4 0 0 24 577 26 1
42 1 1 40 152 95 70 1
42 2 0 34 73 600 70 1
42 3 0 35 34 594 70 1
42 4 0 0 24 587 70 1
43 1 1 30 116 180 70 1
43 2 0 34 71 657 70 1
43 3 0 35 32 651 70 1
43 4 0 0 29 629 70 1
44 1 1 40 100 105 45 2
44 2 0 44 70 622 45 2
44 3 0 53 31 616 45 2
44 4 0 0 17 577 45 2
45 1 1 45 105 115 8 2
45 2 0 44 35 622 8 2
45 3 0 53 31 616 8 2
45 4 0 0 12 577 8 2
46 1 1 20 106 190 70 1
46 2 0 34 72 659 70 1
46 3 0 35 33 653 70 1
46 4 0 0 44 592 70 1
47 1 1 60 90 100 26 2
47 2 0 44 69 596 26 2
47 3 0 53 30 590 26 2
47 4 0 0 13 577 26 2
48 1 1 40 48 115 50 1
48 2 0 34 31 365 50 1
48 3 0 35 25 410 50 1
48 4 0 0 16 308 50 1
49 1 1 50 69 85 10 3
49 2 0 44 16 344 10 3
49 3 0 53 13 389 10 3
49 4 0 0 4 315 10 3
50 1 1 75 99 135 30 1
50 2 0 34 96 678 30 1
50 3 0 35 57 672 30 1
50 4 0 0 29 629 30 1
51 1 1 90 64 155 60 2
51 2 0 44 74 678 60 2
51 3 0 53 35 672 60 2
51 4 0 0 20 629 60 2
52 1 1 85 105 85 30 4
52 2 0 44 56 665 30 4
52 3 0 53 35 659 30 4
52 4 0 0 8 587 30 4
53 1 0 69 60 123 30 1
53 2 1 15 24 365 30 1
53 3 0 35 25 430 30 1
53 4 0 0 13 332 30 1
54 1 0 64 58 90 50 2
54 2 1 30 22 340 50 2
54 3 0 53 25 417 50 2
54 4 0 0 9 334 50 2
55 1 0 64 45 73 6 4
55 2 1 15 22 290 6 4
55 3 0 53 13 395 6 4
55 4 0 0 5 314 6 4
56 1 0 69 108 170 30 1
56 2 1 30 31 875 30 1
56 3 0 35 44 887 30 1
56 4 0 0 50 884 30 1
57 1 0 69 110 249 12 1
57 2 1 45 22 890 12 1
57 3 0 35 47 955 12 1
57 4 0 0 38 990 12 1
58 1 0 64 115 138 36 2
58 2 1 10 44 830 36 2
58 3 0 53 50 869 36 2
58 4 0 0 18 862 36 2
59 1 0 69 117 147 30 1
59 2 1 40 59 790 30 1
59 3 0 35 48 885 30 1
59 4 0 0 38 883 30 1
60 1 0 64 88 119 35 3
60 2 1 50 78 775 35 3
60 3 0 53 43 840 35 3
60 4 0 0 16 855 35 3
61 1 0 69 105 196 6 1
61 2 1 40 43 895 6 1
61 3 0 35 44 919 6 1
61 4 0 0 50 935 6 1
62 1 0 64 120 333 6 1
62 2 1 25 28 870 6 1
62 3 0 53 52 890 6 1
62 4 0 0 38 921 6 1
63 1 0 64 103 146 8 2
63 2 1 25 36 875 8 2
63 3 0 53 43 943 8 2
63 4 0 0 19 887 8 2
64 1 0 69 103 138 6 1
64 2 1 5 22 800 6 1
64 3 0 35 43 821 6 1
64 4 0 0 36 846 6 1
65 1 0 64 116 164 12 2
65 2 1 75 89 685 12 2
65 3 0 53 47 875 12 2
65 4 0 0 19 874 12 2
66 1 0 69 103 129 30 1
66 2 0 34 88 925 30 1
66 3 1 10 30 790 30 1
66 4 0 0 50 887 30 1
67 1 0 64 109 230 35 2
67 2 0 44 101 1104 35 2
67 3 0 53 56 1094 35 2
67 4 1 0 26 960 35 2
68 1 0 69 108 177 35 1
68 2 0 34 92 907 35 1
68 3 1 45 39 850 35 1
68 4 0 0 52 865 35 1
69 1 0 64 92 161 60 3
69 2 1 40 73 792 60 3
69 3 0 53 46 920 60 3
69 4 0 0 16 887 60 3
70 1 0 64 119 161 60 2
70 2 1 45 75 765 60 2
70 3 0 53 51 869 60 2
70 4 0 0 19 898 60 2
71 1 0 64 109 190 12 2
71 2 1 40 24 399 12 2
71 3 0 53 46 951 12 2
71 4 0 0 27 897 12 2
72 1 0 69 111 108 10 1
72 2 1 30 30 760 10 1
72 3 0 35 50 867 10 1
72 4 0 0 47 844 10 1
73 1 0 69 104 246 10 1
73 2 1 25 23 830 10 1
73 3 0 35 45 1068 10 1
73 4 0 0 41 978 10 1
74 1 0 69 104 200 15 1
74 2 1 75 23 835 15 1
74 3 0 35 43 846 15 1
74 4 0 0 40 927 15 1
75 1 0 64 124 160 10 2
75 2 1 30 82 850 10 2
75 3 0 53 54 893 10 2
75 4 0 0 19 886 10 2
76 1 0 64 103 145 8 1
76 2 1 50 73 840 8 1
76 3 0 53 43 892 8 1
76 4 0 0 50 894 8 1
77 1 0 69 103 125 30 1
77 2 1 30 80 800 30 1
77 3 0 35 42 844 30 1
77 4 0 0 38 861 30 1
78 1 0 64 113 163 20 2
78 2 0 44 51 948 20 2
78 3 0 53 49 938 20 2
78 4 1 0 26 720 20 2
79 1 0 64 76 147 70 5
79 2 0 44 63 918 70 5
79 3 0 53 44 908 70 5
79 4 1 0 10 1440 70 5
80 1 0 69 108 163 20 1
80 2 0 34 89 905 20 1
80 3 1 30 43 785 20 1
80 4 0 0 35 879 20 1
81 1 0 69 127 193 60 1
81 2 0 34 109 888 60 1
81 3 1 60 52 1025 60 1
81 4 0 0 50 892 60 1
82 1 0 64 44 100 70 4
82 2 0 44 25 351 70 4
82 3 0 53 20 361 70 4
82 4 1 0 5 180 70 4
83 1 0 69 59 98 8 1
83 2 1 1 11 320 8 1
83 3 0 35 13 413 8 1
83 4 0 0 17 332 8 1
84 1 0 69 59 114 30 1
84 2 1 25 60 337 30 1
84 3 0 35 25 423 30 1
84 4 0 0 8 335 30 1
85 1 1 25 65 140 70 2
85 2 0 44 69 596 70 2
85 3 0 53 30 590 70 2
85 4 0 0 16 577 70 2
86 1 0 69 60 67 60 1
86 2 1 10 37 285 60 1
86 3 0 35 28 400 60 1
86 4 0 0 14 320 60 1
87 1 0 64 59 118 20 2
87 2 0 44 17 349 20 2
87 3 0 53 14 359 20 2
87 4 1 0 5 240 20 2
88 1 0 69 61 72 15 1
88 2 1 10 18 305 15 1
88 3 0 35 27 396 15 1
88 4 0 0 12 332 15 1
89 1 0 64 59 118 30 2
89 2 0 44 32 349 30 2
89 3 0 53 26 359 30 2
89 4 1 0 6 265 30 2
90 1 0 64 60 74 26 2
90 2 1 20 40 262 26 2
90 3 0 53 26 389 26 2
90 4 0 0 10 315 26 2
91 1 0 64 44 93 35 4
91 2 1 20 30 291 35 4
91 3 0 53 19 346 35 4
91 4 0 0 4 316 35 4
92 1 0 69 58 124 12 1
92 2 1 10 30 340 12 1
92 3 0 35 25 427 12 1
92 4 0 0 14 364 12 1
93 1 0 64 84 108 70 2
93 2 0 44 70 596 70 2
93 3 0 53 31 590 70 2
93 4 1 0 15 360 70 2
94 1 1 30 145 90 50 1
94 2 0 44 31 343 50 1
94 3 0 53 25 388 50 1
94 4 0 0 13 296 50 1
95 1 1 45 121 100 40 2
95 2 0 44 92 926 40 2
95 3 0 53 47 916 40 2
95 4 0 0 20 885 40 2
96 1 1 30 84 180 70 1
96 2 0 34 72 707 70 1
96 3 0 35 33 701 70 1
96 4 0 0 26 626 70 1
97 1 0 69 61 146 10 1
97 2 0 34 17 409 10 1
97 3 1 5 31 300 10 1
97 4 0 0 13 350 10 1
98 1 1 45 180 160 26 1
98 2 0 34 89 985 26 1
98 3 0 35 44 975 26 1
98 4 0 0 39 896 26 1
99 1 0 64 94 231 50 3
99 2 0 44 79 949 50 3
99 3 1 40 32 1110 50 3
99 4 0 0 13 942 50 3
100 1 0 64 92 203 70 3
100 2 0 44 77 961 70 3
100 3 0 53 46 951 70 3
100 4 1 0 17 780 70 3
101 1 0 69 59 111 30 1
101 2 0 34 31 376 30 1
101 3 1 15 25 360 30 1
101 4 0 0 23 351 30 1
102 1 0 64 75 153 50 5
102 2 0 44 64 900 50 5
102 3 0 53 45 890 50 5
102 4 1 0 13 720 50 5
103 1 0 69 58 99 20 1
103 2 0 34 16 366 20 1
103 3 0 35 13 411 20 1
103 4 1 0 13 300 20 1
104 1 0 64 110 153 32 2
104 2 0 44 91 874 32 2
104 3 0 53 46 864 32 2
104 4 1 0 21 960 32 2
105 1 0 64 108 187 27 2
105 2 0 44 90 932 27 2
105 3 0 53 45 922 27 2
105 4 1 0 20 1440 27 2
106 1 0 69 104 179 30 1
106 2 0 34 89 978 30 1
106 3 1 30 28 795 30 1
106 4 0 0 40 904 30 1
107 1 0 69 108 180 35 1
107 2 0 34 89 901 35 1
107 3 0 35 44 891 35 1
107 4 1 0 34 720 35 1
108 1 0 64 78 146 40 4
108 2 0 44 66 903 40 4
108 3 0 53 43 893 40 4
108 4 1 0 11 870 40 4
109 1 0 64 60 144 60 2
109 2 0 44 32 404 60 2
109 3 0 53 26 449 60 2
109 4 1 0 8 270 60 2
110 1 0 64 78 175 40 4
110 2 0 44 67 932 40 4
110 3 0 53 44 922 40 4
110 4 1 0 12 720 40 4
111 1 0 69 67 108 70 1
111 2 0 34 38 370 70 1
111 3 0 35 32 415 70 1
111 4 1 0 12 240 70 1
112 1 0 64 108 200 70 2
112 2 0 44 90 944 70 2
112 3 0 53 45 934 70 2
112 4 1 0 19 720 70 2
113 1 1 60 108 80 30 2
113 2 0 44 32 344 30 2
113 3 0 53 26 389 30 2
113 4 0 0 7 315 30 2
114 1 1 30 58 90 35 2
114 2 0 44 32 506 35 2
114 3 0 53 26 551 35 2
114 4 0 0 8 402 35 2
115 1 1 55 69 115 60 1
115 2 0 34 43 392 60 1
115 3 0 35 37 437 60 1
115 4 0 0 13 268 60 1
116 1 1 40 66 105 45 1
116 2 0 34 31 372 45 1
116 3 0 35 25 417 45 1
116 4 0 0 18 327 45 1
117 1 0 69 57 67 45 1
117 2 0 34 31 355 45 1
117 3 1 40 18 245 45 1
117 4 0 0 13 320 45 1
118 1 0 69 129 185 6 1
118 2 0 34 67 933 6 1
118 3 1 20 54 820 6 1
118 4 0 0 38 894 6 1
119 1 1 90 151 95 36 1
119 2 0 34 96 895 36 1
119 3 0 35 51 885 36 1
119 4 0 0 35 844 36 1
120 1 1 10 70 85 20 1
120 2 0 34 34 351 20 1
120 3 0 35 28 396 20 1
120 4 0 0 22 307 20 1
121 1 1 25 75 100 20 2
121 2 0 44 15 348 20 2
121 3 0 53 12 393 20 2
121 4 0 0 7 290 20 2
122 1 1 99 110 260 26 1
122 2 0 34 92 934 26 1
122 3 0 35 47 924 26 1
122 4 0 0 45 816 26 1
123 1 1 30 94 195 29 1
123 2 0 34 89 943 29 1
123 3 0 35 44 933 29 1
123 4 0 0 58 912 29 1
124 1 1 35 95 155 8 2
124 2 0 44 45 930 8 2
124 3 0 53 43 920 8 2
124 4 0 0 23 860 8 2
125 1 0 69 104 178 32 1
125 2 0 34 89 992 32 1
125 3 1 15 38 675 32 1
125 4 0 0 39 900 32 1
126 1 0 64 103 170 45 2
126 2 0 44 88 889 45 2
126 3 1 30 35 770 45 2
126 4 0 0 18 905 45 2
127 1 0 64 86 167 45 3
127 2 0 44 75 972 45 3
127 3 0 53 44 962 45 3
127 4 1 0 13 870 45 3
128 1 0 64 108 139 26 2
128 2 0 44 90 862 26 2
128 3 1 30 36 780 26 2
128 4 0 0 18 875 26 2
129 1 0 69 59 106 60 1
129 2 0 34 31 372 60 1
129 3 0 35 25 417 60 1
129 4 1 0 13 300 60 1
130 1 0 64 58 124 10 2
130 2 1 10 35 380 10 2
130 3 0 53 13 427 10 2
130 4 0 0 8 364 10 2
131 1 0 64 107 153 45 2
131 2 0 44 89 880 45 2
131 3 0 53 44 870 45 2
131 4 1 0 2 660 45 2
132 1 0 64 86 143 60 3
132 2 0 44 74 880 60 3
132 3 0 53 43 870 60 3
132 4 1 0 16 660 60 3
133 1 0 69 108 196 60 1
133 2 0 34 91 967 60 1
133 3 1 15 35 935 60 1
133 4 0 0 38 903 60 1
134 1 0 69 103 149 8 1
134 2 0 34 45 892 8 1
134 3 1 25 25 730 8 1
134 4 0 0 37 882 8 1
135 1 0 64 103 160 60 2
135 2 0 44 89 987 60 2
135 3 0 53 44 977 60 2
135 4 1 0 34 660 60 2
136 1 0 64 114 161 12 2
136 2 0 44 60 1031 12 2
136 3 0 53 58 1021 12 2
136 4 1 0 19 720 12 2
137 1 0 69 107 150 45 1
137 2 0 34 91 914 45 1
137 3 0 35 46 904 45 1
137 4 1 0 36 750 45 1
138 1 0 69 118 137 50 1
138 2 0 34 96 904 50 1
138 3 1 5 65 850 50 1
138 4 0 0 64 859 50 1
139 1 0 69 102 101 26 1
139 2 0 34 87 870 26 1
139 3 1 45 35 800 26 1
139 4 0 0 35 825 26 1
140 1 0 64 85 101 35 3
140 2 0 44 73 870 35 3
140 3 0 53 42 860 35 3
140 4 1 0 12 600 35 3
141 1 0 69 107 158 12 1
141 2 1 30 61 780 12 1
141 3 0 35 45 901 12 1
141 4 0 0 54 853 12 1
142 1 0 69 113 244 15 1
142 2 1 30 67 845 15 1
142 3 0 35 49 893 15 1
142 4 0 0 47 868 15 1
143 1 0 64 84 215 12 4
143 2 1 99 37 885 12 4
143 3 0 53 46 966 12 4
143 4 0 0 10 921 12 4
144 1 0 64 94 163 35 3
144 2 1 25 68 755 35 3
144 3 0 53 47 895 35 3
144 4 0 0 16 879 35 3
145 1 0 69 112 161 26 1
145 2 1 15 21 797 26 1
145 3 0 35 45 876 26 1
145 4 0 0 47 852 26 1
146 1 0 69 103 166 6 1
146 2 1 45 20 820 6 1
146 3 0 35 43 836 6 1
146 4 0 0 35 886 6 1
147 1 0 69 107 152 4 1
147 2 1 30 33 755 4 1
147 3 0 35 44 882 4 1
147 4 0 0 48 845 4 1
148 1 0 64 103 164 40 2
148 2 1 10 41 730 40 2
148 3 0 53 43 925 40 2
148 4 0 0 19 898 40 2
149 1 0 64 143 166 40 1
149 2 1 10 83 825 40 1
149 3 0 53 70 896 40 1
149 4 0 0 50 911 40 1
150 1 1 45 94 270 60 1
150 2 0 34 91 916 60 1
150 3 0 35 46 906 60 1
150 4 0 0 49 872 60 1
151 1 1 45 138 115 4 1
151 2 0 34 60 880 4 1
151 3 0 35 58 870 4 1
151 4 0 0 47 888 4 1
152 1 1 60 102 250 50 1
152 2 0 34 112 997 50 1
152 3 0 35 67 952 50 1
152 4 0 0 43 971 50 1
153 1 1 60 151 255 60 2
153 2 0 44 91 941 60 2
153 3 0 53 46 931 60 2
153 4 0 0 21 959 60 2
154 1 1 60 111 205 70 1
154 2 0 34 97 888 70 1
154 3 0 35 52 878 70 1
154 4 0 0 49 855 70 1
155 1 1 60 70 95 40 2
155 2 0 44 31 360 40 2
155 3 0 53 25 405 40 2
155 4 0 0 7 335 40 2
156 1 1 45 74 70 35 3
156 2 0 44 26 361 35 3
156 3 0 53 21 406 35 3
156 4 0 0 4 315 35 3
157 1 1 75 165 180 60 2
157 2 0 44 98 967 60 2
157 3 0 53 53 922 60 2
157 4 0 0 26 947 60 2
158 1 1 30 93 175 60 1
158 2 0 34 96 1030 60 1
158 3 0 35 51 1020 60 1
158 4 0 0 54 967 60 1
159 1 1 90 71 115 50 2
159 2 0 44 31 385 50 2
159 3 0 53 25 430 50 2
159 4 0 0 7 332 50 2
160 1 1 45 75 75 40 3
160 2 0 44 33 418 40 3
160 3 0 53 28 463 40 3
160 4 0 0 5 291 40 3
161 1 1 60 81 70 60 1
161 2 0 34 32 341 60 1
161 3 0 35 26 386 60 1
161 4 0 0 13 307 60 1
162 1 1 75 94 95 20 1
162 2 0 34 33 367 20 1
162 3 0 35 27 412 20 1
162 4 0 0 14 314 20 1
163 1 0 64 70 158 50 3
163 2 0 44 61 778 50 3
163 3 0 53 34 772 50 3
163 4 1 0 11 470 50 3
164 1 0 64 65 145 70 4
164 2 0 44 54 674 70 4
164 3 0 53 33 668 70 4
164 4 1 0 8 560 70 4
165 1 0 64 71 133 50 3
165 2 0 44 59 625 50 3
165 3 0 53 32 619 50 3
165 4 1 0 8 510 50 3
166 1 0 69 81 139 26 1
166 2 0 34 71 698 26 1
166 3 0 35 32 692 26 1
166 4 1 0 33 600 26 1
167 1 0 64 65 154 45 4
167 2 0 44 53 621 45 4
167 3 0 53 32 615 45 4
167 4 1 0 9 535 45 4
168 1 0 64 58 148 45 6
168 2 0 44 48 646 45 6
168 3 0 53 32 640 45 6
168 4 1 0 5 470 45 6
169 1 0 69 81 95 30 1
169 2 0 34 70 610 30 1
169 3 0 35 31 604 30 1
169 4 1 0 30 440 30 1
170 1 0 64 71 145 40 3
170 2 0 44 59 658 40 3
170 3 0 53 32 652 40 3
170 4 1 0 10 590 40 3
171 1 0 64 82 159 50 2
171 2 0 44 71 765 50 2
171 3 0 53 32 759 50 2
171 4 1 0 13 490 50 2
172 1 0 69 61 73 35 1
172 2 0 34 33 350 35 1
172 3 1 50 26 227 35 1
172 4 0 0 14 314 35 1
173 1 0 69 60 133 34 1
173 2 0 34 31 397 34 1
173 3 1 15 21 240 34 1
173 4 0 0 14 351 34 1
174 1 0 64 81 129 8 2
174 2 0 44 35 677 8 2
174 3 1 15 31 565 8 2
174 4 0 0 12 588 8 2
175 1 0 69 59 117 30 1
175 2 0 34 32 397 30 1
175 3 0 35 26 442 30 1
175 4 1 0 17 180 30 1
176 1 0 69 111 276 32 1
176 2 0 34 93 1047 32 1
176 3 1 30 35 860 32 1
176 4 0 0 42 1008 32 1
177 1 0 69 59 88 26 1
177 2 0 34 30 361 26 1
177 3 1 15 21 295 26 1
177 4 0 0 13 299 26 1
178 1 0 69 59 114 42 1
178 2 0 34 31 389 42 1
178 3 1 15 21 243 42 1
178 4 0 0 13 334 42 1
179 1 1 90 55 115 50 1
179 2 0 44 72 602 50 1
179 3 0 53 33 596 50 1
179 4 0 0 24 589 50 1
180 1 1 15 87 110 70 2
180 2 0 44 31 348 70 2
180 3 0 53 25 393 70 2
180 4 0 0 7 320 70 2
181 1 0 69 62 76 30 1
181 2 0 34 39 377 30 1
181 3 0 35 33 422 30 1
181 4 1 0 12 300 30 1
182 1 0 69 59 121 26 1
182 2 0 34 31 386 26 1
182 3 0 35 25 431 26 1
182 4 1 0 14 270 26 1
183 1 0 64 51 90 26 3
183 2 1 20 61 350 26 3
183 3 0 53 22 405 26 3
183 4 0 0 6 327 26 3
184 1 0 64 64 215 18 2
184 2 1 50 41 420 18 2
184 3 0 53 15 385 18 2
184 4 0 0 9 321 18 2
185 1 0 64 58 74 35 2
185 2 1 30 21 295 35 2
185 3 0 53 24 389 35 2
185 4 0 0 7 315 35 2
186 1 0 64 71 119 50 3
186 2 0 44 58 617 50 3
186 3 1 15 35 615 50 3
186 4 0 0 11 586 50 3
187 1 1 15 50 75 4 1
187 2 0 34 15 361 4 1
187 3 0 35 12 406 4 1
187 4 0 0 13 315 4 1
188 1 1 10 61 80 30 4
188 2 0 44 24 350 30 4
188 3 0 53 19 395 30 4
188 4 0 0 4 314 30 4
189 1 0 69 59 100 45 1
189 2 0 34 31 372 45 1
189 3 0 35 25 417 45 1
189 4 1 0 13 210 45 1
190 1 0 69 58 73 60 1
190 2 0 34 31 324 60 1
190 3 0 35 25 334 60 1
190 4 1 0 18 240 60 1
191 1 0 69 62 184 4 1
191 2 0 34 19 454 4 1
191 3 0 35 16 464 4 1
191 4 1 0 18 225 4 1
192 1 1 30 93 85 30 1
192 2 0 34 33 365 30 1
192 3 0 35 27 410 30 1
192 4 0 0 13 308 30 1
193 1 1 20 76 95 60 1
193 2 0 34 33 344 60 1
193 3 0 35 27 389 60 1
193 4 0 0 13 315 60 1
194 1 0 64 100 190 4 2
194 2 0 44 49 678 4 2
194 3 1 30 48 430 4 2
194 4 0 0 14 629 4 2
195 1 0 64 48 63 18 3
195 2 1 10 21 255 18 3
195 3 0 53 13 397 18 3
195 4 0 0 4 324 18 3
196 1 0 64 58 93 15 2
196 2 1 10 30 315 15 2
196 3 0 53 13 346 15 2
196 4 0 0 6 316 15 2
197 1 0 69 59 94 26 1
197 2 0 34 30 361 26 1
197 3 0 35 24 406 26 1
197 4 1 0 10 270 26 1
198 1 1 30 111 105 40 1
198 2 0 34 71 596 40 1
198 3 0 35 32 590 40 1
198 4 0 0 27 577 40 1
199 1 1 5 64 80 70 2
199 2 0 44 30 348 70 2
199 3 0 53 24 393 70 2
199 4 0 0 7 291 70 2
200 1 1 5 60 85 45 4
200 2 0 44 24 379 45 4
200 3 0 53 19 424 45 4
200 4 0 0 3 337 45 4
201 1 0 64 97 188 26 3
201 2 0 44 76 825 26 3
201 3 1 16 38 810 26 3
201 4 0 0 15 803 26 3
202 1 0 69 91 117 35 1
202 2 0 34 77 630 35 1
202 3 0 35 38 624 35 1
202 4 1 0 29 540 35 1
203 1 0 69 59 114 4 1
203 2 0 34 16 378 4 1
203 3 1 5 14 370 4 1
203 4 0 0 17 335 4 1
204 1 0 69 60 66 20 1
204 2 0 34 34 352 20 1
204 3 1 10 37 250 20 1
204 4 0 0 13 307 20 1
205 1 0 69 107 144 45 1
205 2 0 34 89 879 45 1
205 3 1 30 35 775 45 1
205 4 0 0 37 868 45 1
206 1 0 69 81 124 40 1
206 2 0 34 69 605 40 1
206 3 0 35 30 599 40 1
206 4 1 0 30 720 40 1
207 1 1 45 126 135 40 1
207 2 0 34 70 596 40 1
207 3 0 35 31 590 40 1
207 4 0 0 32 577 40 1
208 1 0 69 59 86 2 1
208 2 0 34 15 360 2 1
208 3 1 50 29 265 2 1
208 4 0 0 13 300 2 1
209 1 0 69 81 124 20 1
209 2 0 34 35 605 20 1
209 3 0 35 31 599 20 1
209 4 1 0 27 510 20 1
210 1 0 64 66 140 70 4
210 2 0 44 54 670 70 4
210 3 0 53 33 664 70 4
210 4 1 0 12 540 70 4
;

/*
-----------------
JUDGERNK Data Set
-----------------

 Data described in Chapter 7 of P.D. Allison, "Logistic Regression
 Using the SAS System: Theory and Application."                 */

data judgernk;
input judgid rank blackd whitvic death culp case;
datalines;
11 1 1 1 0 3 4163
11 2 0 1 1 3 2172
11 3 1 1 0 1 1880
11 4 1 0 1 5 2015
11 5 0 0 0 1 1060
11 6 1 1 0 1 2375
11 7 1 0 1 2 1720
11 8 1 0 1 5 1598
11 9 1 0 1 2 197
11 10 0 1 1 5 119
11 11 1 0 0 1 3035
11 12 1 0 0 2 4142
11 13 0 0 0 1 4128
11 14 1 0 0 1 1791
11 15 1 0 0 1 463
12 1 0 1 1 5 119
12 2 1 0 0 2 4142
12 3 1 0 1 5 1598
12 4 0 0 0 1 1060
12 5 1 0 1 2 1720
12 6 1 1 0 1 1880
12 7 1 1 0 3 4163
12 8 1 0 0 1 3035
12 9 1 0 1 5 2015
12 10 0 0 0 1 4128
12 11 1 1 0 1 2375
12 12 1 0 0 1 1791
12 13 0 1 1 3 2172
12 14 1 0 1 2 197
12 15 1 0 0 1 463
13 1 1 1 0 3 4163
13 2 0 1 1 5 119
13 3 1 1 0 1 1880
13 4 0 1 1 3 2172
13 5 1 0 0 2 4142
13 6 1 1 0 1 2375
13 7 1 0 1 5 1598
13 8 1 0 1 5 2015
13 9 1 0 1 2 1720
13 10 1 0 0 1 1791
13 11 0 0 0 1 1060
13 12 1 0 0 1 3035
13 13 0 0 0 1 4128
13 14 1 0 1 2 197
13 15 1 0 0 1 463
14 2 0 1 1 5 119
14 2 1 0 1 5 1598
14 2 1 1 0 3 4163
14 4 1 1 0 1 1880
14 5.5 1 0 0 1 3035
14 5.5 1 0 0 2 4142
14 7.5 1 0 0 1 463
14 7.5 1 0 1 5 2015
14 9 0 0 0 1 1060
14 10 0 0 0 1 4128
14 11 0 1 1 3 2172
14 12 1 0 1 2 197
14 13 1 1 0 1 2375
14 14 1 0 0 1 1791
14 15 1 0 1 2 1720
15 1 1 0 0 1 3035
15 2 1 1 0 3 4163
15 3 1 0 1 5 1598
15 4 0 0 0 1 1060
15 5 1 1 0 1 2375
15 6 1 0 0 1 1791
15 7 0 1 1 5 119
15 8 1 0 1 2 1720
15 9 1 0 1 5 2015
15 10 0 0 0 1 4128
15 11 1 0 0 1 463
15 12 1 0 0 2 4142
15 13 1 1 0 1 1880
15 14 0 1 1 3 2172
15 15 1 0 1 2 197
16 1 1 1 0 3 4163
16 2 1 1 0 1 2375
16 3 1 0 1 5 1598
16 4 1 0 0 2 4142
16 5 0 1 1 5 119
16 6.5 1 1 0 1 1880
16 6.5 0 1 1 3 2172
16 8 1 0 0 1 3035
16 9 1 0 0 1 1791
16 10 1 0 1 2 197
16 11 1 0 0 1 463
16 12 1 0 1 2 1720
16 13 1 0 1 5 2015
16 14 0 0 0 1 1060
16 15 0 0 0 1 4128
21 1 0 1 1 4 3049
21 2 0 1 0 1 2715
21 3 1 0 0 1 4150
21 4 1 0 0 3 4179
21 5 1 0 0 5 231
21 6 0 1 0 5 2826
21 7 0 1 0 1 3003
21 8 1 0 1 4 2228
21 9 0 0 1 5 728
21 10 0 1 0 1 2091
21 11 1 0 0 1 2647
21 12 0 1 0 1 2270
21 13 1 0 0 1 716
21 14 1 0 0 1 2463
22 1 0 1 0 5 2826
22 2 0 1 1 4 3049
22 3 0 1 0 1 2715
22 4 1 0 0 5 231
22 5 1 0 0 3 4179
22 6 1 0 0 1 4150
22 7 0 1 0 1 3003
22 8 1 0 0 1 2647
22 9 0 1 0 1 2091
22 10 1 0 1 4 2228
22 11 1 0 0 1 2463
22 12 0 0 1 5 728
22 13 1 0 0 1 716
22 14 0 1 0 1 2270
23 1 1 0 0 1 4150
23 2 0 1 0 1 2715
23 3 0 1 0 1 2091
23 4 0 1 0 5 2826
23 5 1 0 1 4 2228
23 6 0 0 1 5 728
23 7 1 0 0 3 4179
23 8 0 1 1 4 3049
23 9 0 1 0 1 3003
23 10 1 0 0 1 2647
23 11 1 0 0 1 716
23 12 1 0 0 1 2463
23 13.5 1 0 0 5 231
23 13.5 0 1 0 1 2270
26 1 0 1 0 1 2091
26 2 1 0 0 3 4179
26 3 0 1 0 5 2826
26 4 0 1 0 1 2715
26 5 1 0 0 1 4150
26 6 1 0 0 5 231
26 7 1 0 1 4 2228
26 8 1 0 0 1 2647
26 9 0 0 1 5 728
26 10 0 1 1 4 3049
26 11 1 0 0 1 2463
26 12 0 1 0 1 3003
26 13 0 1 0 1 2270
26 14 1 0 0 1 716
31 1.5 0 1 0 2 506
31 1.5 0 1 1 4 1529
31 3 1 1 1 5 1158
31 4 0 1 1 5 3002
31 5 0 1 0 1 1780
31 6 0 1 1 5 1453
31 7 1 1 1 2 868
31 8 0 1 0 1 1079
31 9 1 1 0 1 1133
31 10 1 0 0 1 4158
31 11 0 1 1 2 595
31 12 1 0 0 1 1918
31 13 0 1 0 1 4063
31 14 1 1 1 2 1459
31 15 1 0 0 1 2627
32 2.5 0 1 1 5 1453
32 2.5 0 1 1 4 1529
32 2.5 0 1 0 1 1780
32 2.5 0 1 1 5 3002
32 6 0 1 0 2 506
32 6 0 1 1 2 595
32 6 1 1 1 5 1158
32 8 1 1 0 1 1133
32 11 1 1 1 2 868
32 11 0 1 0 1 1079
32 11 1 1 1 2 1459
32 11 1 0 0 1 2627
32 11 1 0 0 1 4158
32 14.5 1 0 0 1 1918
32 14.5 0 1 0 1 4063
33 1 0 1 1 5 3002
33 2 0 1 1 4 1529
33 3 0 1 0 1 1780
33 4 1 1 1 2 1459
33 5 0 1 1 5 1453
33 6 1 0 0 1 1918
33 7 1 1 1 2 868
33 8 1 1 1 5 1158
33 9 1 1 0 1 1133
33 10 1 0 0 1 4158
33 11 0 1 1 2 595
33 12 0 1 0 2 506
33 13 0 1 0 1 4063
33 14 0 1 0 1 1079
33 15 1 0 0 1 2627
34 1.5 0 1 1 4 1529
34 1.5 0 1 1 5 3002
34 3 0 1 0 2 506
34 5 1 1 1 2 868
34 5 1 1 1 5 1158
34 5 0 1 1 5 1453
34 7.5 0 1 0 1 1079
34 7.5 0 1 0 1 1780
34 9.5 0 1 1 2 595
34 9.5 1 0 0 1 1918
34 11.5 1 1 0 1 1133
34 11.5 1 0 0 1 4158
34 13 1 1 1 2 1459
34 14 0 1 0 1 4063
34 15 1 0 0 1 2627
35 1 1 1 1 2 868
35 2 0 1 1 5 3002
35 3 1 1 1 5 1158
35 4 0 1 0 2 506
35 5 0 1 1 4 1529
35 6 0 1 0 1 1780
35 7 0 1 1 5 1453
35 8 0 1 1 2 595
35 9 1 1 1 2 1459
35 10 1 1 0 1 1133
35 11 1 0 0 1 4158
35 12 1 0 0 1 1918
35 13 0 1 0 1 1079
35 14 0 1 0 1 4063
35 15 1 0 0 1 2627
41 1 1 0 0 1 209
41 2 1 1 1 5 4202
41 3.5 1 1 1 4 1080
41 3.5 1 1 0 2 4133
41 5 1 1 0 1 4055
41 6 1 0 1 4 2687
41 7.5 1 0 1 5 443
41 7.5 0 1 0 1 1476
41 9 0 1 0 1 1958
41 10 0 1 1 4 2795
41 11 1 0 0 1 394
41 13 1 0 0 1 576
41 13 1 0 0 1 2235
41 13 1 1 1 3 4212
42 1.5 1 1 0 2 4133
42 1.5 1 1 1 5 4202
42 3.5 0 1 1 4 2795
42 3.5 1 1 0 1 4055
42 5.5 1 0 1 5 443
42 5.5 1 1 1 4 1080
42 7.5 1 0 1 4 2687
42 7.5 1 1 1 3 4212
42 9 0 1 0 1 1958
42 10 0 1 0 1 1476
42 11 1 0 0 1 394
42 12 1 0 0 1 209
42 13 1 0 0 1 576
42 14 1 0 0 1 2235
43 1 1 1 1 5 4202
43 2 1 1 0 1 4055
43 3 1 0 0 1 209
43 4 1 0 0 1 394
43 5 0 1 0 1 1958
43 6 0 1 1 4 2795
43 7 1 0 1 4 2687
43 8 1 0 1 5 443
43 9 1 1 1 4 1080
43 10 1 1 1 3 4212
43 11 1 1 0 2 4133
43 12 1 0 0 1 2235
43 13 0 1 0 1 1476
43 14 1 0 0 1 576
44 1 1 1 1 5 4202
44 2 1 1 0 1 4055
44 3 0 1 1 4 2795
44 4 1 0 0 1 394
44 5.5 0 1 0 1 1958
44 5.5 1 0 1 4 2687
44 7 1 1 1 4 1080
44 8 1 1 0 2 4133
44 9 1 0 1 5 443
44 10 1 0 0 1 209
44 11 1 0 0 1 2235
44 12 0 1 0 1 1476
44 13 1 1 1 3 4212
44 14 1 0 0 1 576
45 1 1 1 1 5 4202
45 2 1 0 0 1 394
45 3 1 1 0 1 4055
45 4 1 1 0 2 4133
45 5 1 0 1 5 443
45 6 1 0 1 4 2687
45 7 1 0 0 1 2235
45 8 0 1 1 4 2795
45 9 0 1 0 1 1476
45 10 0 1 0 1 1958
45 11 1 1 1 4 1080
45 12 1 1 1 3 4212
45 13 1 0 0 1 576
45 14 1 0 0 1 209
51 1 0 0 0 4 1793
51 2 1 0 1 5 2026
51 3 1 0 0 3 4169
51 4 0 1 1 3 2809
51 5 1 0 1 1 662
51 6 1 0 1 4 1917
51 7.5 1 0 0 2 73
51 7.5 1 0 1 3 1138
51 9.5 0 1 0 1 2040
51 9.5 1 1 0 1 2722
51 11.5 1 0 0 1 1243
51 11.5 0 1 0 1 2030
51 13.5 0 1 0 2 964
51 13.5 0 0 0 1 2761
51 15 1 0 1 5 1823
52 1 1 0 1 4 1917
52 2 1 0 0 1 1243
52 3 1 0 1 1 662
52 4 0 0 0 4 1793
52 5 1 0 1 5 2026
52 7 0 1 0 2 964
52 7 0 1 0 1 2030
52 7 1 1 0 1 2722
52 9.5 1 0 0 2 73
52 9.5 0 1 0 1 2040
52 11 1 0 0 3 4169
52 12 0 1 1 3 2809
52 13.5 1 0 1 3 1138
52 13.5 1 0 1 5 1823
52 15 0 0 0 1 2761
54 1.5 1 1 0 1 2722
54 1.5 1 0 0 3 4169
54 3.5 1 0 0 1 1243
54 3.5 0 1 0 1 2030
54 5.5 1 0 1 1 662
54 5.5 0 1 0 1 2040
54 7 0 0 0 4 1793
54 8.5 1 0 1 4 1917
54 8.5 1 0 1 5 2026
54 10.5 1 0 1 3 1138
54 10.5 0 1 1 3 2809
54 12 1 0 0 2 73
54 13.5 0 1 0 2 964
54 13.5 0 0 0 1 2761
54 15 1 0 1 5 1823
55 1.5 1 0 1 3 1138
55 1.5 0 0 0 4 1793
55 3 0 1 0 1 2040
55 4 0 1 1 3 2809
55 5.5 1 0 1 5 2026
55 5.5 1 0 0 3 4169
55 7 0 1 0 1 2030
55 8 1 0 0 1 1243
55 9.5 1 0 0 2 73
55 9.5 0 0 0 1 2761
55 11 0 1 0 2 964
55 12.5 1 0 1 5 1823
55 12.5 1 1 0 1 2722
55 14.5 1 0 1 1 662
55 14.5 1 0 1 4 1917
56 1 0 1 0 1 2040
56 3 1 0 1 1 662
56 3 1 1 0 1 2722
56 4 1 0 0 3 4169
56 5 0 1 0 1 2030
56 6 1 0 0 2 73
56 7 0 0 0 4 1793
56 8 0 1 1 3 2809
56 9.5 1 0 1 4 1917
56 9.5 1 0 1 5 2026
56 11 1 0 0 1 1243
56 12 0 1 0 2 964
56 13 1 0 1 3 1138
56 14 1 0 1 5 1823
56 15 0 0 0 1 2761
61 1 0 0 0 5 3018
61 2 0 1 1 5 200
61 3 1 0 1 1 4174
61 4 0 1 0 2 1640
61 5 1 0 1 3 3000
61 7 1 1 1 1 4149
61 8 0 1 0 2 1783
61 9 0 1 0 1 618
61 10 1 1 1 3 4152
61 11 1 1 0 1 4166
61 12 0 1 0 3 603
61 12 1 1 0 1 4074
61 13 0 0 1 2 4117
61 14 0 1 0 1 1533
62 1.5 0 1 1 5 200
62 1.5 0 0 0 5 3018
62 3 1 0 1 1 4174
62 4 1 0 1 3 3000
62 5 1 1 0 1 4074
62 6 0 1 0 1 618
62 7 0 1 0 3 603
62 8 1 1 0 1 4166
62 9.5 1 1 1 1 4149
62 9.5 1 1 1 3 4152
62 11 0 1 0 2 1640
62 12 0 0 1 2 4117
62 13.5 0 1 0 1 1533
62 13.5 0 1 0 2 1783
63 1 0 0 0 5 3018
63 2 1 0 1 3 3000
63 3 0 1 1 5 200
63 4.5 1 1 1 3 4152
63 4.5 1 0 1 1 4174
63 6 0 1 0 1 1533
63 7 0 1 0 2 1640
63 8 0 1 0 3 603
63 9 0 1 0 2 1783
63 10 1 1 0 1 4166
63 11 1 1 1 1 4149
63 12 0 0 1 2 4117
63 13 1 1 0 1 4074
63 14 0 1 0 1 618
64 1.5 0 1 1 5 200
64 1.5 0 0 0 5 3018
64 3 1 0 1 3 3000
64 4 1 1 1 1 4149
64 5 1 0 1 1 4174
64 6 0 1 0 1 618
64 7 0 1 0 3 603
64 8 1 1 1 3 4152
64 9 0 1 0 2 1640
64 10 1 1 0 1 4074
64 11 0 1 0 2 1783
64 12 1 1 0 1 4166
64 13 0 0 1 2 4117
64 14 0 1 0 1 1533
66 1.5 0 0 0 5 3018
66 1.5 1 0 1 1 4174
66 3 0 1 1 5 200
66 4 0 1 0 3 603
66 5 1 0 1 3 3000
66 6.5 0 1 0 1 618
66 6.5 1 1 0 1 4074
66 8 1 1 1 1 4149
66 9.5 0 1 0 1 1533
66 9.5 1 1 0 1 4166
66 11 0 1 0 2 1783
66 12 0 1 0 2 1640
66 13 1 1 1 3 4152
66 14 0 0 1 2 4117
71 2 0 1 1 3 4176
71 3 0 1 0 1 673
71 4 0 1 0 1 2190
71 5 1 1 0 1 4170
71 6 1 1 0 1 2170
71 7 0 1 1 3 1227
71 8 0 0 0 2 4090
71 9 1 1 0 1 3044
71 9 0 1 0 1 4203
71 10 1 0 0 1 1612
71 11 0 1 1 5 520
71 13 1 1 0 1 305
71 13 1 1 1 5 1031
71 13 0 1 1 5 4204
71 15 0 1 0 1 679
72 1 0 1 1 3 4176
72 2 1 1 1 5 1031
72 3.5 0 1 0 1 673
72 3.5 0 1 1 3 1227
72 5.5 0 1 1 5 520
72 5.5 0 1 0 1 2190
72 7 0 0 0 2 4090
72 8 1 1 0 1 2170
72 9 0 1 1 5 4204
72 10.5 1 1 0 1 3044
72 10.5 1 1 0 1 4170
72 12 1 1 0 1 305
72 13 0 1 0 1 4203
72 14 1 0 0 1 1612
72 15 0 1 0 1 679
73 1 1 1 0 1 3044
73 2.5 0 1 1 3 1227
73 2.5 1 1 0 1 2170
73 4.5 0 1 0 1 2190
73 4.5 0 1 1 3 4176
73 6 0 0 0 2 4090
73 7 0 1 1 5 4204
73 8.5 1 1 1 5 1031
73 8.5 0 1 0 1 4203
73 10 1 1 0 1 4170
73 11 0 1 1 5 520
73 12 0 1 0 1 673
73 13 1 1 0 1 305
73 14 0 1 0 1 679
73 15 1 0 0 1 1612
74 1.5 0 1 1 3 1227
74 1.5 0 1 0 1 2190
74 3.5 0 1 0 1 673
74 3.5 0 1 1 3 4176
74 5.5 1 1 1 5 1031
74 5.5 0 0 0 2 4090
74 7.5 1 1 0 1 2170
74 7.5 0 1 1 5 4204
74 9 1 1 0 1 4170
74 10 0 1 0 1 4203
74 11.5 1 1 0 1 305
74 11.5 1 0 0 1 1612
74 13.5 0 1 1 5 520
74 13.5 1 1 0 1 3044
74 15 0 1 0 1 679
75 1 1 1 0 1 4170
75 2 0 1 1 3 4176
75 3 0 1 1 5 520
75 4 1 0 0 1 1612
75 5 0 1 0 1 2190
75 6 0 0 0 2 4090
75 7 0 1 1 3 1227
75 8 1 1 0 1 3044
75 9 1 1 1 5 1031
75 10 1 1 0 1 2170
75 11 0 1 0 1 673
75 12 1 1 0 1 305
75 13 0 1 0 1 4203
75 14 0 1 0 1 679
75 15 0 1 1 5 4204
81 2.5 0 1 0 2 1336
81 2.5 0 1 1 5 3032
81 4 1 1 1 5 4213
81 5 0 0 0 2 4167
81 6 1 0 0 2 2318
81 7 0 1 0 2 2800
81 8 0 0 0 2 726
81 8 0 1 0 1 1391
81 9 0 0 0 2 727
81 10 1 1 0 1 338
81 11.5 0 0 0 2 124
81 11.5 0 1 1 4 1329
81 13.5 1 1 0 1 1076
81 13.5 0 1 0 1 1576
81 15 0 1 1 4 1914
82 1 0 1 1 5 3032
82 2.5 0 1 0 2 2800
82 2.5 0 0 0 2 4167
82 4.5 0 1 1 4 1914
82 4.5 1 0 0 2 2318
82 6 1 1 0 1 338
82 7 0 0 0 2 124
82 8 1 1 0 1 1076
82 9 0 0 0 2 727
82 10 0 0 0 2 726
82 11 1 1 1 5 4213
82 12.5 0 1 0 2 1336
82 12.5 0 1 0 1 1391
82 14 0 1 1 4 1329
82 15 0 1 0 1 1576
83 1 0 1 1 5 3032
83 2 0 0 0 2 726
83 3 0 1 0 2 1336
83 4 0 1 0 1 1391
83 5 1 0 0 2 2318
83 6 1 1 0 1 338
83 7 0 0 0 2 4167
83 8 0 1 0 2 2800
83 9 1 1 1 5 4213
83 10 1 1 0 1 1076
83 11 0 0 0 2 124
83 12 0 1 0 1 1576
83 13 0 0 0 2 727
83 14 0 1 1 4 1914
83 15 0 1 1 4 1329
84 1.5 0 0 0 2 727
84 1.5 0 0 0 2 4167
84 3 0 0 0 2 726
84 4.5 0 1 1 5 3032
84 4.5 1 1 1 5 4213
84 6.5 0 1 0 2 1336
84 6.5 1 0 0 2 2318
84 8 0 1 0 2 2800
84 9.5 0 0 0 2 124
84 9.5 1 1 0 1 338
84 11.5 1 1 0 1 1076
84 11.5 0 1 1 4 1914
84 13.5 0 1 1 4 1329
84 13.5 0 1 0 1 1576
84 15 0 1 0 1 1391
86 1 0 0 0 2 727
86 2.5 0 0 0 2 726
86 2.5 0 1 0 2 1336
86 4 0 0 0 2 4167
86 5 1 1 1 5 4213
86 6 0 1 1 4 1329
86 7 0 1 1 5 3032
86 8 1 0 0 2 2318
86 9 0 1 1 4 1914
86 10 0 1 0 2 2800
86 11 0 0 0 2 124
86 12 1 1 0 1 338
86 13 0 1 0 1 1576
86 14 1 1 0 1 1076
86 15 0 1 0 1 1391
91 1 0 1 1 5 1717
91 2 0 0 1 5 1337
91 3 1 1 1 1 4126
91 4 1 0 1 5 4121
91 5 0 1 0 4 140
91 6 1 1 1 1 4171
91 7 1 1 0 1 1246
91 8 1 0 0 1 558
91 9 1 1 0 1 649
91 10 0 0 0 1 190
91 11 1 0 0 1 2381
91 12 0 0 0 1 2053
91 13 1 0 0 1 703
91 14 0 1 0 1 4031
91 15 0 1 0 4 1510
92 1 1 0 1 5 4121
92 2 1 1 1 1 4171
92 3 0 0 1 5 1337
92 4 1 1 1 1 4126
92 5 0 0 0 1 190
92 6 0 0 0 1 2053
92 7 0 1 1 5 1717
92 8 1 0 0 1 2381
92 9 0 1 0 4 140
92 10 1 1 0 1 649
92 11 0 1 0 1 4031
92 12 1 0 0 1 558
92 13 1 1 0 1 1246
92 14 0 1 0 4 1510
92 15 1 0 0 1 703
93 1 0 0 1 5 1337
93 2 1 1 1 1 4126
93 4 0 0 0 1 2053
93 4 1 0 1 5 4121
93 4 1 1 1 1 4171
93 6.5 0 0 0 1 190
93 6.5 0 1 1 5 1717
93 8 0 1 0 4 1510
93 9 0 1 0 1 4031
93 10 1 1 0 1 1246
93 11 1 1 0 1 649
93 12 1 0 0 1 558
93 13 1 0 0 1 2381
93 14 0 1 0 4 140
93 15 1 0 0 1 703
94 1 0 0 1 5 1337
94 2 1 1 1 1 4171
94 3 0 1 0 4 140
94 4 1 0 0 1 2381
94 5 0 1 0 1 4031
94 6 1 1 0 1 1246
94 7 1 1 0 1 649
94 8 1 0 1 5 4121
94 9 1 1 1 1 4126
94 10 0 0 0 1 2053
94 11 0 1 0 4 1510
94 12 1 0 0 1 558
94 13 0 1 1 5 1717
94 14 0 0 0 1 190
94 15 1 0 0 1 703
95 1 1 1 1 1 4171
95 2 1 1 1 1 4126
95 3 1 0 1 5 4121
95 4 0 1 1 5 1717
95 5 0 0 1 5 1337
95 6 0 0 0 1 190
95 7 0 1 0 4 140
95 8 0 0 0 1 2053
95 9 1 1 0 1 649
95 10 0 1 0 1 4031
95 11 0 1 0 4 1510
95 12 1 0 0 1 558
95 13 1 1 0 1 1246
95 14 1 0 0 1 703
95 15 1 0 0 1 2381
102 1 0 1 0 2 1658
102 1 1 0 0 2 1974
102 1 0 1 0 3 3001
102 1 0 1 0 5 3048
102 2 0 1 0 1 2044
102 2 0 1 1 4 2241
102 3 1 0 0 1 694
102 4 1 1 0 2 2403
102 5 0 1 0 1 365
102 6 0 1 0 2 4207
102 7 1 0 1 5 160
102 8 0 1 0 1 1946
102 12 0 1 0 2 4153
102 14 0 1 0 1 1489
102 15 0 0 0 1 1638
103 1 1 0 0 2 1974
103 2 0 1 0 3 3001
103 3 1 0 1 5 160
103 4.5 0 1 0 5 3048
103 4.5 0 1 0 2 4207
103 6 0 1 0 1 365
103 7 0 1 0 1 2044
103 8 0 1 0 2 1658
103 9 0 1 0 1 1489
103 10.5 1 0 0 1 694
103 10.5 0 1 0 1 1946
103 12 1 1 0 2 2403
103 13 0 0 0 1 1638
103 14 0 1 0 2 4153
103 15 0 1 1 4 2241
104 1 0 1 0 5 3048
104 2 1 0 1 5 160
104 3 0 0 0 1 1638
104 4 0 1 1 4 2241
104 5 0 1 0 1 1489
104 6 0 1 0 2 4153
104 7 1 0 0 2 1974
104 8 0 1 0 1 365
104 9 0 1 0 2 4207
104 10 1 0 0 1 694
104 11 0 1 0 2 1658
104 12 0 1 0 3 3001
104 13 1 1 0 2 2403
104 14 0 1 0 1 1946
104 15 0 1 0 1 2044
105 1 0 1 1 4 2241
105 2 0 1 0 1 365
105 3 0 1 0 5 3048
105 4 0 1 0 2 4207
105 5 0 0 0 1 1638
105 6 1 0 1 5 160
105 7 1 0 0 1 694
105 8 0 1 0 3 3001
105 9 1 0 0 2 1974
105 10 1 1 0 2 2403
105 11 0 1 0 2 1658
105 12 0 1 0 1 1946
105 13 0 1 0 1 2044
105 14 0 1 0 1 1489
105 15 0 1 0 2 4153
106 1 1 0 1 5 160
106 2 0 1 0 5 3048
106 3.5 1 1 0 2 2403
106 3.5 0 1 0 2 4207
106 5 0 1 0 2 1658
106 6 0 1 0 1 2044
106 7 0 1 0 3 3001
106 8 0 1 1 4 2241
106 9 1 0 0 1 694
106 10 1 0 0 2 1974
106 11 0 0 0 1 1638
106 12 0 1 0 1 1946
106 13 0 1 0 1 365
106 14 0 1 0 1 1489
106 15 0 1 0 2 4153
;

/*
----------------
PTSD Data Set
----------------

 Data described in Chapter 8 of P.D. Allison, "Logistic Regression
 Using the SAS System: Theory and Application."                 */

data ptsd;
input subjid ptsd control problems sevent cohes time;
datalines;
15 0 3.2222222222 5.625 1 8 1
15 0 3.1666666667 5.375 0 8 2
15 0 3.2777777778 3.75 1 8 3
18 1 2.5555555556 9.25 0 8 1
18 0 3.4444444444 4.375 0 8 2
18 0 3.3333333333 2.375 0 8 3
19 1 2.7222222222 7.75 1 7 1
19 1 2.7777777778 7.75 1 7 2
19 0 2.7777777778 7.5 1 7 3
23 0 3.3888888889 7.75 0 8 1
23 1 3.2777777778 7.25 1 8 2
23 0 3.3333333333 6.25 0 8 3
24 0 3.1666666667 6.875 0 9 1
24 0 3.8888888889 6.875 0 9 2
24 0 3.9444444444 4.375 0 9 3
29 1 3.2777777778 6.125 1 8 1
29 0 3.3333333333 5.875 0 8 2
29 0 3.9444444444 2.125 1 8 3
30 0 3.3333333333 5.5 0 9 1
30 0 3.6666666667 4.375 0 9 2
30 0 3.3888888889 3.75 0 9 3
31 0 2.8888888889 6 1 8 1
31 1 3.1111111111 7.125 2 8 2
31 0 3.2222222222 5.875 1 8 3
32 0 3.3333333333 5.5 1 8 1
32 0 3.6111111111 4.25 0 8 2
32 0 3.9444444444 3.375 0 8 3
33 0 3.6666666667 4.5 0 9 1
33 0 3.6111111111 2.875 1 9 2
33 0 3.9444444444 2.875 0 9 3
34 0 3.0555555556 6.5 1 9 1
34 0 3.5 4.625 3 9 2
34 0 2.6111111111 5.25 0 9 3
41 0 3.8888888889 3.625 1 7 1
41 0 4 1.625 0 7 2
41 0 4 1 0 7 3
43 0 3.7222222222 3.875 1 8 1
43 0 3.8333333333 2.5 0 8 2
43 0 3.6666666667 1.75 0 8 3
44 0 3.2222222222 7.75 0 9 1
44 0 3.4444444444 7.5 0 9 2
44 1 3.2777777778 5.875 0 9 3
45 0 3.4444444444 6.125 0 9 1
45 0 3.0555555556 5.75 0 9 2
45 0 3.3888888889 5.5 0 9 3
47 1 2.4444444444 7.25 1 6 1
47 0 2.2777777778 6.375 0 6 2
47 0 3.0555555556 4.25 3 6 3
48 0 3.7222222222 4.875 0 6 1
48 0 3.7777777778 5.5 2 6 2
48 1 3.3333333333 6.625 1 6 3
49 0 3.2777777778 4 0 7 1
49 0 3.7222222222 3.375 0 7 2
49 0 3.9444444444 1.25 0 7 3
50 1 2.8888888889 5.25 0 6 1
50 0 3.5555555556 4 0 6 2
50 0 3.2222222222 2.25 0 6 3
51 1 2.7222222222 5.375 0 6 1
51 0 2.5 2.75 2 6 2
51 1 2.8888888889 3.125 1 6 3
52 0 3.5555555556 4.5 0 3 1
52 0 3.7777777778 4.375 2 3 2
52 0 3.6666666667 3.5 1 3 3
53 0 3.1666666667 7.625 3 8 1
53 0 2.9444444444 8.875 0 8 2
53 0 3.0555555556 7.75 1 8 3
55 0 3.4444444444 8 1 7 1
55 1 3.6666666667 6.125 0 7 2
55 0 3.2777777778 7.25 1 7 3
56 0 3.2777777778 6.25 1 8 1
56 0 3.3888888889 7.5 0 8 2
56 0 3.8888888889 2.125 1 8 3
57 1 2.9444444444 8.625 2 4 1
57 0 3.8888888889 7.625 1 4 2
57 0 3.8888888889 1.25 0 4 3
58 1 3.6666666667 8.25 3 1 1
58 1 3.6666666667 4.5 2 1 2
58 0 4 2.375 1 1 3
59 0 3.2777777778 3.625 1 8 1
59 0 3.4444444444 6.125 1 8 2
59 0 3.5555555556 7.375 0 8 3
61 1 3.6666666667 5.875 2 7 1
61 0 3.3333333333 1.75 1 7 2
61 1 3.2222222222 1.75 0 7 3
62 0 3.6666666667 7.25 1 9 1
62 0 3.6666666667 7.5 3 9 2
62 0 3.6111111111 5.875 2 9 3
64 0 3.2222222222 6.75 0 8 1
64 0 2.8333333333 6.375 0 8 2
64 0 2.8888888889 6.625 2 8 3
66 1 3.2222222222 8.125 2 7 1
66 1 3.4444444444 7.75 2 7 2
66 1 3.3333333333 7.375 1 7 3
67 1 3.0555555556 7 0 7 1
67 0 3.1666666667 7 1 7 2
67 0 3.5555555556 5.375 0 7 3
69 1 2.9444444444 7.125 1 3 1
69 0 3.0555555556 6.5 0 3 2
69 0 3.2777777778 5.25 0 3 3
71 1 2.9444444444 7.375 0 5 1
71 0 3.2222222222 6.625 0 5 2
71 0 3.2222222222 2.875 0 5 3
73 0 2.8333333333 8.5 0 8 1
73 1 3 8.625 3 8 2
73 1 3.5555555556 7 2 8 3
74 0 3.5 6.875 0 8 1
74 0 3.7222222222 1.875 1 8 2
74 0 3.8888888889 1 1 8 3
75 0 3.5555555556 7.125 1 8 1
75 0 3.7222222222 7.125 1 8 2
75 0 2.6111111111 9 2 8 3
76 0 2.8333333333 8.375 0 1 1
76 0 3.4444444444 6.625 0 1 2
76 0 3.7777777778 6.5 0 1 3
78 0 3.4444444444 7.125 1 8 1
78 0 3.5 4.5 0 8 2
78 1 3.5555555556 3.5 2 8 3
79 0 3.6111111111 5.125 0 7 1
79 0 3.7222222222 3.5 0 7 2
79 0 3.8888888889 1.375 1 7 3
80 1 2.8888888889 7.5 1 7 1
80 1 3 4.75 3 7 2
80 1 3.2222222222 6 1 7 3
81 1 2.6111111111 4.375 0 8 1
81 0 4 2.5 1 8 2
81 0 3.9444444444 4.5 0 8 3
82 1 2 8.875 0 7 1
82 0 3.1111111111 7.75 1 7 2
82 0 2.8333333333 7.25 0 7 3
84 0 3.3333333333 5.625 1 7 1
84 0 4 1.5 1 7 2
84 0 4 1.625 0 7 3
87 1 3.7777777778 6.625 1 7 1
87 0 3.3333333333 1.625 0 7 2
87 1 4 4.625 1 7 3
89 1 3.2222222222 6.25 2 7 1
89 0 3.2222222222 8.375 1 7 2
89 1 3.6111111111 6.625 3 7 3
90 0 3.6111111111 4.875 2 6 1
90 0 3.2777777778 1.875 1 6 2
90 0 3.8333333333 1.5 0 6 3
92 0 3.8888888889 2 0 8 1
92 0 4 1.625 0 8 2
92 0 4 1 0 8 3
94 0 3.0555555556 7.25 0 8 1
94 0 2.9444444444 6.125 1 8 2
94 0 3.6111111111 3.75 0 8 3
95 0 3.8333333333 1.5 0 6 1
95 1 3.9444444444 3.75 0 6 2
95 0 3.6666666667 1 0 6 3
99 0 3.8888888889 4.75 0 7 1
99 0 3.8333333333 3.25 0 7 2
99 0 3.7777777778 1 0 7 3
100 1 3 8.5 3 5 1
100 1 2.9444444444 4.375 1 5 2
100 0 3.3888888889 5.25 3 5 3
102 0 3.2222222222 7.125 0 9 1
102 0 3.5 1.75 0 9 2
102 0 2.7777777778 3.25 0 9 3
103 0 2.9444444444 6.75 0 9 1
103 0 2.7777777778 6.125 0 9 2
103 0 3.1111111111 5.625 0 9 3
104 0 3.8333333333 4.625 0 7 1
104 0 3.4444444444 2.375 0 7 2
104 0 3.7777777778 1 0 7 3
105 0 3.5555555556 7.25 2 7 1
105 1 3.1111111111 7.5 0 7 2
105 0 3.6666666667 7.25 0 7 3
106 1 3.0555555556 6.25 1 2 1
106 1 2.8333333333 4.5 0 2 2
106 1 2.8888888889 5.875 0 2 3
108 1 2.8333333333 5.25 0 7 1
108 0 3.5 3.875 1 7 2
108 0 3.7222222222 3.25 1 7 3
112 0 3.5555555556 3.75 3 8 1
112 0 3.3333333333 4 2 8 2
112 0 3.3333333333 1.875 2 8 3
115 1 2.8333333333 7.25 0 3 1
115 0 3 4.375 0 3 2
115 0 3.0555555556 6.125 1 3 3
118 1 3.6666666667 2.375 2 9 1
118 0 3.7777777778 1.75 0 9 2
118 0 3.8888888889 1.5 0 9 3
120 1 2.5555555556 6.625 1 6 1
120 1 2.8333333333 5 1 6 2
120 0 3 4.5 1 6 3
122 0 3.3333333333 5.25 1 5 1
122 1 3.9444444444 2.25 1 5 2
122 0 3.7777777778 1.625 0 5 3
123 1 3.6111111111 7.625 1 6 1
123 1 3.8333333333 6.5 0 6 2
123 0 3.7222222222 2.125 2 6 3
124 1 3 8.625 0 5 1
124 1 3.2777777778 8.5 2 5 2
124 0 2.7777777778 5.75 2 5 3
126 0 3.2777777778 5.625 0 9 1
126 1 3.1666666667 5.75 0 9 2
126 1 3.6111111111 2.875 1 9 3
127 1 2.9444444444 7.75 3 4 1
127 1 3.1666666667 7.75 4 4 2
127 1 3.4444444444 7.75 4 4 3
129 0 3.0555555556 6.25 1 9 1
129 0 3.0555555556 5.5 0 9 2
129 0 3.4444444444 5.125 0 9 3
130 0 3.6666666667 6.875 1 9 1
130 1 3.4444444444 5.25 1 9 2
130 0 3.1111111111 4.25 0 9 3
133 0 3.0555555556 4.875 0 9 1
133 0 3.7777777778 3.5 1 9 2
133 0 2.8888888889 2.25 2 9 3
138 1 2.8333333333 7.625 0 8 1
138 1 3.1111111111 6.125 2 8 2
138 1 3.2222222222 4.25 0 8 3
139 0 3.5 6.75 1 3 1
139 0 3.6111111111 6 0 3 2
139 0 3.8888888889 5.375 0 3 3
141 1 2.4444444444 5.5 0 2 1
141 1 2.9444444444 6.375 0 2 2
141 0 2.3333333333 6.375 1 2 3
142 0 3.3888888889 2.625 1 9 1
142 0 3.7222222222 2.5 0 9 2
142 0 3.6666666667 2.5 0 9 3
143 0 3.6666666667 6.75 2 5 1
143 0 3.5555555556 4.75 0 5 2
143 0 3.9444444444 1.5 0 5 3
145 0 3.5 7.625 1 9 1
145 1 3.3333333333 7.375 0 9 2
145 0 2.9444444444 6.375 0 9 3
146 0 3.8888888889 4.75 1 8 1
146 0 4 2.875 0 8 2
146 0 3.9444444444 3.75 0 8 3
148 0 3.8888888889 5.5 0 9 1
148 0 3.7777777778 2.75 0 9 2
148 0 3.5 2.875 1 9 3
149 0 3.6666666667 6 0 8 1
149 0 3.2222222222 3 0 8 2
149 0 3.3333333333 1.125 0 8 3
150 1 2.4444444444 7.25 0 1 1
150 0 3.3888888889 7 2 1 2
150 0 3.3888888889 4.25 1 1 3
151 0 3.6111111111 5 0 9 1
151 0 3.7777777778 3 0 9 2
151 0 3.9444444444 5.375 0 9 3
155 1 2.8333333333 6.375 0 2 1
155 1 2.8888888889 7 0 2 2
155 1 3 6.375 0 2 3
156 1 3.1111111111 4.25 0 6 1
156 1 2.8888888889 3.75 1 6 2
156 0 3.6111111111 2.25 0 6 3
157 1 2.6111111111 6.625 0 8 1
157 0 3.1666666667 7.5 1 8 2
157 0 3.0555555556 5.5 0 8 3
160 1 3.6111111111 4.875 0 7 1
160 0 3.6666666667 2.75 1 7 2
160 0 3.2222222222 2.875 1 7 3
161 0 3.4444444444 6.125 0 7 1
161 1 3.4444444444 5.5 1 7 2
161 1 3.3888888889 5.375 2 7 3
162 1 2.4444444444 6.125 0 4 1
162 0 2.8333333333 4.5 0 4 2
162 0 3.3888888889 2.5 1 4 3
163 0 2.7777777778 5.5 0 9 1
163 0 3.7777777778 4.375 1 9 2
163 0 2.5555555556 1.375 0 9 3
164 0 3.6111111111 5.25 0 8 1
164 0 3.2222222222 5 0 8 2
164 0 3.6111111111 2.875 0 8 3
165 0 3.8333333333 3.25 1 8 1
165 0 4 1.125 2 8 2
165 0 3.6666666667 1.75 1 8 3
166 0 3.5 7.75 0 9 1
166 0 3.5555555556 5 1 9 2
166 0 3.7777777778 7.5 1 9 3
168 1 2.7777777778 7.75 0 8 1
168 0 2.8333333333 6.75 2 8 2
168 1 2.1666666667 6.875 1 8 3
174 0 2.6111111111 6.875 3 3 1
174 1 3.2222222222 5.875 1 3 2
174 0 3.2777777778 5.75 1 3 3
175 0 3.5 6.375 3 8 1
175 0 3.6666666667 1.125 0 8 2
175 0 3.7222222222 1.75 0 8 3
177 0 3.8333333333 7.75 0 8 1
177 0 2.9444444444 7.125 2 8 2
177 1 2.5555555556 7.125 2 8 3
178 1 2.4444444444 6.5 2 5 1
178 0 3.1666666667 4.75 0 5 2
178 0 3.1111111111 2.875 1 5 3
180 1 3.5 8.125 0 8 1
180 0 3.8888888889 6.5 1 8 2
180 0 3.7777777778 5.875 2 8 3
182 0 3.3333333333 4.875 0 9 1
182 0 3.3333333333 4.5 1 9 2
182 0 3.8333333333 2.5 1 9 3
184 1 3.2222222222 6.125 2 4 1
184 0 3.8888888889 7.75 0 4 2
184 0 4 5.25 0 4 3
185 1 3.3888888889 6.125 1 6 1
185 0 3.3333333333 7.75 1 6 2
185 1 3.9444444444 5.375 1 6 3
186 1 3.1111111111 7.25 0 8 1
186 1 3.6666666667 6.75 3 8 2
186 1 3.6111111111 7.625 0 8 3
188 1 3.2222222222 7.75 0 7 1
188 0 3.0555555556 6.5 0 7 2
188 1 3 7.625 0 7 3
190 1 2.7777777778 5.5 2 2 1
190 0 2.8888888889 5.625 1 2 2
190 0 3.6666666667 3 0 2 3
192 1 3.5 5.25 1 8 1
192 0 3.6666666667 6.125 2 8 2
192 0 3.9444444444 4.625 0 8 3
193 0 3.7222222222 7 0 9 1
193 0 3.7777777778 3.25 1 9 2
193 0 3.6666666667 5 0 9 3
196 0 3.6666666667 3.75 0 7 1
196 0 3.7777777778 3.25 0 7 2
196 0 3.8333333333 2.625 3 7 3
199 0 3.8888888889 6 0 8 1
199 0 3.8333333333 2 1 8 2
199 0 3.9444444444 1.75 0 8 3
200 1 3.7777777778 7.75 0 7 1
200 0 3.9444444444 7.25 1 7 2
200 0 3.7222222222 3.125 0 7 3
201 0 3.5555555556 7.75 1 9 1
201 1 3.7777777778 8 3 9 2
201 0 3.3333333333 6.375 1 9 3
202 0 3.6666666667 4.625 2 8 1
202 0 3.6666666667 3 2 8 2
202 0 3.9444444444 1.5 3 8 3
204 1 2.8333333333 7.75 1 7 1
204 1 2.7222222222 7 1 7 2
204 0 2.7222222222 6.5 1 7 3
205 1 3.7777777778 3.875 3 9 1
205 0 3.8888888889 1.5 2 9 2
205 0 3.8888888889 1.25 4 9 3
206 0 2.7222222222 5.75 1 8 1
206 0 2.2777777778 5.25 1 8 2
206 0 3 5.375 0 8 3
207 0 2.6666666667 7.75 1 9 1
207 0 3.0555555556 7.75 1 9 2
207 0 2.5 6.625 1 9 3
208 0 3.6111111111 6.375 0 9 1
208 0 3.8333333333 3.375 0 9 2
208 0 3.8333333333 1.5 1 9 3
212 0 3.4444444444 7.125 0 8 1
212 0 4 3.125 0 8 2
212 0 3.7777777778 2 0 8 3
213 0 3.7777777778 2.375 0 8 1
213 0 3.8888888889 3.125 0 8 2
213 0 4 1.125 0 8 3
214 0 3.3888888889 7.125 1 9 1
214 0 3.7222222222 3.75 0 9 2
214 1 3 3.125 1 9 3
216 1 3.2777777778 7.375 2 8 1
216 1 3 7.75 3 8 2
216 1 3.6111111111 7.125 3 8 3
217 1 3.3888888889 6.875 1 9 1
217 1 3.7777777778 2.5 1 9 2
217 1 4 4.375 0 9 3
219 1 3.1111111111 7.25 1 7 1
219 1 2.8333333333 7.5 2 7 2
219 0 3.1111111111 7 0 7 3
220 0 4 4.375 0 9 1
220 0 4 1.875 1 9 2
220 0 4 1 0 9 3
221 0 3.6666666667 4.75 0 8 1
221 0 3.7222222222 4.625 0 8 2
221 0 3.7222222222 2.375 1 8 3
222 1 3.5555555556 6.25 5 8 1
222 1 3.6111111111 6.5 4 8 2
222 1 2.6666666667 4.875 2 8 3
223 0 3.8888888889 4.625 0 8 1
223 0 4 3 1 8 2
223 0 4 1.125 0 8 3
225 0 4 5.75 2 9 1
225 0 3.7777777778 2.5 0 9 2
225 0 4 1.5 0 9 3
231 0 3 6.125 1 7 1
231 0 3.3333333333 5 0 7 2
231 0 3.5555555556 2.125 0 7 3
232 1 3.5 8.75 2 7 1
232 1 2.9444444444 7.125 0 7 2
232 1 3.5555555556 8.375 2 7 3
233 1 3.2222222222 6.5 2 7 1
233 0 3.3888888889 4.375 1 7 2
233 0 3.1666666667 1.875 1 7 3
234 0 3.0555555556 6.75 1 9 1
234 1 2.9444444444 6 1 9 2
234 0 3.3333333333 7.125 2 9 3
237 0 4 1.625 0 9 1
237 0 4 1 1 9 2
237 0 4 1.375 0 9 3
238 0 3.0555555556 7 1 9 1
238 0 3.2777777778 7.625 0 9 2
238 0 2.7777777778 7.5 0 9 3
240 0 2.7777777778 6.875 2 6 1
240 0 2.7222222222 5.75 0 6 2
240 0 2.2777777778 6.75 1 6 3
241 0 2.8333333333 7.625 1 5 1
241 1 3.0555555556 7.375 1 5 2
241 0 4 4 0 5 3
242 0 3.1666666667 6.75 1 7 1
242 0 3 6 1 7 2
242 1 3 7.125 4 7 3
243 1 2.8888888889 7.625 0 6 1
243 1 3.1111111111 7.375 0 6 2
243 1 2.4444444444 7.375 0 6 3
244 1 2.1111111111 7.75 2 0 1
244 1 2.7222222222 7.75 2 0 2
244 1 3 7.75 2 0 3
245 0 3.7777777778 3.25 1 8 1
245 0 4 2.375 3 8 2
245 0 3.9444444444 1.625 0 8 3
247 0 3.0555555556 6.25 0 7 1
247 0 3.1666666667 4.125 0 7 2
247 0 3.6111111111 4 0 7 3
250 0 3.6666666667 6.625 0 9 1
250 0 3.9444444444 3.75 1 9 2
250 0 3.8888888889 2.75 0 9 3
251 0 3.0555555556 6.875 1 8 1
251 0 2.7777777778 6.625 2 8 2
251 0 3.2222222222 7.125 0 8 3
252 0 4 6.625 0 8 1
252 0 3.7777777778 3.5 1 8 2
252 0 3.8888888889 1.125 0 8 3
258 0 4 1 1 7 1
258 0 4 1 0 7 2
258 0 3.6666666667 1 0 7 3
261 0 3.5 6.75 0 9 1
261 0 3.9444444444 2.25 0 9 2
261 0 4 2.25 3 9 3
262 1 3.4444444444 6.125 0 9 1
262 1 3.6666666667 2.875 1 9 2
262 1 3.5555555556 2.5 3 9 3
266 1 3.0555555556 7.25 1 7 1
266 0 3.1666666667 5.375 0 7 2
266 0 3.2777777778 2.75 0 7 3
267 1 2.2222222222 7 2 9 1
267 1 2.8333333333 5.375 1 9 2
267 0 3.6111111111 6 0 9 3
268 1 2.7222222222 7.75 0 8 1
268 1 3 6.75 2 8 2
268 0 2.5555555556 7.75 2 8 3
269 0 3.2222222222 4.625 0 9 1
269 0 3.0555555556 4.625 1 9 2
269 0 2.9444444444 5 0 9 3
271 1 3.6666666667 5.625 0 8 1
271 0 3.7777777778 1.125 0 8 2
271 0 3.8333333333 1 0 8 3
272 1 2.7777777778 7.25 2 8 1
272 1 2.8333333333 7.375 2 8 2
272 0 2.7777777778 7.375 2 8 3
273 1 2.3333333333 7.875 1 4 1
273 1 2.2777777778 7.625 2 4 2
273 1 2.7222222222 6.625 1 4 3
275 0 3.6666666667 6.5 0 5 1
275 1 3.5555555556 2.125 0 5 2
275 0 3.4444444444 2.625 0 5 3
276 0 3.9444444444 7.5 3 7 1
276 0 3.8888888889 7.25 1 7 2
276 0 4 1.25 0 7 3
277 1 3.4444444444 7.25 1 7 1
277 0 3.6666666667 6.25 0 7 2
277 0 3.9444444444 5.625 1 7 3
279 1 3.2777777778 6.625 0 3 1
279 0 3.6111111111 5.375 0 3 2
279 0 3.3333333333 5.875 1 3 3
281 0 3.1111111111 6.5 0 6 1
281 0 3.2777777778 3.5 0 6 2
281 0 3.4444444444 6.375 0 6 3
283 0 3.8888888889 4.875 1 6 1
283 0 4 2.5 1 6 2
283 0 3.7222222222 5.125 2 6 3
284 1 2.7777777778 6.75 1 4 1
284 1 2.3888888889 6 1 4 2
284 0 2.9444444444 4 4 4 3
288 0 3.3333333333 7 2 9 1
288 0 3.5 5.375 0 9 2
288 0 3.5555555556 5.5 0 9 3
289 0 3.2777777778 5.75 0 8 1
289 0 3.8888888889 4.625 0 8 2
289 0 4 1 1 8 3
290 0 3.8888888889 6.125 0 8 1
290 0 3.8888888889 2.375 0 8 2
290 0 4 1 0 8 3
292 0 3.5555555556 7.375 0 8 1
292 0 4 1.125 0 8 2
292 0 4 3.625 0 8 3
293 1 3.0555555556 7.75 1 9 1
293 1 3.1111111111 7.125 0 9 2
293 0 3.6111111111 2.875 2 9 3
294 0 3.2777777778 6.5 0 8 1
294 0 3.4444444444 5.625 0 8 2
294 0 3.5 6.25 0 8 3
295 0 3.4444444444 7.5 1 9 1
295 1 3.6666666667 6.875 1 9 2
295 0 3.2777777778 3.625 1 9 3
296 0 2.2777777778 8.875 0 9 1
296 0 3.5 7.75 0 9 2
296 0 2.6666666667 6.625 0 9 3
297 1 2.5 7.25 1 9 1
297 0 3 7.75 3 9 2
297 1 3.3333333333 4.125 0 9 3
299 0 3.7777777778 7.125 1 8 1
299 0 3.7222222222 4.875 0 8 2
299 0 3.6666666667 6.125 2 8 3
300 1 3.7777777778 6.875 0 9 1
300 1 3.9444444444 5.125 0 9 2
300 1 3.8888888889 3.75 1 9 3
301 1 3.5 7.375 2 4 1
301 0 3.8333333333 7.25 1 4 2
301 0 3.6666666667 7.75 0 4 3
302 1 3.1666666667 7.375 2 5 1
302 0 3.2222222222 7.75 0 5 2
302 1 3.3333333333 5.875 3 5 3
303 0 4 1.375 0 9 1
303 0 4 1.375 0 9 2
303 0 4 1.25 0 9 3
304 0 4 3.5 1 9 1
304 0 3.8888888889 1.5 0 9 2
304 0 4 1.5 2 9 3
305 0 3.4444444444 6.5 0 9 1
305 0 3.2777777778 3.75 0 9 2
305 0 3.6111111111 5.375 0 9 3
306 1 2.6111111111 7.25 2 9 1
306 0 2.4444444444 7.5 0 9 2
306 0 3.0555555556 6.625 0 9 3
309 0 2.7222222222 6.375 2 4 1
309 0 3.3333333333 6.25 1 4 2
309 1 3.3888888889 7.25 1 4 3
310 1 3.2777777778 6.75 0 6 1
310 1 3.7777777778 4.375 0 6 2
310 0 3.9444444444 7.125 1 6 3
311 1 3.7222222222 5.875 0 7 1
311 0 3.5555555556 6.625 0 7 2
311 0 3.5555555556 2.375 0 7 3
312 0 2.7777777778 5.5 0 0 1
312 1 3.2222222222 5.375 0 0 2
312 1 2.7222222222 3.75 0 0 3
314 1 3.5555555556 8.875 5 5 1
314 1 3.8888888889 4.25 1 5 2
314 1 4 1.875 3 5 3
316 0 3.4444444444 6.625 1 9 1
316 1 2.8888888889 5.375 1 9 2
316 0 3.5555555556 5.75 0 9 3
317 0 3.6666666667 6.5 0 7 1
317 0 3.7222222222 3.25 0 7 2
317 0 3.9444444444 2.875 0 7 3
318 0 3.0555555556 6.25 1 8 1
318 0 3.6666666667 5.875 2 8 2
318 0 3.6111111111 6 0 8 3
319 1 2.9444444444 7 0 2 1
319 0 3.7222222222 2.625 0 2 2
319 0 4 1.75 1 2 3
320 0 3.8333333333 2.75 0 8 1
320 0 3.7222222222 2 0 8 2
320 0 4 1.625 1 8 3
321 0 3.3333333333 6 0 7 1
321 0 3.7222222222 4.75 1 7 2
321 0 3.8333333333 6.375 0 7 3
323 0 3.1111111111 7.625 2 6 1
323 1 3.0555555556 5.625 0 6 2
323 1 2.8888888889 7.75 0 6 3
325 0 2.8888888889 8.125 2 8 1
325 0 3.4444444444 5.875 0 8 2
325 0 3.5 2.875 1 8 3
329 0 3.5555555556 6.75 0 9 1
329 1 3.6666666667 5 0 9 2
329 1 3.4444444444 7.5 0 9 3
331 1 2.5 7.125 2 4 1
331 1 2.8333333333 6.125 0 4 2
331 0 3.8333333333 3 1 4 3
332 0 2.8888888889 5.875 1 8 1
332 1 3.0555555556 7.25 1 8 2
332 0 3.1111111111 4.75 0 8 3
334 0 3.7222222222 5.5 2 6 1
334 0 3.4444444444 4.25 3 6 2
334 0 3.5555555556 5.75 0 6 3
337 0 3.7222222222 3.5 0 8 1
337 0 4 1.625 0 8 2
337 0 4 1.125 0 8 3
338 0 3.8888888889 5.875 2 9 1
338 0 3.5555555556 6.625 0 9 2
338 0 3.3333333333 6.625 1 9 3
339 1 3.1111111111 7.125 1 6 1
339 1 2.8888888889 5.625 1 6 2
339 1 3 6.125 2 6 3
340 0 3.6111111111 6.125 1 7 1
340 1 3.6111111111 6 0 7 2
340 0 3.4444444444 5.5 0 7 3
343 1 3.5 6.875 2 7 1
343 0 3.1111111111 4.75 0 7 2
343 0 3.6666666667 4 1 7 3
344 1 3.7222222222 6.25 1 8 1
344 1 3.7777777778 3.125 1 8 2
344 0 3.7222222222 4.625 0 8 3
345 0 4 3.875 1 9 1
345 0 4 2.125 1 9 2
345 0 4 1 0 9 3
346 1 3.2777777778 7.75 1 3 1
346 1 3.5 7.75 0 3 2
346 1 2.6111111111 7.75 1 3 3
348 0 3 6.625 2 8 1
348 0 3.3333333333 7 1 8 2
348 0 3.5555555556 7.125 1 8 3
349 1 3.5 5 1 7 1
349 0 3.9444444444 4.625 0 7 2
349 0 4 4.5 0 7 3
350 1 2.6111111111 7.75 3 1 1
350 1 2.8333333333 5.875 1 1 2
350 1 3.2777777778 6.5 1 1 3
351 0 3.7777777778 3 0 9 1
351 0 4 1 0 9 2
351 0 3.7777777778 1 0 9 3
354 1 3.2777777778 6.25 1 9 1
354 1 3.2777777778 3.625 1 9 2
354 0 3.4444444444 2.625 0 9 3
356 0 2.7222222222 8.125 1 1 1
356 1 2.8888888889 8.25 0 1 2
356 0 2.7222222222 7.75 0 1 3
360 0 3.4444444444 9.5 1 8 1
360 0 3.5555555556 7.75 0 8 2
360 0 3.5 5.375 2 8 3
364 0 2.6666666667 6.125 1 6 1
364 0 3.6111111111 5.75 1 6 2
364 0 4 3.125 2 6 3
365 0 3.5555555556 5.875 0 8 1
365 0 3.5555555556 3.5 0 8 2
365 0 3.6111111111 4.75 0 8 3
366 1 3.4444444444 7.25 0 9 1
366 0 3.4444444444 6.5 1 9 2
366 0 3.1666666667 3.75 0 9 3
368 0 3.5 4.5 0 9 1
368 0 3.9444444444 3.25 0 9 2
368 0 4 1 0 9 3
369 1 3.5 6.625 3 9 1
369 0 3.1666666667 6.375 2 9 2
369 0 3.5 7.75 2 9 3
371 0 3 7.375 2 9 1
371 0 3.6111111111 7.75 5 9 2
371 0 3.6666666667 7.125 3 9 3
372 0 2.7777777778 6.5 2 9 1
372 0 3.0555555556 6.5 1 9 2
372 0 2.3888888889 6.25 1 9 3
373 0 3.2777777778 7.25 0 8 1
373 1 3.2222222222 6.625 1 8 2
373 1 3.7222222222 5.125 2 8 3
374 0 2.9444444444 7.375 2 3 1
374 0 3.5555555556 6.75 1 3 2
374 0 3.3888888889 5.625 0 3 3
375 0 2.2777777778 7.5 1 9 1
375 0 3 5.125 0 9 2
375 0 3.2222222222 7.375 0 9 3
377 0 3.4444444444 7.625 3 8 1
377 0 3.7777777778 7.125 1 8 2
377 0 3.7777777778 7.625 1 8 3
378 1 2.7222222222 6.25 1 9 1
378 0 2.8333333333 3.625 1 9 2
378 0 3.2222222222 2 1 9 3
379 0 2.8888888889 2.25 0 7 1
379 0 3.6111111111 2.25 1 7 2
379 0 3.2777777778 4.25 0 7 3
380 0 3.2222222222 4.5 1 9 1
380 0 2.9444444444 2.375 2 9 2
380 0 3.5 3.5 2 9 3
382 1 2.6111111111 7.75 0 9 1
382 0 3.2222222222 7.125 0 9 2
382 0 3.7222222222 7.75 1 9 3
383 1 2.5555555556 7.375 1 3 1
383 1 3.0555555556 5.625 0 3 2
383 0 3.5555555556 5.5 0 3 3
386 1 3.5 5.875 3 8 1
386 1 3.8333333333 4.75 4 8 2
386 0 4 1 2 8 3
387 0 2.8888888889 7.75 1 0 1
387 0 3 5 0 0 2
387 0 3.5 1 1 0 3
392 0 2.9444444444 6.25 1 8 1
392 0 2.7777777778 3.375 1 8 2
392 1 2.9444444444 5.875 1 8 3
393 1 2.9444444444 9.25 0 3 1
393 1 3.6666666667 8.875 1 3 2
393 1 3.2222222222 7.375 2 3 3
394 0 2.7777777778 7.75 0 9 1
394 0 3.0555555556 5.625 0 9 2
394 1 2.4444444444 7.25 0 9 3
395 0 3.3888888889 6.375 0 8 1
395 0 3.8333333333 5.5 2 8 2
395 0 3.5555555556 5.25 1 8 3
397 1 2.9444444444 8.375 2 6 1
397 1 3.7222222222 7 0 6 2
397 1 3.5555555556 7.125 0 6 3
398 1 3.3333333333 7.125 0 7 1
398 1 3.6111111111 5.125 0 7 2
398 1 3.6666666667 2.625 0 7 3
399 0 3.3888888889 4.875 1 8 1
399 0 3.5 5 1 8 2
399 0 3.7777777778 4.125 0 8 3
401 1 3.1666666667 7.5 0 8 1
401 0 3.2222222222 5.375 0 8 2
401 0 3 7.125 1 8 3
402 1 3 6 0 9 1
402 0 3.5 7.5 0 9 2
402 0 3.5555555556 6.5 0 9 3
404 0 3.9444444444 3.625 1 8 1
404 0 3.9444444444 3.625 0 8 2
404 0 4 1.25 0 8 3
406 0 3.4444444444 6.5 1 9 1
406 0 3.5555555556 6.125 1 9 2
406 0 3.8888888889 2.375 0 9 3
409 0 3.8888888889 2.625 0 9 1
409 0 4 2.125 0 9 2
409 0 3.6666666667 1.375 0 9 3
410 1 3.3888888889 7.75 0 5 1
410 0 3.0555555556 7.75 0 5 2
410 0 3.2777777778 7.75 0 5 3
411 0 3.3333333333 8 1 5 1
411 1 3.6111111111 7.375 0 5 2
411 0 2.8888888889 7.75 0 5 3
414 0 3.2222222222 5.875 0 5 1
414 0 3.6111111111 6.125 0 5 2
414 0 3.9444444444 6.625 1 5 3
415 0 3.7777777778 6.25 0 9 1
415 0 3.9444444444 2.625 0 9 2
415 0 3.4444444444 2.875 0 9 3
418 0 3.7222222222 5.75 0 6 1
418 0 3.2222222222 5.875 0 6 2
418 0 3.6666666667 5.25 0 6 3
419 0 3.6111111111 6.5 0 8 1
419 0 4 1.75 0 8 2
419 0 4 4 0 8 3
420 1 3.5 6.625 0 2 1
420 1 2.7222222222 6.125 1 2 2
420 1 3.3888888889 6 0 2 3
423 0 3.9444444444 6.125 0 8 1
423 0 4 3.5 0 8 2
423 0 4 2.5 0 8 3
424 1 3.6666666667 7 1 6 1
424 1 3.6666666667 5.375 0 6 2
424 1 3.6666666667 5.875 1 6 3
425 1 3.3333333333 7.75 1 7 1
425 1 3.3333333333 7.75 0 7 2
425 1 3.5555555556 6.25 1 7 3
428 0 2.8333333333 5.625 0 8 1
428 0 3.1666666667 6.875 0 8 2
428 0 2.6111111111 7.75 1 8 3
434 1 3.3333333333 5.875 0 9 1
434 0 3.8333333333 7.375 0 9 2
434 0 4 6.625 1 9 3
435 0 3.5555555556 4.5 0 6 1
435 0 3.4444444444 2.375 2 6 2
435 0 3.5555555556 3.625 0 6 3
437 1 3.1111111111 7.75 1 9 1
437 1 2.3333333333 8.875 0 9 2
437 1 2.3333333333 7.75 1 9 3
438 0 3.5555555556 5.375 0 9 1
438 0 3.6111111111 6.125 0 9 2
438 0 4 4.5 0 9 3
441 1 3.2777777778 6.625 0 6 1
441 1 3.6666666667 6.75 0 6 2
441 1 3.2777777778 6.875 1 6 3
443 1 3.5 7.625 3 8 1
443 0 3.6111111111 2.125 2 8 2
443 0 3.5 4.125 0 8 3
445 0 3.3333333333 8.875 0 4 1
445 1 3.7222222222 7.75 2 4 2
445 1 3.3333333333 2.5 3 4 3
447 1 2.6666666667 7.25 2 3 1
447 1 2.9444444444 4.5 0 3 2
447 1 2.7777777778 2.375 1 3 3
448 0 3.2777777778 7.75 0 9 1
448 0 3.9444444444 6.125 0 9 2
448 0 3.7222222222 4.875 0 9 3
450 1 3.4444444444 7.375 1 8 1
450 1 3.2777777778 7.25 0 8 2
450 0 2.6666666667 7.625 1 8 3
451 0 3.6666666667 7.75 1 9 1
451 1 2.9444444444 7 1 9 2
451 1 3.1666666667 3.875 0 9 3
453 1 3.3888888889 7.5 0 8 1
453 0 3.4444444444 6.125 0 8 2
453 0 3.6666666667 5.5 0 8 3
454 0 2.6666666667 7.75 2 6 1
454 0 3 5 1 6 2
454 0 3.1666666667 6.5 0 6 3
457 1 2.1111111111 6.625 2 6 1
457 1 2.7777777778 6.5 1 6 2
457 1 2.8888888889 6.625 1 6 3
459 0 3.4444444444 5.75 1 3 1
459 0 3.1111111111 6.75 2 3 2
459 0 3.5 2 1 3 3
460 1 2.6111111111 7.5 2 9 1
460 1 3.1666666667 3.875 1 9 2
460 1 3.5 2.625 2 9 3
461 1 3.2222222222 7.625 0 7 1
461 0 3.7222222222 7.25 0 7 2
461 0 3.8888888889 3 0 7 3
462 1 3.6111111111 6.625 1 6 1
462 1 2.8333333333 7.75 3 6 2
462 1 2.5555555556 6.875 0 6 3
463 1 2.7777777778 8 0 7 1
463 1 2.5555555556 5.625 0 7 2
463 1 3.6111111111 5 0 7 3
464 0 2.9444444444 6.375 0 7 1
464 0 2.5555555556 7.75 1 7 2
464 0 2.9444444444 6.875 0 7 3
468 0 2.9444444444 3.75 3 7 1
468 1 3.3888888889 3.125 0 7 2
468 0 3.7222222222 2.5 2 7 3
469 1 3.5 6.75 0 8 1
469 0 3.8888888889 5.125 1 8 2
469 0 4 6.25 1 8 3
470 0 3.2777777778 7 1 5 1
470 0 3.1666666667 4.5 0 5 2
470 0 3.3888888889 5.125 2 5 3
471 1 2.9444444444 6.25 1 8 1
471 0 3.7222222222 6.375 1 8 2
471 1 3.2222222222 5 1 8 3
473 0 3.5 7.75 0 7 1
473 0 3.7222222222 6.5 1 7 2
473 0 3.5 7.5 0 7 3
474 1 3.1111111111 7.25 0 9 1
474 0 3.1111111111 7.75 2 9 2
474 0 3.6666666667 1 1 9 3
482 1 3.1666666667 6.625 0 4 1
482 0 3 7.25 0 4 2
482 1 3.1666666667 7.625 1 4 3
487 0 3.3888888889 7.75 0 8 1
487 0 3.5555555556 6.875 0 8 2
487 0 3.6111111111 3.75 2 8 3
488 0 3.5555555556 6 1 6 1
488 0 3 6 3 6 2
488 0 3.6666666667 1.75 2 6 3
490 0 3.5555555556 7.375 1 9 1
490 0 3.7222222222 1.625 1 9 2
490 0 3.7777777778 1 0 9 3
491 0 3.1111111111 5.75 0 9 1
491 0 3.8888888889 6.5 1 9 2
491 0 3.3888888889 2.625 0 9 3
492 0 3.2777777778 7.375 0 7 1
492 1 3.6111111111 6.375 0 7 2
492 0 3.7222222222 2.875 1 7 3
493 0 3.3333333333 6.875 1 9 1
493 0 3.4444444444 7 0 9 2
493 0 3.7777777778 5 0 9 3
495 0 3.3333333333 6.75 0 7 1
495 0 3.3333333333 7.125 1 7 2
495 0 3.2777777778 6.25 0 7 3
496 1 1.8333333333 6.75 2 6 1
496 1 2.5 6.75 0 6 2
496 0 3.6666666667 6.875 0 6 3
497 0 3.8333333333 1.25 1 9 1
497 0 3.8888888889 1.375 0 9 2
497 0 4 1 2 9 3
499 1 3.0555555556 6.75 0 5 1
499 0 3.3333333333 6.625 1 5 2
499 1 3.6666666667 5.75 0 5 3
505 1 3.3888888889 7 0 9 1
505 0 3.5 6.125 0 9 2
505 0 3.0555555556 3.5 0 9 3
506 0 3.7222222222 4.75 1 9 1
506 0 3.3333333333 2 1 9 2
506 0 3.5555555556 4.125 2 9 3
510 0 2.9444444444 4.875 3 7 1
510 1 2.7777777778 6.5 3 7 2
510 1 3.3888888889 3.875 2 7 3
514 1 3.0555555556 4.875 1 6 1
514 0 3.4444444444 1.375 1 6 2
514 0 2.9444444444 1.75 3 6 3
518 0 3.3333333333 8 0 5 1
518 1 3.5555555556 7 0 5 2
518 0 3.3888888889 6.375 0 5 3
520 0 4 2.25 0 9 1
520 0 4 2.25 0 9 2
520 0 4 3.125 1 9 3
522 1 3.1111111111 7.125 5 3 1
522 0 3.2777777778 6.625 0 3 2
522 0 2.7222222222 5.75 1 3 3
523 1 2.9444444444 6.75 0 2 1
523 0 3.3333333333 7 1 2 2
523 0 3.3333333333 5.25 0 2 3
529 1 2.5555555556 7.75 2 4 1
529 1 2.7222222222 7.375 0 4 2
529 1 3.3888888889 7.75 1 4 3
531 0 3.8888888889 4.125 0 7 1
531 0 4 3.25 1 7 2
531 0 3.7777777778 2.25 1 7 3
532 0 3.7777777778 5.875 0 9 1
532 0 4 5.375 0 9 2
532 0 4 3.125 0 9 3
536 1 2.4444444444 6.875 0 6 1
536 0 2.5555555556 5.875 0 6 2
536 1 3.5555555556 7.25 0 6 3
538 0 3.6111111111 6.5 0 8 1
538 0 3.1111111111 4.375 0 8 2
538 0 3.3888888889 4.125 0 8 3
539 0 2.3888888889 7.875 1 7 1
539 0 2.8888888889 6.75 0 7 2
539 0 3.0555555556 6.5 2 7 3
545 1 3.3333333333 7.5 0 9 1
545 1 4 5.125 0 9 2
545 1 2.8333333333 6.125 1 9 3
551 0 2.9444444444 6.125 0 9 1
551 0 3.2222222222 7.125 0 9 2
551 0 3.3888888889 2.625 0 9 3
554 0 2.7777777778 9.75 1 7 1
554 1 3.6666666667 8.75 0 7 2
554 1 3.2222222222 9.25 2 7 3
557 1 2.4444444444 7.75 0 9 1
557 1 3.0555555556 7.75 0 9 2
557 0 2.7222222222 6.375 2 9 3
558 1 3.3888888889 7.75 2 8 1
558 0 3.6111111111 7.25 1 8 2
558 0 3.6111111111 2.625 0 8 3
559 0 3.1111111111 5.125 0 8 1
559 0 3.2222222222 5.625 0 8 2
559 1 3.0555555556 6.75 5 8 3
561 0 3.6111111111 6.5 0 9 1
561 0 4 7.125 0 9 2
561 0 3.7777777778 6.625 0 9 3
562 1 3.3888888889 9.25 0 9 1
562 1 3.7222222222 6.625 0 9 2
562 1 3.9444444444 4.125 1 9 3
564 0 3.1111111111 8.875 0 7 1
564 0 3.2777777778 7.125 1 7 2
564 0 3.7222222222 6.375 0 7 3
565 0 3.1111111111 4.5 0 6 1
565 0 3.3333333333 3.25 1 6 2
565 0 3.0555555556 1.875 0 6 3
566 1 2.8333333333 5.875 1 5 1
566 0 3.2777777778 5 0 5 2
566 0 3.2222222222 5.25 1 5 3
567 0 3.7777777778 5 0 8 1
567 0 3.7777777778 3.625 1 8 2
567 0 3.5555555556 2.5 1 8 3
568 1 3.3888888889 7 3 5 1
568 1 3.4444444444 3.125 1 5 2
568 1 3.1666666667 6.875 5 5 3
569 1 3.8888888889 7.5 2 9 1
569 0 3.9444444444 7.75 0 9 2
569 0 3.5 7.5 2 9 3
570 0 3.7222222222 2.75 0 7 1
570 0 3.8888888889 2.25 0 7 2
570 0 3.6666666667 1.25 0 7 3
571 0 3.5555555556 3 0 7 1
571 0 2.9444444444 1.875 0 7 2
571 0 3.5 2.75 0 7 3
;

/*
-----------------
POSTDOC Data Set
-----------------

 Data described in Chapter 8 of P.D. Allison, "Logistic Regression
 Using the SAS System: Theory and Application."                 */

data postdoc;
input pdoc age mar doc und ag arts cits docid;
datalines;
0 29 1 362 7 0 1 2 1402
1 32 1 210 6 0 1 4 1250
1 26 1 359 6 0 0 1 1399
0 25 1 181 3 0 0 1 1221
1 30 1 429 7 0 0 1 1469
1 28 1 359 6 0 1 0 1399
1 30 1 210 4 0 0 0 1250
1 40 1 347 4 0 0 0 1387
0 30 1 210 5 0 1 2 1250
1 28 1 359 7 0 5 32 1399
0 29 1 447 4 0 0 0 1487
1 28 1 276 5 0 1 0 1316
0 41 1 261 3 0 0 0 1301
1 27 1 226 7 0 0 1 1266
1 35 1 359 6 0 0 1 1399
1 30 0 341 5 0 7 16 1381
0 28 0 226 1 0 1 1 1266
1 28 1 429 4 0 3 3 1469
0 27 0 359 3 0 0 0 1399
1 27 0 205 4 0 0 0 1245
1 27 0 276 5 0 0 0 1316
0 37 1 347 7 0 1 2 1387
1 26 1 210 7 0 1 4 1250
0 34 1 236 5 0 0 1 1276
0 35 0 359 5 0 0 1 1399
1 31 0 341 7 0 3 7 1381
1 27 0 214 6 0 0 0 1254
1 37 1 250 5 0 2 2 1290
1 26 1 261 7 0 2 7 1301
0 27 1 181 5 0 0 1 1221
1 27 1 226 4 0 0 0 1266
1 27 1 362 6 0 0 1 1402
1 30 1 347 4 0 1 2 1387
0 30 1 359 9 0 0 1 1399
0 25 0 181 3 0 1 5 1221
1 29 1 429 5 0 0 1 1469
0 25 1 210 5 0 0 1 1250
0 29 1 215 6 0 0 0 1255
0 41 1 226 4 0 0 1 1266
1 31 1 359 5 0 0 1 1399
1 29 1 341 7 0 0 0 1381
1 26 0 359 4 0 1 1 1399
0 34 1 362 4 0 3 0 1402
1 31 1 210 5 0 0 0 1250
0 29 1 226 6 0 1 0 1266
1 26 1 276 4 0 2 0 1316
0 32 1 261 4 0 0 1 1301
1 27 1 347 6 0 0 0 1387
0 36 1 276 5 0 0 0 1316
0 25 0 210 7 0 0 1 1250
1 29 1 462 7 0 1 22 1502
1 30 1 454 6 0 1 0 1494
1 33 1 252 6 0 0 0 1292
1 27 1 454 7 0 2 1 1494
0 26 1 254 6 0 0 0 1294
0 35 1 198 5 0 1 0 1238
1 32 1 454 4 0 0 1 1494
0 28 0 336 6 0 0 0 1376
1 27 0 340 8 0 0 0 1380
0 37 1 186 3 0 1 16 1226
1 28 1 462 8 0 0 1 1502
0 26 1 414 7 0 1 0 1454
1 25 1 414 7 0 1 7 1454
1 30 1 283 7 0 2 7 1323
0 26 1 255 5 0 1 0 1295
1 27 1 462 7 0 1 37 1502
0 34 1 200 3 0 0 1 1240
0 33 1 198 5 0 0 0 1238
1 28 1 0 2 0 1 1 1040
0 35 1 286 5 0 0 0 1326
1 28 1 354 6 0 2 27 1394
0 28 0 340 8 0 0 0 1380
1 27 1 462 4 0 0 0 1502
0 31 1 283 3 0 2 27 1323
0 27 1 254 4 0 0 1 1294
1 27 0 287 6 0 1 2 1327
0 36 0 186 4 0 1 0 1226
0 27 1 392 3 0 1 2 1432
0 36 1 369 7 0 1 20 1409
0 28 1 336 7 0 2 1 1376
0 31 1 286 4 0 3 8 1326
0 42 0 454 6 0 0 0 1494
1 27 1 462 7 0 0 1 1502
1 25 0 340 6 0 0 1 1380
0 38 0 283 6 0 1 5 1323
1 25 1 258 7 0 4 2 1298
0 26 1 425 7 0 2 5 1465
0 36 1 369 6 0 2 9 1409
0 33 1 340 4 0 0 1 1380
1 29 1 454 7 0 0 1 1494
1 26 0 287 6 0 2 1 1327
0 29 1 258 7 0 0 1 1298
0 25 0 425 7 0 1 4 1465
1 28 1 392 7 0 0 0 1432
1 27 1 336 4 0 1 5 1376
1 31 1 232 4 0 0 0 1272
0 25 1 454 5 0 0 0 1494
1 31 1 336 5 0 0 0 1376
1 29 1 392 4 0 0 1 1432
1 25 0 392 7 0 0 1 1432
0 25 0 336 7 0 1 10 1376
1 31 0 178 6 0 0 1 1218
1 31 1 354 6 0 1 0 1394
1 25 0 392 6 0 0 1 1432
0 29 1 232 5 0 1 2 1272
0 39 0 309 4 0 1 0 1349
1 24 1 258 3 0 0 1 1298
1 27 0 340 5 0 3 5 1380
1 29 1 287 5 0 2 2 1327
0 29 1 462 7 0 2 9 1502
0 32 1 186 4 0 2 16 1226
1 32 1 122 3 0 0 1 1162
1 27 1 251 5 0 3 5 1291
1 30 1 251 3 0 3 7 1291
0 36 1 369 7 0 1 5 1409
0 27 1 178 7 0 1 1 1218
1 41 1 462 5 0 2 25 1502
1 29 1 122 4 0 1 0 1162
1 28 0 369 5 0 3 10 1409
0 33 0 212 5 0 0 1 1252
0 33 1 252 4 0 2 1 1292
0 33 1 232 5 0 0 1 1272
0 31 1 340 5 0 0 1 1380
1 29 1 462 7 0 1 2 1502
1 26 1 354 7 0 1 2 1394
0 30 1 198 4 0 0 0 1238
0 29 1 340 5 0 0 1 1380
1 28 0 392 3 0 0 0 1432
1 32 1 454 6 0 2 14 1494
1 29 0 454 6 0 2 7 1494
1 28 1 198 4 0 0 0 1238
1 26 1 454 4 0 1 0 1494
1 25 0 354 6 0 3 6 1394
0 36 1 392 7 0 0 1 1432
1 27 1 462 7 0 1 1 1502
1 26 1 392 1 0 3 5 1432
1 35 1 232 4 0 0 0 1272
0 31 1 286 5 0 1 5 1326
1 27 1 195 6 0 1 5 1235
1 30 0 392 8 0 0 1 1432
0 30 0 287 7 0 1 3 1327
1 32 1 369 5 0 2 10 1409
1 33 1 369 7 0 0 0 1409
0 32 1 195 4 0 1 1 1235
1 25 0 336 7 0 3 5 1376
0 27 1 232 4 0 0 1 1272
1 28 1 369 6 0 2 2 1409
1 32 1 321 6 0 0 1 1361
1 26 1 336 7 0 0 1 1376
0 33 1 232 5 0 1 3 1272
0 31 1 212 3 0 0 0 1252
1 35 1 454 4 0 0 1 1494
1 34 1 232 5 0 0 1 1272
1 33 1 254 5 0 3 5 1294
0 33 1 286 5 0 0 0 1326
0 28 1 347 3 0 0 0 1387
1 26 1 462 3 0 0 1 1502
1 32 1 287 3 0 3 12 1327
1 31 1 232 3 0 0 0 1272
0 26 1 186 6 0 5 7 1226
1 27 1 195 5 0 1 0 1235
0 42 1 232 5 0 0 1 1272
0 33 1 425 5 0 1 5 1465
1 26 0 197 4 0 2 1 1237
0 25 1 186 8 0 15 74 1226
1 34 1 369 5 0 0 0 1409
1 30 1 454 5 0 0 0 1494
1 31 1 354 5 0 1 4 1394
1 28 1 454 8 0 0 0 1494
1 29 1 336 5 0 0 0 1376
0 31 1 256 4 0 1 20 1296
1 27 1 163 5 0 1 2 1203
1 34 1 163 4 0 1 0 1203
1 28 0 296 4 0 0 1 1336
1 31 1 454 6 0 1 2 1494
0 27 1 221 0 0 0 1 1261
0 31 0 0 5 0 2 15 1040
1 37 1 454 2 0 1 1 1494
0 33 1 221 6 0 0 1 1261
0 29 1 221 6 0 0 0 1261
0 33 0 454 6 0 0 1 1494
1 30 1 454 6 0 0 0 1494
0 28 1 221 6 0 3 12 1261
0 41 1 221 7 0 0 0 1261
0 30 1 454 6 0 2 3 1494
1 27 0 454 6 0 4 4 1494
1 30 1 176 3 0 1 0 1216
1 28 0 391 7 0 0 7 1431
1 37 1 348 7 0 0 1 1388
0 41 1 189 0 0 0 0 1229
1 29 1 373 6 0 0 1 1413
1 31 1 168 7 0 0 1 1208
1 32 1 296 4 0 2 10 1336
0 30 1 0 7 0 0 0 1040
0 26 1 213 5 0 0 1 1253
1 28 1 0 5 0 0 1 1040
1 28 1 286 5 0 0 1 1326
0 28 1 237 7 0 0 1 1277
0 33 1 449 4 0 1 0 1489
0 28 1 391 8 0 3 23 1431
0 27 1 237 4 0 1 1 1277
0 27 0 436 4 0 0 1 1476
1 30 1 183 4 0 0 3 1223
0 33 0 237 5 0 0 1 1277
1 39 1 183 7 0 2 11 1223
0 26 1 391 7 0 4 23 1431
1 35 1 0 7 0 0 0 1040
0 27 1 183 0 0 0 1 1223
0 29 1 237 5 0 0 1 1277
0 28 1 237 5 0 0 1 1277
1 30 1 335 4 0 0 1 1375
0 29 1 348 5 0 4 7 1388
0 28 1 366 6 0 0 2 1406
1 26 1 346 6 0 0 1 1386
1 26 1 349 7 0 0 1 1389
0 28 1 449 7 0 0 1 1489
1 32 1 130 4 0 0 4 1170
0 30 1 449 4 0 7 15 1489
1 29 1 173 4 0 0 2 1213
1 28 0 335 4 0 0 1 1375
0 26 1 183 5 0 0 0 1223
0 41 1 0 4 0 0 0 1040
1 29 1 449 7 0 1 3 1489
1 28 1 373 5 0 1 10 1413
1 27 1 166 9 0 0 1 1206
0 26 1 237 5 0 0 1 1277
0 31 1 206 7 0 0 1 1246
0 27 1 249 4 0 1 12 1289
1 26 1 449 7 0 0 1 1489
1 36 0 346 7 0 1 7 1386
0 29 1 180 3 0 0 0 1220
1 30 1 286 4 0 0 0 1326
0 33 1 348 8 0 3 20 1388
1 29 1 189 8 0 1 0 1229
1 32 1 286 5 0 0 1 1326
1 0 1 335 5 0 1 10 1375
1 25 1 373 7 0 0 1 1413
0 27 1 373 3 0 0 0 1413
0 26 0 373 7 0 0 1 1413
1 31 1 166 1 0 0 1 1206
1 30 1 166 3 0 0 0 1206
1 27 1 373 7 0 0 1 1413
1 27 1 206 6 0 0 0 1246
0 36 1 307 3 0 0 4 1347
0 31 1 391 4 0 0 0 1431
0 31 1 168 8 0 0 1 1208
0 27 1 286 8 0 0 1 1326
0 28 1 286 2 0 1 3 1326
1 27 0 436 2 0 0 1 1476
0 27 1 286 5 0 0 1 1326
1 26 1 335 4 0 1 0 1375
1 28 1 296 6 0 0 0 1336
0 32 1 215 5 0 0 0 1255
0 30 0 183 5 0 0 1 1223
0 0 1 176 5 0 0 4 1216
0 45 1 0 5 0 0 1 1040
1 31 1 0 5 0 1 11 1040
1 0 1 349 4 0 0 3 1389
0 28 1 237 5 0 0 1 1277
0 37 1 189 4 0 0 0 1229
1 30 1 189 5 0 0 0 1229
1 28 1 449 7 0 0 1 1489
0 23 1 214 6 0 0 0 1254
1 27 1 213 5 0 0 1 1253
1 26 1 335 7 0 0 3 1375
0 34 1 307 1 0 0 3 1347
0 33 1 449 7 0 2 8 1489
1 28 1 168 5 0 0 1 1208
0 33 1 286 1 0 1 1 1326
1 26 1 449 5 0 1 1 1489
0 27 1 286 5 0 0 1 1326
1 29 0 477 6 0 2 3 1517
0 30 1 260 3 0 1 1 1300
1 26 1 202 4 0 0 2 1242
0 32 1 196 7 0 1 1 1236
1 28 1 238 5 0 0 1 1278
1 33 1 477 5 0 0 0 1517
1 27 0 429 7 0 0 0 1469
1 28 1 260 4 0 0 1 1300
1 29 1 229 7 0 0 1 1269
1 26 1 322 5 0 2 11 1362
1 32 1 466 6 0 1 7 1506
0 37 1 196 6 0 2 7 1236
1 35 1 229 5 0 0 1 1269
0 33 1 256 5 0 0 1 1296
1 34 1 188 4 0 0 3 1228
0 27 0 429 6 0 0 0 1469
1 33 1 413 5 0 3 32 1453
1 31 1 477 7 0 2 1 1517
1 28 1 334 6 0 0 1 1374
1 27 0 477 7 0 0 3 1517
0 27 1 344 5 0 0 0 1384
1 29 0 334 7 0 2 0 1374
1 28 1 379 6 0 0 3 1419
1 26 1 250 3 0 0 0 1290
0 42 1 238 5 0 0 1 1278
0 31 1 238 5 0 0 0 1278
1 33 1 94 6 0 0 1 1134
1 29 1 466 5 0 0 1 1506
0 30 1 466 3 0 0 1 1506
1 37 0 250 2 0 0 0 1290
1 28 1 360 5 0 0 0 1400
1 31 1 313 4 0 0 1 1353
1 36 1 466 4 0 3 16 1506
1 28 1 254 7 0 0 1 1294
1 26 0 379 5 0 1 3 1419
1 27 1 256 9 0 0 0 1296
1 36 1 334 9 0 0 1 1374
0 29 1 173 5 0 11 33 1213
0 27 1 293 5 0 0 1 1333
1 26 1 477 7 0 0 0 1517
1 27 1 413 7 0 3 57 1453
1 30 1 293 7 0 3 8 1333
0 29 1 188 5 0 0 0 1228
1 32 1 317 4 0 1 3 1357
1 28 1 360 7 0 0 1 1400
0 31 1 466 7 0 0 1 1506
0 28 1 173 5 0 6 37 1213
1 32 1 380 7 0 0 1 1420
1 29 1 250 3 0 0 1 1290
1 26 1 229 6 0 0 1 1269
0 27 1 334 7 0 3 37 1374
0 30 1 196 6 0 0 0 1236
0 39 1 140 1 0 0 1 1180
1 33 1 229 5 0 0 1 1269
0 28 1 429 4 0 0 0 1469
1 26 0 293 5 0 6 20 1333
1 29 0 291 5 0 2 0 1331
1 27 1 322 5 0 2 11 1362
0 47 1 140 3 0 0 0 1180
0 45 1 477 7 0 6 3 1517
1 26 0 466 4 0 0 0 1506
1 27 0 466 8 0 3 11 1506
1 28 1 256 4 0 0 3 1296
1 32 1 274 4 0 0 1 1314
0 37 1 132 4 0 0 1 1172
0 29 1 229 4 0 0 0 1269
1 33 1 389 5 0 0 1 1429
0 30 1 466 5 0 1 2 1506
0 36 1 140 5 0 0 0 1180
0 37 1 334 7 0 2 17 1374
1 28 1 202 4 0 0 1 1242
1 26 1 282 3 0 3 7 1322
1 29 1 173 1 0 2 5 1213
1 27 1 0 5 0 2 8 1040
1 32 1 477 4 0 0 0 1517
0 35 1 172 4 0 0 1 1212
1 30 1 466 4 0 0 32 1506
0 28 1 254 7 0 0 0 1294
1 26 0 344 7 0 0 3 1384
0 27 1 188 6 0 5 4 1228
1 26 0 360 4 0 0 1 1400
0 33 1 174 3 0 0 0 1214
1 31 1 334 8 0 0 7 1374
0 32 1 282 4 0 3 7 1322
0 29 1 254 8 0 0 0 1294
1 29 1 466 4 0 0 0 1506
1 27 1 379 5 0 1 0 1419
1 27 1 413 7 0 0 0 1453
1 28 1 250 3 0 0 1 1290
1 31 1 173 5 0 0 3 1213
1 33 1 477 7 0 0 0 1517
0 37 1 256 4 0 1 0 1296
1 30 1 256 3 0 0 1 1296
1 27 0 429 7 1 3 9 1469
0 26 1 429 5 1 2 15 1469
1 30 1 429 4 1 4 5 1469
0 25 1 429 4 1 10 30 1469
1 29 0 429 7 1 1 1 1469
1 26 1 429 6 1 0 0 1469
1 30 1 429 5 1 2 0 1469
0 25 1 210 4 1 0 1 1250
0 32 1 429 8 1 4 5 1469
0 27 1 429 5 1 0 0 1469
0 28 1 125 3 1 2 0 1165
0 33 1 429 5 1 2 0 1469
0 27 1 429 5 1 2 7 1469
1 25 1 319 5 1 0 0 1359
0 26 1 319 5 1 0 1 1359
1 36 1 429 5 1 2 5 1469
0 26 1 429 3 1 1 1 1469
0 32 1 210 5 1 0 1 1250
1 24 1 429 4 1 2 2 1469
0 29 1 276 5 1 0 0 1316
1 27 1 429 5 1 2 20 1469
0 31 1 250 4 1 0 0 1290
1 24 0 429 5 1 3 5 1469
0 31 1 429 5 1 0 1 1469
0 36 1 250 4 1 1 0 1290
1 30 1 429 3 1 0 0 1469
0 27 1 429 3 1 1 5 1469
1 29 0 429 3 1 0 0 1469
0 29 1 429 3 1 0 0 1469
0 28 1 429 5 1 0 0 1469
0 32 1 429 5 1 0 0 1469
0 34 0 429 5 1 0 0 1469
0 38 1 429 5 1 1 0 1469
0 27 1 429 3 1 0 0 1469
0 28 1 429 5 1 1 1 1469
1 37 0 429 8 1 0 0 1469
0 32 1 429 4 1 0 0 1469
1 27 1 429 5 1 2 5 1469
0 25 0 429 5 1 0 1 1469
0 27 1 429 5 1 0 1 1469
0 34 1 429 5 1 1 2 1469
0 31 0 429 4 1 0 0 1469
1 28 0 429 6 1 1 0 1469
0 34 1 429 8 1 0 0 1469
0 25 1 429 6 1 1 2 1469
1 30 1 429 5 1 1 1 1469
0 27 1 429 5 1 1 10 1469
0 25 1 429 7 1 0 0 1469
0 29 1 429 8 1 0 1 1469
0 30 1 429 4 1 0 0 1469
1 31 1 429 6 1 1 2 1469
1 31 1 429 6 1 0 0 1469
0 26 0 429 4 1 0 0 1469
0 33 1 210 4 1 0 1 1250
0 30 1 429 7 1 1 3 1469
0 31 1 429 5 1 1 2 1469
0 36 1 296 4 1 0 1 1336
0 28 1 296 7 1 0 1 1336
0 34 1 142 6 1 3 0 1182
1 25 1 200 5 1 1 7 1240
0 38 1 168 6 1 0 0 1208
0 28 1 200 6 1 1 2 1240
1 33 1 239 6 1 0 1 1279
0 27 1 286 5 1 1 1 1326
0 31 1 296 3 1 0 1 1336
0 29 1 168 1 1 5 3 1208
0 31 1 168 4 1 1 4 1208
0 27 1 200 5 1 1 5 1240
0 28 1 296 4 1 3 10 1336
1 27 1 176 7 1 2 15 1216
0 33 1 286 5 1 0 0 1326
1 28 1 176 4 1 0 1 1216
0 32 1 286 5 1 0 0 1326
0 27 1 340 5 1 0 0 1380
1 31 1 176 4 1 2 2 1216
0 33 1 454 5 1 0 0 1494
0 27 1 200 4 1 1 2 1240
0 35 1 296 5 1 0 0 1336
0 36 1 168 4 1 2 2 1208
0 41 1 286 2 1 1 0 1326
0 27 1 296 4 1 0 0 1336
0 29 1 296 0 1 0 0 1336
0 31 1 296 2 1 3 2 1336
0 31 1 286 4 1 0 1 1326
1 26 1 168 4 1 0 1 1208
1 38 1 152 3 1 1 0 1192
1 30 1 296 4 1 1 0 1336
0 32 1 239 5 1 3 4 1279
0 33 1 239 8 1 1 1 1279
0 28 1 296 6 1 2 15 1336
0 28 1 200 3 1 2 0 1240
1 30 1 340 4 1 1 1 1380
0 29 1 286 4 1 10 23 1326
1 36 0 286 5 1 0 1 1326
1 26 1 296 4 1 0 0 1336
1 26 0 296 5 1 0 1 1336
0 32 1 296 4 1 1 5 1336
0 31 1 296 4 1 2 0 1336
0 31 1 296 4 1 0 0 1336
0 35 1 296 5 1 0 0 1336
1 34 1 436 7 1 0 1 1476
0 30 1 436 7 1 0 1 1476
1 28 1 214 4 1 0 0 1254
0 32 1 436 8 1 0 1 1476
0 26 1 436 5 1 1 6 1476
0 28 1 0 7 1 0 0 1040
0 26 1 436 2 1 3 22 1476
0 27 1 436 4 1 2 1 1476
0 29 1 436 2 1 0 0 1476
0 26 1 436 5 1 1 0 1476
1 28 0 436 7 1 0 0 1476
1 26 0 436 4 1 0 0 1476
0 36 1 436 7 1 0 0 1476
0 26 1 436 5 1 0 1 1476
1 35 0 436 9 1 0 0 1476
1 26 1 436 7 1 0 1 1476
0 34 1 436 5 1 0 2 1476
1 28 1 392 5 1 1 1 1432
1 30 1 436 5 1 0 2 1476
0 29 1 436 4 1 0 2 1476
0 29 1 436 4 1 0 1 1476
0 32 1 214 4 1 0 1 1254
0 32 1 130 3 1 3 6 1170
0 34 1 237 5 1 0 0 1277
0 28 1 436 4 1 0 0 1476
1 27 0 436 4 1 0 1 1476
1 26 1 436 5 1 2 7 1476
0 40 1 180 8 1 7 3 1220
0 27 1 436 3 1 1 6 1476
0 30 1 436 3 1 0 1 1476
1 27 1 436 7 1 0 1 1476
0 28 0 436 5 1 2 3 1476
0 31 1 436 3 1 0 0 1476
0 27 1 436 4 1 0 1 1476
0 30 1 436 5 1 0 1 1476
0 32 1 237 5 1 0 1 1277
0 31 1 436 5 1 1 2 1476
1 26 1 436 3 1 0 0 1476
1 26 1 436 3 1 0 0 1476
0 27 1 436 4 1 0 0 1476
1 27 1 436 5 1 1 2 1476
0 26 1 436 5 1 0 0 1476
0 31 1 214 5 1 0 0 1254
1 28 1 392 4 1 1 5 1432
0 28 1 340 3 1 0 1 1380
0 34 1 217 4 1 0 1 1257
1 35 1 317 8 1 0 1 1357
1 31 1 333 7 1 2 4 1373
0 27 1 186 4 1 0 3 1226
1 40 1 249 5 1 0 0 1289
0 28 1 333 5 1 0 1 1373
1 32 1 317 5 1 0 1 1357
1 28 1 249 7 1 5 0 1289
1 27 1 333 4 1 4 0 1373
0 32 1 333 5 1 0 1 1373
1 26 1 340 6 1 0 1 1380
0 27 1 333 4 1 4 0 1373
0 30 1 333 5 1 1 1 1373
0 29 1 186 2 1 0 0 1226
0 34 1 249 8 1 0 0 1289
0 26 1 174 2 1 0 0 1214
0 28 1 186 4 1 0 1 1226
1 29 1 340 5 1 0 0 1380
0 26 1 186 7 1 3 13 1226
0 26 1 186 5 1 1 0 1226
1 34 1 217 7 1 0 0 1257
0 28 1 217 4 1 0 0 1257
0 28 1 317 4 1 0 1 1357
0 30 1 317 5 1 0 2 1357
0 31 1 317 5 1 0 0 1357
0 32 1 217 5 1 1 7 1257
0 34 1 160 3 1 0 1 1200
1 31 1 333 5 1 0 1 1373
1 27 1 340 5 1 0 0 1380
1 27 1 333 5 1 0 1 1373
0 30 1 333 3 1 0 0 1373
0 34 1 174 3 1 0 1 1214
0 43 1 217 3 1 1 6 1257
0 28 1 217 3 1 0 4 1257
0 40 1 217 3 1 2 3 1257
0 28 1 317 4 1 0 0 1357
0 31 1 186 4 1 0 1 1226
0 38 1 174 7 1 0 0 1214
0 32 1 0 3 1 0 1 1040
1 28 1 249 4 1 0 0 1289
1 29 0 333 4 1 0 2 1373
1 34 1 340 4 1 0 1 1380
1 25 0 333 7 1 0 0 1373
0 27 1 333 3 1 0 0 1373
1 29 0 317 5 1 0 0 1357
0 29 1 340 4 1 4 9 1380
1 27 0 340 5 1 2 40 1380
0 29 1 217 6 1 0 0 1257
;


/*
-----------------
CASECONT Data Set
-----------------

 Data described in Chapter 8 of P.D. Allison, "Logistic Regression
 Using the SAS System: Theory and Application."                 */


data casecont;
input pubhouse staybaby black kids doubleup age days casenum;
datalines;
0 1 1 0 1 17.5 8 1994662001
0 0 1 1 1 18.3 8 1994662001
0 1 0 2 1 20.9 10 0189633001
0 0 0 1 0 32.9 10 0189633001
0 1 0 1 0 29.5 10 4435941001
0 0 1 2 1 31.8 10 4435941001
0 1 1 5 0 39.3 11 4257996002
0 0 0 1 0 34.9 11 4257996002
0 1 1 3 0 19.6 12 1761045001
0 0 0 1 1 20 12 1761045001
0 1 0 0 0 33.5 13 1572302001
0 0 1 1 1 21.9 13 1572302001
0 1 0 1 0 28.6 20 4293147001
0 0 1 1 1 20.2 20 4293147001
0 1 0 2 1 21.9 20 2903906001
0 0 1 1 0 35.7 20 2903906001
0 1 0 1 1 32.2 24 4124206001
0 0 1 1 0 22.3 24 4124206001
0 1 1 1 1 21.7 24 7916104001
0 0 1 1 1 20.8 24 7916104001
0 1 1 1 0 34.5 25 3927579001
0 0 1 0 0 31.4 25 3927579001
0 1 0 2 0 21.9 27 0730299001
0 0 1 5 0 27.2 27 0730299001
0 1 1 1 0 24.5 29 3746460001
0 0 0 3 0 26.4 29 3746460001
0 1 1 0 0 21.4 30 0580478001
0 0 0 1 1 20 30 0580478001
0 1 1 0 1 33.3 32 2303908001
0 0 0 3 0 29.3 32 2303908001
0 1 1 4 0 31.2 33 7519841001
0 0 0 3 0 36.1 33 7519841001
0 1 1 2 1 24 37 2209519001
0 0 1 0 0 31.7 37 2209519001
0 1 1 0 1 23.4 43 1810812001
0 0 0 1 0 27 43 1810812001
0 1 1 2 1 20.8 47 7965349001
0 0 1 1 1 24.7 47 7965349001
0 1 1 2 0 31.3 48 2295122001
0 0 1 1 1 25.2 48 2295122001
0 1 1 2 1 19.1 49 0983099001
0 0 0 2 1 20.9 49 0983099001
0 1 0 1 0 33.4 49 1519891001
0 0 1 1 0 21.2 49 1519891001
0 1 1 1 0 23.4 50 2865609001
0 0 1 0 0 25.5 50 2865609001
0 1 1 2 0 18.3 51 1635962001
1 0 0 2 0 32 51 1635962001
0 1 1 0 1 22.8 52 1935108001
0 0 0 1 0 24 52 1935108001
0 1 1 0 1 36.9 52 3047688001
0 0 1 1 1 24.3 52 3047688001
0 1 1 0 1 28.4 53 0297136001
0 0 1 0 0 26.4 53 0297136001
0 1 1 1 1 31 53 1694088001
0 0 1 3 0 23.1 53 1694088001
0 1 1 0 0 25.1 56 2116214001
0 0 1 3 0 26.7 56 2116214001
0 1 0 0 1 19.7 57 0889130001
0 0 1 1 1 18 57 0889130001
0 1 1 0 0 36.1 57 4562521001
0 0 1 1 1 17.3 57 4562521001
0 1 1 1 0 28.1 59 4241896001
1 0 1 1 0 28.5 59 4241896001
0 1 1 1 1 29.2 61 4331000001
0 0 0 6 0 29.3 61 4331000001
0 1 1 0 0 35.4 65 7658765001
1 0 0 3 0 22.3 65 7658765001
0 1 1 0 1 19.2 66 1667448001
0 0 1 1 0 28.7 66 1667448001
0 1 0 2 0 32.9 69 9004699002
0 0 0 0 0 26.2 69 9004699002
0 1 0 1 1 20.2 70 0369266001
0 0 1 0 0 27.5 70 0369266001
0 1 0 1 1 22.2 73 1436877001
0 0 0 5 0 22.9 73 1436877001
0 1 1 0 0 31.5 74 7859699001
0 0 0 2 0 30.1 74 7859699001
0 1 1 2 0 20.7 77 1905357001
0 0 0 5 0 33.3 77 1905357001
0 1 1 2 1 22.1 78 4652205001
0 0 0 1 0 23.6 78 4652205001
0 1 0 1 0 30.1 79 1746552001
0 0 0 2 0 30.3 79 1746552001
0 1 0 0 0 22.8 80 1727263001
0 0 0 2 1 39.8 80 1727263001
0 1 1 0 1 21.9 80 7996036001
0 0 1 2 1 21 80 7996036001
0 1 1 1 1 21.5 82 1929279001
0 0 0 3 0 23.5 82 1929279001
0 1 0 2 0 19.8 83 0362037001
0 0 0 1 1 18.5 83 0362037001
0 1 0 3 0 31.6 85 1456525001
0 0 1 3 0 31.4 85 1456525001
0 1 1 0 0 27.9 85 4375368001
0 0 1 1 1 31.8 85 4375368001
0 1 1 0 1 21.4 85 1852047001
0 0 0 2 1 27.3 85 1852047001
0 1 1 0 0 35.1 86 7850861001
1 0 1 0 0 21.8 86 7850861001
0 1 1 1 0 28.2 86 1301302001
0 0 1 3 1 23.6 86 1301302001
0 1 1 1 0 24.1 89 7561061001
1 0 0 0 0 23.8 89 7561061001
0 1 0 1 0 31.1 91 2261227001
0 0 0 2 0 35.1 91 2261227001
0 1 1 2 1 36.1 91 1475710001
0 0 0 2 0 30.5 91 1475710001
0 1 1 1 1 26.1 91 1215277001
0 0 1 3 0 24.3 91 1215277001
0 1 1 0 0 27.6 92 1519320001
0 0 0 0 0 34.1 92 1519320001
0 1 1 3 0 24.8 92 1345657001
0 0 1 1 1 22 92 1345657001
0 1 1 1 1 25.9 96 1122849001
0 0 0 0 1 25.2 96 1122849001
1 1 0 1 0 27.1 96 4533577001
1 0 1 1 0 34 96 4533577001
0 1 1 1 1 39.5 100 3871250001
1 0 1 2 0 24.4 100 3871250001
0 1 1 3 0 28.2 100 7391358001
1 0 1 2 0 33.2 100 7391358001
0 1 1 2 1 18.2 102 1967372001
1 0 1 3 0 25.6 102 1967372001
0 1 0 1 1 18.9 106 1806002001
1 0 0 3 0 36.3 106 1806002001
1 1 1 5 0 34.8 108 7919033001
1 0 0 1 0 29.8 108 7919033001
0 1 1 0 1 21.4 108 1547198001
0 0 0 1 0 29.1 108 1547198001
0 1 1 1 1 20.9 110 1878284001
0 0 0 0 1 23.5 110 1878284001
1 1 1 0 0 22.3 110 0898270001
0 0 1 2 1 25.8 110 0898270001
0 1 1 0 1 22.8 114 7502994001
0 0 0 1 0 21 114 7502994001
0 1 0 0 1 21.8 117 1970136001
1 0 0 2 0 29.4 117 1970136001
0 1 1 1 1 23.7 117 7716837001
0 0 1 2 0 27.6 117 7716837001
1 1 1 1 0 22.3 117 1466749001
0 0 0 0 1 23.1 117 1466749001
1 1 1 3 0 33.3 118 1698420001
0 0 0 1 0 21 118 1698420001
0 1 0 2 1 21.4 118 2527222002
0 0 0 0 0 32.7 118 2527222002
0 1 1 1 0 28.3 119 0164907001
0 0 0 5 0 22.6 119 0164907001
0 1 1 1 1 26.5 127 3373133001
1 0 0 3 0 29.2 127 3373133001
0 1 0 1 1 22.1 127 7614292001
1 0 0 2 1 21.9 127 7614292001
0 1 0 1 0 24.9 128 0684409001
1 0 0 1 1 25.4 128 0684409001
1 1 0 3 0 19.5 128 0445294001
1 0 0 1 1 19.8 128 0445294001
0 1 1 1 0 32.8 128 4068451001
1 0 0 1 1 22 128 4068451001
1 1 0 2 0 21.8 131 7995111001
1 0 1 1 0 29.8 131 7995111001
0 1 1 2 0 32.4 132 4661592001
1 0 1 4 0 38.4 132 4661592001
1 1 0 3 1 21.9 133 1363106001
1 0 1 3 0 21.5 133 1363106001
0 1 1 1 0 30.7 134 4199467001
1 0 1 12 0 36.3 134 4199467001
0 1 1 1 0 31 136 7341956001
0 0 1 0 0 27.6 136 7341956001
1 1 1 3 0 35.1 138 1470104001
1 0 1 1 0 20.3 138 1470104001
0 1 1 1 1 26.7 139 4239367001
0 0 0 2 0 32 139 4239367001
0 1 1 3 1 29.6 139 4633536001
0 0 1 3 1 27.5 139 4633536001
0 1 0 1 1 17.8 141 0490695001
1 0 0 1 0 20.6 141 0490695001
0 1 0 0 0 23.3 142 0662606001
1 0 1 2 0 29.6 142 0662606001
0 1 0 0 1 29.7 142 1754432001
0 0 1 1 0 24.4 142 1754432001
1 1 1 0 1 19 142 1230826001
1 0 1 1 0 23.9 142 1230826001
0 1 1 1 0 26.8 144 0023696001
1 0 1 1 0 19.4 144 0023696001
0 1 1 2 0 26.6 144 7939386001
0 0 0 2 0 35.8 144 7939386001
0 1 1 1 1 21.9 145 1539273001
1 0 0 3 0 21.1 145 1539273001
0 1 1 0 0 31.6 147 7821285001
1 0 0 4 0 31.6 147 7821285001
0 1 1 2 0 30.3 149 0432617001
0 0 1 1 0 23.9 149 0432617001
0 1 0 1 1 19.8 150 1362111001
0 0 1 1 0 22.7 150 1362111001
0 1 1 2 0 25.6 152 0189075001
0 0 1 3 0 24.3 152 0189075001
0 1 1 1 0 30.7 155 0003730001
0 0 1 1 0 22.6 155 0003730001
0 1 0 1 1 27.2 156 1594095001
0 0 1 6 0 32.3 156 1594095001
0 1 1 1 0 25.1 156 7609157001
0 0 1 1 0 34.5 156 7609157001
1 1 1 1 1 18.2 157 1267282001
1 0 1 2 0 30.1 157 1267282001
0 1 1 5 0 28.6 160 7687941001
0 0 1 2 0 23.1 160 7687941001
1 1 0 1 1 22.5 163 1835822001
1 0 0 2 0 25 163 1835822001
1 1 1 1 1 21.9 164 1141988001
0 0 0 3 0 29.9 164 1141988001
0 1 1 1 1 17.1 164 2832145001
0 0 1 0 0 27.2 164 2832145001
0 1 1 1 0 39.6 167 1635924001
0 0 0 1 0 18.7 167 1635924001
0 1 1 1 1 22.9 168 0948601001
1 0 1 1 1 20.5 168 0948601001
1 1 1 1 0 18.4 169 1508645001
1 0 1 1 0 22.9 169 1508645001
1 1 0 1 0 19.1 169 1777667001
0 0 0 1 1 20.2 169 1777667001
0 1 1 1 0 27.9 169 0596666001
0 0 0 1 0 19.6 169 0596666001
1 1 1 2 0 22.7 169 0001174001
0 0 1 4 0 23.1 169 0001174001
1 1 1 1 1 21.6 169 0773363001
1 0 0 2 1 22.8 169 0773363001
0 1 1 1 0 26.2 170 3022378001
1 0 0 3 0 28 170 3022378001
1 1 1 5 0 31.8 171 4306557001
1 0 1 1 1 19.6 171 4306557001
0 1 1 1 0 26.6 176 1846426001
1 0 0 2 0 27.6 176 1846426001
0 1 0 2 1 21.3 177 1802584001
1 0 1 0 0 22.2 177 1802584001
1 1 1 3 0 29.5 178 4229126001
0 0 0 2 0 21.7 178 4229126001
0 1 1 1 0 30.3 178 4049567001
0 0 1 1 0 19 178 4049567001
0 1 0 1 1 24 180 0640571001
1 0 0 1 0 26.9 180 0640571001
0 1 1 2 0 25.5 181 4470934001
1 0 1 3 0 18.2 181 4470934001
0 1 1 2 1 31.8 182 4129019001
1 0 1 1 1 21.3 182 4129019001
0 1 1 1 1 19 182 4592706001
1 0 1 1 1 23.7 182 4592706001
1 1 0 3 1 27.2 182 4383806001
1 0 1 2 0 36.2 182 4383806001
1 1 1 2 0 20.3 183 7838487001
1 0 0 1 0 24.5 183 7838487001
0 1 1 5 0 31.5 184 3914397001
0 0 0 2 1 22.9 184 3914397001
0 1 1 1 1 26.3 185 1133959001
1 0 1 1 1 21 185 1133959001
1 1 1 5 0 31.3 185 1590840001
0 0 1 1 0 27.9 185 1590840001
1 1 1 1 0 19 186 1008715001
0 0 1 1 1 28.1 186 1008715001
1 1 0 1 1 21.1 186 0664028001
1 0 1 2 1 27.3 186 0664028001
0 1 1 1 1 28.9 187 4547130001
1 0 1 0 0 35.2 187 4547130001
1 1 1 2 1 19.6 189 0204602001
0 0 0 1 0 22.8 189 0204602001
0 1 1 2 1 21.1 189 0567999001
0 0 1 1 1 25.3 189 0567999001
1 1 1 0 0 20.6 190 7963224001
1 0 1 2 0 30.9 190 7963224001
0 1 1 1 1 25.3 190 1822666001
1 0 1 5 0 35.3 190 1822666001
1 1 1 0 0 25.5 191 4412324001
1 0 1 1 0 24.6 191 4412324001
1 1 1 2 0 26.8 193 2253908001
1 0 1 1 1 22.6 193 2253908001
0 1 1 1 0 16.8 194 1155528001
0 0 1 1 1 19.5 194 1155528001
1 1 1 1 0 19.3 194 0770889001
0 0 1 3 0 38.7 194 0770889001
1 1 1 12 0 37 196 3526633001
1 0 1 0 1 20.9 196 3526633001
0 1 1 4 0 38.2 196 3586325001
1 0 0 2 1 29.8 196 3586325001
0 1 1 2 0 20.4 196 0228844001
0 0 0 2 0 19.1 196 0228844001
0 1 0 2 1 22 197 7840511001
0 0 0 1 1 18.1 197 7840511001
0 1 1 3 0 29.4 197 4294639001
1 0 1 1 0 18.9 197 4294639001
1 1 0 1 0 17.1 197 1551454001
1 0 0 1 0 27.7 197 1551454001
1 1 1 1 0 25 198 0804512001
0 0 1 1 0 18.5 198 0804512001
0 1 1 0 0 28 198 4433425001
1 0 1 1 0 17.9 198 4433425001
1 1 1 2 0 21 198 7594108001
1 0 1 1 1 26.5 198 7594108001
1 1 1 2 0 30.9 199 1162387001
1 0 0 2 0 22.2 199 1162387001
1 1 0 1 1 29.6 200 4280379001
0 0 0 2 0 25.1 200 4280379001
0 1 1 1 1 23.6 200 4649735001
1 0 1 3 0 25.4 200 4649735001
1 1 1 1 1 20.1 200 1555531001
1 0 0 1 1 18.8 200 1555531001
1 1 1 2 1 19.8 200 1046010001
0 0 0 1 0 25.3 200 1046010001
1 1 1 1 0 22.7 201 1121267001
1 0 1 1 0 22.8 201 1121267001
0 1 1 2 1 31.3 201 1474137001
0 0 1 1 0 33.3 201 1474137001
1 1 1 2 0 18.1 201 0025856001
1 0 0 1 1 20.3 201 0025856001
1 1 0 6 0 29.5 201 4198354001
1 0 1 1 0 20.8 201 4198354001
1 1 1 2 1 26.7 201 2547305007
1 0 1 2 1 20.7 201 2547305007
1 1 0 1 1 23.3 201 7437790001
0 0 1 3 0 24.3 201 7437790001
1 1 1 3 0 38.6 203 1635644001
1 0 1 4 0 26.2 203 1635644001
0 1 1 2 1 20.4 204 3569893001
1 0 0 3 0 34.4 204 3569893001
1 1 1 2 0 19.8 205 0741874001
0 0 0 3 1 25.2 205 0741874001
0 1 1 2 1 31.7 206 4284644001
0 0 1 1 1 23 206 4284644001
1 1 1 1 1 20.9 207 1752013001
1 0 0 2 0 21.4 207 1752013001
0 1 1 2 1 19.8 207 0133155001
0 0 1 1 0 21.8 207 0133155001
1 1 0 1 0 29 207 4205299001
1 0 1 1 0 25 207 4205299001
1 1 1 3 0 28.2 209 4367351001
1 0 1 1 1 21.1 209 4367351001
0 1 1 1 0 25 210 1633092001
0 0 1 1 1 33.7 210 1633092001
1 1 1 1 1 26.6 210 1801923001
1 0 0 1 1 26.4 210 1801923001
1 1 1 2 1 18.4 210 1092249001
1 0 1 3 1 22.5 210 1092249001
0 1 0 1 0 22.6 210 1073207001
0 0 0 4 1 24.1 210 1073207001
1 1 1 2 0 18.9 210 0630267001
1 0 0 2 0 29 210 0630267001
1 1 0 0 0 17.3 211 0987910001
1 0 1 1 1 32.6 211 0987910001
1 1 0 3 1 21.3 211 0845195001
1 0 1 2 1 27.5 211 0845195001
0 1 1 2 0 23.7 212 1070994001
1 0 0 2 0 22.6 212 1070994001
1 1 1 1 1 28.7 212 1596404001
1 0 1 0 0 37.6 212 1596404001
0 1 1 1 1 22.3 213 7310869001
1 0 1 1 1 18.7 213 7310869001
1 1 1 1 0 21.4 213 0444499001
1 0 1 3 0 38.2 213 0444499001
1 1 0 1 0 32 214 7942905001
1 0 1 4 0 22.6 214 7942905001
1 1 1 3 1 22.4 214 4443927001
1 0 0 3 1 25.1 214 4443927001
1 1 1 2 0 23.6 215 7928861001
0 0 1 1 1 30 215 7928861001
0 1 1 1 0 28.6 216 7482118001
1 0 0 3 1 26.1 216 7482118001
1 1 1 3 0 29 217 1270469001
1 0 1 5 0 23.7 217 1270469001
0 1 0 2 0 35.6 217 1160065001
0 0 1 1 1 28.4 217 1160065001
1 1 1 1 0 26.1 218 7311526001
1 0 1 3 0 27.1 218 7311526001
1 1 0 1 0 19.6 218 1748636001
1 0 1 3 0 32.3 218 1748636001
1 1 0 1 1 20.2 218 7687848001
0 0 1 1 1 20.2 218 7687848001
1 1 1 3 1 21.9 219 1218801001
1 0 1 1 0 33.4 219 1218801001
1 1 0 5 0 35.2 220 3621915001
0 0 0 0 1 23 220 3621915001
1 1 1 1 1 18.8 221 0746182001
1 0 1 3 0 31.5 221 0746182001
1 1 1 1 0 28.7 222 0213502001
1 0 1 2 1 22.8 222 0213502001
1 1 1 4 0 30.2 222 4289602001
0 0 0 3 0 26.2 222 4289602001
1 1 1 2 1 23.9 224 1121103001
1 0 0 2 1 23.2 224 1121103001
1 1 1 5 1 29.6 224 4261597002
1 0 1 3 1 24.8 224 4261597002
1 1 0 2 0 19 224 0021992001
0 0 1 2 1 20.6 224 0021992001
1 1 1 3 1 27.1 225 1514260001
0 0 1 1 1 20.6 225 1514260001
0 1 1 4 0 36.6 225 3397497001
1 0 1 3 0 36.1 225 3397497001
1 1 0 3 0 22.6 225 7414780001
0 0 1 0 0 31.2 225 7414780001
1 1 1 1 1 30.2 226 4546355001
1 0 0 3 0 30.1 226 4546355001
0 1 0 1 0 25.2 226 1293429001
1 0 0 3 0 35.3 226 1293429001
1 1 0 2 1 21 226 1098133001
1 0 1 1 0 23.2 226 1098133001
1 1 0 5 1 25.4 226 4311934001
1 0 1 1 0 21.7 226 4311934001
1 1 1 1 1 30.9 226 4129198001
1 0 1 1 0 37.7 226 4129198001
0 1 1 3 1 24.3 227 4496339001
1 0 0 2 0 23.4 227 4496339001
1 1 1 7 0 27.6 228 2618850001
1 0 1 1 0 31.3 228 2618850001
1 1 1 8 1 32 229 0623153001
1 0 0 2 1 32.7 229 0623153001
0 1 1 1 1 35.4 231 2012713001
1 0 1 2 0 37.6 231 2012713001
1 1 1 7 1 31.8 231 4056662001
1 0 1 2 1 22.8 231 4056662001
1 1 1 2 1 19.4 231 1709379001
1 0 1 2 1 24.6 231 1709379001
1 1 1 2 1 24 232 2507785003
1 0 1 2 1 34.1 232 2507785003
1 1 0 1 1 22.9 232 1420035001
1 0 1 2 0 33.4 232 1420035001
0 1 1 3 1 34.3 233 4313800001
0 0 1 1 1 22.3 233 4313800001
1 1 1 5 0 34 233 3735516001
1 0 1 0 1 34 233 3735516001
1 1 1 1 1 22.5 233 1498996001
1 0 1 0 1 36.8 233 1498996001
1 1 1 1 1 23.6 233 0868844001
1 0 0 3 0 25.8 233 0868844001
1 1 1 1 1 26.9 236 1120617001
1 0 0 1 0 33.4 236 1120617001
1 1 1 1 0 20.5 236 1407805001
1 0 1 1 1 19.2 236 1407805001
1 1 1 3 0 26.3 237 1121471001
1 0 1 2 1 29.5 237 1121471001
0 1 0 1 1 23.2 238 1968675001
1 0 1 3 0 23 238 1968675001
0 1 1 1 1 19.9 238 7307303001
1 0 0 3 0 32.1 238 7307303001
0 1 1 3 1 23.4 239 4633553001
1 0 1 1 0 22 239 4633553001
0 1 1 3 1 38.7 240 0508891001
0 0 1 3 0 29.3 240 0508891001
0 1 0 2 1 22.8 241 1315091001
0 0 1 4 0 23 241 1315091001
1 1 0 2 0 21.4 241 1019699001
0 0 1 0 1 26.7 241 1019699001
1 1 1 4 0 31.3 241 4429738001
1 0 1 2 1 23 241 4429738001
1 1 1 5 0 27.6 241 4445788001
1 0 1 3 0 26.7 241 4445788001
1 1 1 1 0 19.2 242 0802816001
1 0 1 1 1 19.2 242 0802816001
1 1 0 5 0 27.1 243 4537268001
1 0 1 3 0 33.8 243 4537268001
1 1 1 2 1 32 243 1172962001
1 0 1 0 0 32 243 1172962001
1 1 0 3 0 31.7 244 4310417001
1 0 1 2 1 19.9 244 4310417001
1 1 1 4 0 21.7 245 2466450001
0 0 0 1 1 28.8 245 2466450001
0 1 0 1 1 30.8 246 4652378001
1 0 1 2 0 33.7 246 4652378001
0 1 1 1 1 22.3 246 1019941001
1 0 1 2 1 23.2 246 1019941001
1 1 1 1 1 21.4 246 1667891001
1 0 0 1 0 21.4 246 1667891001
1 1 0 5 0 33.9 246 4152090001
1 0 1 0 1 25.9 246 4152090001
0 1 0 1 0 19.1 248 0964396001
1 0 1 1 1 19.8 248 0964396001
0 1 0 3 1 20.2 248 0757925001
1 0 1 1 1 19 248 0757925001
1 1 1 2 0 23.3 248 0004283001
0 0 1 2 0 37.9 248 0004283001
0 1 1 1 0 24.4 249 0771020001
1 0 0 1 0 29.5 249 0771020001
1 1 0 2 0 23.3 249 4697143001
1 0 0 3 1 34.7 249 4697143001
1 1 1 2 1 19.8 249 0498726001
1 0 1 2 1 22.8 249 0498726001
0 1 1 1 1 24.3 249 7367519001
1 0 1 1 1 21.4 249 7367519001
1 1 1 3 0 31.4 251 1498831001
1 0 1 1 1 22 251 1498831001
1 1 1 1 1 19.9 251 0987615001
1 0 0 1 1 18.7 251 0987615001
1 1 1 2 0 23.1 252 0856913001
1 0 0 3 0 26.7 252 0856913001
1 1 0 2 0 27.7 253 4565577001
1 0 0 2 1 20.8 253 4565577001
1 1 1 3 0 24.7 253 4600488001
1 0 0 1 0 22.4 253 4600488001
1 1 1 2 0 27.1 253 4400019001
1 0 1 2 1 29 253 4400019001
1 1 1 8 0 38 253 3829890001
1 0 0 1 0 24.9 253 3829890001
0 1 1 2 0 22.4 253 1107664001
1 0 1 1 1 26.3 253 1107664001
1 1 1 2 0 30.2 253 4638928001
0 0 0 2 1 17.3 253 4638928001
1 1 0 2 0 24.1 254 0210485001
0 0 1 3 0 28.8 254 0210485001
0 1 0 2 0 30 254 0795402001
0 0 1 4 0 21.2 254 0795402001
1 1 0 6 0 25.6 254 7751875001
1 0 0 1 0 21.1 254 7751875001
0 1 1 1 0 20.3 254 0998349001
1 0 1 5 0 33 254 0998349001
0 1 0 1 1 32.2 254 0790971001
1 0 1 2 1 22.9 254 0790971001
1 1 1 1 1 21.8 255 0960764001
0 0 1 1 0 36.4 255 0960764001
1 1 1 6 0 31.7 255 3964785001
1 0 1 1 1 23.8 255 3964785001
1 1 0 1 0 20.2 256 1365138001
1 0 1 1 0 35.5 256 1365138001
1 1 1 1 1 26.8 258 0898814001
1 0 1 3 0 33.3 258 0898814001
1 1 1 2 0 34.7 258 3228560001
0 0 1 0 0 33.5 258 3228560001
1 1 0 1 0 26.5 258 1060672001
0 0 1 6 1 31.7 258 1060672001
1 1 0 1 1 18.8 259 1235855001
0 0 1 2 0 34.5 259 1235855001
1 1 1 2 1 25.8 259 1011662001
1 0 1 2 0 23.9 259 1011662001
1 1 1 1 1 23.2 259 0934157001
1 0 1 1 1 23.3 259 0934157001
0 1 1 3 0 22.5 259 1219091001
1 0 1 2 0 22.2 259 1219091001
1 1 1 1 0 37.4 260 1601513001
0 0 0 3 1 36.7 260 1601513001
1 1 1 1 0 36.3 260 1732678001
1 0 0 4 0 34.8 260 1732678001
0 1 1 1 0 30.9 260 4084531001
1 0 1 2 0 23.3 260 4084531001
0 1 1 2 0 20.7 260 0510806001
1 0 1 3 0 31.8 260 0510806001
1 1 1 3 1 19.9 261 7647729001
1 0 1 2 0 21.7 261 7647729001
1 1 1 1 0 32.2 261 4035977001
1 0 1 1 1 21.7 261 4035977001
1 1 1 0 0 32.7 261 1134872001
1 0 1 3 0 36.8 261 1134872001
1 1 1 0 0 36.7 261 4512919001
1 0 1 1 1 21.8 261 4512919001
0 1 0 1 1 18.7 261 0819737001
0 0 0 2 1 25.3 261 0819737001
1 1 1 1 0 27.6 262 0657440001
1 0 1 1 0 36.6 262 0657440001
1 1 1 3 0 22.5 262 7459004001
0 0 1 2 0 19.9 262 7459004001
0 1 1 1 1 22.1 263 3105810001
0 0 0 1 1 19.8 263 3105810001
0 1 0 4 0 26.9 263 4401335001
1 0 1 0 0 38.1 263 4401335001
1 1 1 1 0 21.5 263 3430263002
1 0 0 2 1 24.8 263 3430263002
1 1 1 2 1 21.3 264 7982619001
1 0 0 3 1 24.7 264 7982619001
1 1 1 0 0 27 264 7891762001
1 0 1 0 0 28.7 264 7891762001
1 1 0 1 0 25.8 265 7673886001
1 0 1 2 0 25.9 265 7673886001
0 1 1 3 0 23.5 265 7769999001
1 0 0 1 1 25.4 265 7769999001
1 1 0 2 0 36.7 265 7598181001
1 0 1 1 1 19.2 265 7598181001
1 1 1 0 1 29.6 266 0861109001
1 0 1 2 1 35.8 266 0861109001
1 1 1 3 0 24 267 7303498001
1 0 0 0 0 32.4 267 7303498001
1 1 0 1 0 24.8 267 0029530001
1 0 1 2 1 30.6 267 0029530001
1 1 1 3 0 31.9 268 3980697001
0 0 1 2 0 28.4 268 3980697001
1 1 1 3 0 30.8 268 4628751001
1 0 1 1 0 25 268 4628751001
1 1 1 1 0 37.8 269 3896773001
0 0 1 2 0 33.6 269 3896773001
1 1 1 1 0 23.9 269 7401683001
1 0 0 1 0 30.4 269 7401683001
1 1 0 5 0 27.7 269 4365692001
1 0 0 2 0 38.2 269 4365692001
1 1 1 2 1 19.9 270 1005609001
1 0 1 2 1 19.8 270 1005609001
1 1 1 2 1 21.7 270 0885466001
1 0 0 2 0 37 270 0885466001
1 1 1 1 0 20.6 270 0946921001
1 0 0 3 1 21.3 270 0946921001
1 1 1 2 0 25.4 270 7506332001
0 0 1 1 1 27.5 270 7506332001
1 1 0 3 0 26.4 271 0496243001
1 0 1 1 0 37.4 271 0496243001
0 1 1 7 0 38.6 271 4122240001
1 0 0 1 1 23.5 271 4122240001
1 1 0 3 1 25 271 1209015001
1 0 1 1 0 21.5 271 1209015001
0 1 0 2 0 20.1 271 0954641001
1 0 1 2 0 33.8 271 0954641001
0 1 1 6 0 32 272 4070461001
1 0 1 1 1 27 272 4070461001
0 1 1 3 1 32 272 1676773001
1 0 0 2 0 39.2 272 1676773001
1 1 0 2 1 21.9 272 1277316001
1 0 1 1 1 18.9 272 1277316001
1 1 1 3 1 24.4 272 4624953001
1 0 1 5 0 36.8 272 4624953001
1 1 1 1 1 21.4 273 0821781001
1 0 0 1 0 25.4 273 0821781001
0 1 1 1 1 27.3 273 4435919001
0 0 1 1 0 25.9 273 4435919001
0 1 1 1 1 19.9 274 1201240001
1 0 1 3 0 32.1 274 1201240001
1 1 1 1 1 30.7 274 7374981003
1 0 0 3 0 30.7 274 7374981003
1 1 0 3 1 28.8 275 7578605001
1 0 1 1 1 23.1 275 7578605001
1 1 1 3 0 26.2 275 2663680002
1 0 0 4 0 24.6 275 2663680002
1 1 1 2 1 18.9 276 1431219001
1 0 0 4 0 28.7 276 1431219001
1 1 1 1 0 31.7 276 0913645001
1 0 1 1 0 26.8 276 0913645001
0 1 1 1 1 25.9 277 1080209001
1 0 0 1 1 22.6 277 1080209001
0 1 1 2 1 24.8 277 4378882001
1 0 1 1 0 35.3 277 4378882001
1 1 1 1 1 19.1 279 3438651001
1 0 1 0 0 37.8 279 3438651001
1 1 1 2 0 24.5 279 1000930001
1 0 1 1 0 21.3 279 1000930001
1 1 1 2 0 31.7 279 3492065001
1 0 0 1 1 27.7 279 3492065001
1 1 1 1 0 19.9 279 0627678001
1 0 1 1 0 19.7 279 0627678001
1 1 1 1 1 21.1 279 1050877001
1 0 1 5 0 29.7 279 1050877001
1 1 1 0 0 28 280 4423100001
1 0 1 1 1 28.4 280 4423100001
0 1 1 1 1 27.9 280 4145995001
1 0 0 2 0 23.9 280 4145995001
0 1 0 2 0 24.8 281 0633340001
1 0 0 3 0 20.6 281 0633340001
1 1 0 2 1 34.3 281 7934057001
0 0 1 0 1 30.1 281 7934057001
1 1 0 1 1 32.2 282 1154139001
0 0 1 0 0 32.6 282 1154139001
1 1 1 2 0 32.8 282 4421459001
1 0 1 2 1 38.7 282 4421459001
1 1 1 4 1 23 282 4698392001
1 0 0 1 0 27.5 282 4698392001
1 1 1 2 0 24.2 283 1123665001
1 0 1 1 0 32.2 283 1123665001
1 1 1 2 1 21.9 283 7776290001
0 0 0 0 1 20.1 283 7776290001
1 1 1 1 1 25.6 283 4611211001
1 0 1 3 0 28 283 4611211001
1 1 1 2 1 24.4 283 7675482001
1 0 1 4 0 29.2 283 7675482001
1 1 1 2 0 25.8 284 1180152001
0 0 0 1 0 26 284 1180152001
0 1 1 2 1 19.2 284 1052937001
1 0 0 2 0 26.7 284 1052937001
1 1 0 1 0 24.6 284 1285804001
0 0 1 2 0 32.5 284 1285804001
1 1 1 1 1 30.9 284 7944384001
1 0 0 1 0 20.9 284 7944384001
1 1 1 3 0 34.7 285 4330678001
1 0 0 2 0 23.8 285 4330678001
1 1 0 0 0 18.6 286 4399356001
1 0 1 2 1 22 286 4399356001
1 1 0 7 0 29.3 286 4277250001
1 0 0 2 0 27.6 286 4277250001
0 1 1 1 0 23.6 286 7891653001
1 0 0 4 0 36.9 286 7891653001
0 1 0 3 0 26.4 286 1585572001
1 0 1 1 0 38.8 286 1585572001
1 1 0 2 0 23.6 286 7631126001
0 0 1 1 1 21.2 286 7631126001
0 1 0 2 1 21.8 286 1784445001
1 0 0 2 0 24.4 286 1784445001
1 1 0 1 1 22.6 287 7911943001
1 0 1 1 0 22.5 287 7911943001
1 1 0 1 1 29.4 287 1074885001
1 0 1 2 0 27 287 1074885001
0 1 0 3 1 22 288 0826782001
1 0 1 2 0 38.5 288 0826782001
0 1 1 5 0 32.9 288 4407768001
1 0 0 1 0 39.9 288 4407768001
1 1 1 3 0 24.6 289 1633880001
1 0 1 2 1 23.4 289 1633880001
1 1 0 6 0 30.1 290 1606171001
1 0 1 1 0 26.2 290 1606171001
1 1 1 2 0 26.4 290 4611521001
0 0 1 3 0 22.9 290 4611521001
1 1 1 2 0 20.9 290 7546364001
1 0 0 1 1 21.6 290 7546364001
0 1 1 1 1 29.1 291 4593545001
1 0 0 3 0 30.3 291 4593545001
1 1 1 2 0 21.8 291 7371663001
1 0 0 1 0 19.2 291 7371663001
0 1 0 1 0 18.1 292 1378859001
1 0 1 1 1 31.6 292 1378859001
0 1 1 2 0 29.7 292 1458712001
0 0 1 2 0 34.1 292 1458712001
1 1 1 2 0 31.9 293 4192993001
0 0 1 1 1 21.1 293 4192993001
0 1 1 1 0 26.6 294 4124934001
1 0 1 1 1 20.5 294 4124934001
0 1 1 1 1 19.7 295 0962029001
1 0 1 1 0 33.4 295 0962029001
1 1 1 1 0 33.2 295 4620807001
1 0 0 4 0 30 295 4620807001
1 1 0 3 0 26 295 7544487001
0 0 0 0 1 26.1 295 7544487001
1 1 0 2 1 27.5 295 0008595001
1 0 1 2 0 30 295 0008595001
1 1 0 3 1 28.3 297 0788257002
1 0 0 4 1 23.7 297 0788257002
1 1 1 2 1 28.5 297 0599965001
1 0 0 1 1 37.8 297 0599965001
0 1 0 2 0 28.6 297 0692934001
0 0 0 1 0 37.4 297 0692934001
1 1 1 1 0 33.5 298 4069282001
0 0 0 4 0 29.2 298 4069282001
1 1 0 2 1 21.3 299 1560215001
1 0 0 1 0 25.7 299 1560215001
1 1 0 2 1 19.7 299 4454536001
1 0 1 1 1 36.7 299 4454536001
1 1 0 2 1 17.6 299 0914587001
1 0 1 6 0 38.8 299 0914587001
1 1 0 5 0 29.2 300 7564314001
1 0 0 1 0 29 300 7564314001
1 1 1 2 1 27.1 300 4663376001
1 0 0 1 1 19.4 300 4663376001
1 1 1 1 0 21 301 0835583001
1 0 0 2 1 26.2 301 0835583001
1 1 1 1 0 28.5 301 1104756001
1 0 1 1 0 38.1 301 1104756001
0 1 1 2 1 22.2 301 7951964001
1 0 0 2 0 39.7 301 7951964001
0 1 0 2 0 22 302 0155034001
1 0 1 3 1 35.4 302 0155034001
1 1 0 1 1 24.3 302 0785931001
1 0 0 3 0 24.9 302 0785931001
0 1 1 1 1 28.8 302 1219283001
1 0 1 1 0 33.2 302 1219283001
1 1 1 5 0 29.6 302 4297826001
1 0 1 1 0 30.3 302 4297826001
1 1 1 1 0 22.2 302 7400966001
1 0 1 2 0 24 302 7400966001
1 1 0 4 0 32.3 302 3759309001
1 0 1 1 0 33 302 3759309001
1 1 1 3 0 25.1 303 4614897001
1 0 1 3 1 31.9 303 4614897001
1 1 1 2 0 22 303 3881409001
1 0 0 2 0 16.2 303 3881409001
1 1 1 3 0 31.8 303 7549224001
1 0 1 3 1 39.1 303 7549224001
1 1 1 2 1 33.1 304 1519492001
1 0 1 1 1 33 304 1519492001
1 1 0 6 0 30.4 304 4341514001
0 0 1 8 0 34.5 304 4341514001
0 1 0 1 1 27.2 304 4287350001
1 0 1 3 0 30.2 304 4287350001
0 1 0 1 1 19.6 304 1705212001
1 0 1 1 1 25.8 304 1705212001
1 1 0 1 0 37.1 304 4169911001
1 0 1 1 0 26.9 304 4169911001
1 1 1 1 0 21.8 304 1304879001
1 0 1 0 0 30.3 304 1304879001
1 1 1 3 0 23.6 305 0565574001
1 0 0 1 0 26.9 305 0565574001
1 1 1 1 0 19.9 306 1321257001
1 0 0 1 0 21.1 306 1321257001
1 1 1 3 0 37.5 306 4376596001
1 0 1 3 1 21.2 306 4376596001
1 1 0 3 0 23.1 306 0859086001
1 0 1 1 1 23.7 306 0859086001
1 1 1 1 1 21.8 307 0658487001
1 0 1 1 1 30.5 307 0658487001
0 1 0 2 0 27.5 307 1541054001
1 0 1 0 0 29.6 307 1541054001
1 1 1 5 0 26.4 308 1298473001
1 0 1 2 0 28.8 308 1298473001
1 1 1 0 1 39.8 308 4026089001
1 0 0 2 0 36.7 308 4026089001
1 1 1 2 0 19.6 308 0914006001
1 0 0 1 1 22.5 308 0914006001
1 1 1 1 1 22 308 1190501001
1 0 1 2 0 39.1 308 1190501001
1 1 0 2 0 22.6 309 0773567001
1 0 1 2 1 23.6 309 0773567001
1 1 1 4 0 26 310 0893882001
1 0 1 5 0 27.7 310 0893882001
1 1 1 2 0 28.6 310 7941956001
1 0 1 1 1 22.9 310 7941956001
1 1 1 4 0 35.2 310 3628137002
1 0 1 1 1 34.8 310 3628137002
1 1 1 1 0 22.8 310 0009162001
1 0 1 3 0 26.4 310 0009162001
0 1 0 1 1 22 310 0745170001
1 0 0 2 0 33.9 310 0745170001
1 1 0 1 0 30.2 311 7572569001
1 0 1 3 0 29.9 311 7572569001
1 1 1 2 0 27.8 311 4534045001
1 0 0 0 0 31.9 311 4534045001
1 1 1 3 1 33.7 312 2581613001
1 0 1 0 0 37.5 312 2581613001
1 1 1 2 1 19.5 313 0537003001
1 0 1 4 1 19.5 313 0537003001
1 1 1 2 1 24.8 314 7617839001
0 0 1 1 1 25.6 314 7617839001
0 1 1 1 0 38.8 314 7369630001
1 0 1 1 1 31.4 314 7369630001
1 1 0 1 0 25.6 315 0726680001
1 0 0 1 1 26.5 315 0726680001
1 1 1 2 1 22.7 315 0930251001
1 0 1 1 1 19.3 315 0930251001
0 1 0 2 0 19.2 315 1192484001
1 0 1 5 0 29.2 315 1192484001
1 1 1 3 0 24.8 316 4497620001
0 0 1 4 0 27.7 316 4497620001
1 1 1 3 0 26.6 316 4409520001
1 0 1 1 1 23.8 316 4409520001
1 1 1 4 0 32.1 316 0223506001
1 0 1 1 1 23 316 0223506001
1 1 1 2 1 23.4 317 1401995001
0 0 1 3 1 21.5 317 1401995001
1 1 1 2 0 22 317 3240972001
1 0 0 4 0 26.3 317 3240972001
1 1 1 2 1 23.3 317 7864147001
1 0 1 2 1 22.4 317 7864147001
0 1 0 1 1 16.8 317 0768384001
1 0 0 1 0 34 317 0768384001
1 1 1 0 0 29.2 318 4418782001
1 0 0 3 1 27.5 318 4418782001
1 1 1 2 1 28.5 318 4180139001
1 0 0 3 0 24.5 318 4180139001
0 1 1 1 1 29.3 318 7314271001
0 0 1 1 0 29.9 318 7314271001
0 1 1 1 1 27.9 318 4424557001
1 0 0 1 0 22.2 318 4424557001
1 1 1 8 0 35 319 3862843001
0 0 1 2 1 21.1 319 3862843001
1 1 1 1 1 20.7 319 1379013001
1 0 1 1 1 19.2 319 1379013001
1 1 0 1 0 22.5 319 1391040001
1 0 1 1 1 21.7 319 1391040001
1 1 0 3 0 28.2 319 4274450001
1 0 1 1 0 37.7 319 4274450001
0 1 1 1 1 29.2 320 4237508001
0 0 1 2 0 28.5 320 4237508001
0 1 1 1 1 24.6 320 4680310001
0 0 0 1 1 30.9 320 4680310001
0 1 1 3 0 39 320 3297533001
1 0 1 1 1 22.6 320 3297533001
0 1 1 2 0 26.6 320 2420657002
1 0 0 2 0 22 320 2420657002
0 1 1 1 0 23.6 321 0867253001
1 0 1 2 0 36.2 321 0867253001
1 1 1 4 0 26.1 321 4548525001
1 0 1 1 0 20.7 321 4548525001
1 1 0 1 0 38.6 321 7838398001
1 0 1 1 1 20.3 321 7838398001
1 1 1 2 0 30.3 321 1520532001
1 0 0 3 0 35.3 321 1520532001
1 1 1 1 0 24.5 321 4546348001
1 0 1 1 0 37.7 321 4546348001
1 1 1 1 0 19.2 322 2539843001
0 0 1 1 1 22 322 2539843001
1 1 1 1 0 26.8 323 4648117001
1 0 1 1 1 25.8 323 4648117001
1 1 0 4 0 22.5 325 4679131001
1 0 1 1 1 26.2 325 4679131001
1 1 1 2 1 26.6 326 7603934001
1 0 1 4 0 30.8 326 7603934001
1 1 0 2 0 20.6 326 1522637001
1 0 1 0 0 31.7 326 1522637001
0 1 1 1 0 22 326 4045339001
1 0 1 1 1 22.7 326 4045339001
1 1 0 1 0 18.1 327 1794527001
1 0 1 4 0 33.3 327 1794527001
1 1 0 1 0 20.4 328 1260780001
0 0 0 2 0 30.3 328 1260780001
0 1 1 2 0 33.3 329 4489967001
1 0 0 5 0 24.1 329 4489967001
1 1 1 2 0 31.9 330 4442518001
1 0 0 2 1 22.2 330 4442518001
1 1 0 1 0 26 330 1130558001
1 0 1 1 0 28.9 330 1130558001
1 1 1 2 1 19.6 330 1495739001
1 0 1 1 1 31.3 330 1495739001
0 1 1 2 1 26.2 330 4662292001
1 0 0 2 0 20.4 330 4662292001
1 1 1 2 1 26.3 331 4334450001
0 0 0 2 0 32.9 331 4334450001
1 1 1 0 1 28.9 331 2471970001
1 0 0 1 0 18.3 331 2471970001
1 1 1 2 1 24.1 331 0926334001
1 0 1 3 0 23.7 331 0926334001
1 1 0 7 0 33.6 332 4523315001
1 0 1 1 1 20.2 332 4523315001
1 1 1 4 1 31.9 332 7603777001
1 0 0 4 1 28.2 332 7603777001
1 1 1 0 0 22.2 332 7354837001
0 0 1 0 0 27.1 332 7354837001
1 1 1 4 1 30.6 332 4363187001
1 0 0 3 1 27.8 332 4363187001
1 1 1 2 1 22 333 0868516001
1 0 0 2 0 21.1 333 0868516001
1 1 1 1 0 23.2 333 1630552001
1 0 0 2 0 23.8 333 1630552001
1 1 1 4 0 16.2 334 2785266001
1 0 1 1 1 17.8 334 2785266001
1 1 1 1 1 24.1 335 4604093001
1 0 1 3 0 36 335 4604093001
0 1 1 2 1 24.4 336 0968388001
1 0 1 5 1 28.2 336 0968388001
1 1 0 3 1 32.8 336 7574055001
1 0 1 1 1 20.4 336 7574055001
1 1 1 4 0 31.3 337 4638941001
0 0 1 1 1 26.2 337 4638941001
1 1 0 2 1 36.9 337 3960126001
1 0 0 1 0 37.1 337 3960126001
1 1 1 5 0 33.8 337 0441646001
1 0 1 4 1 32.7 337 0441646001
1 1 1 1 0 31 337 4018319001
1 0 0 3 0 24 337 4018319001
1 1 1 2 1 31.7 338 4675232001
1 0 1 3 0 29.9 338 4675232001
1 1 1 5 1 31.7 338 4015304001
1 0 0 3 0 21.2 338 4015304001
1 1 1 2 1 21.8 339 0856151001
0 0 1 2 0 25.3 339 0856151001
1 1 1 2 0 23.7 339 4690680001
1 0 0 2 0 33.8 339 4690680001
1 1 1 5 1 32.8 340 3995377001
1 0 1 1 0 22.8 340 3995377001
1 1 1 2 1 19.6 340 2093266001
1 0 0 6 0 35.5 340 2093266001
1 1 1 2 1 25.8 340 4082285001
1 0 0 2 1 17.6 340 4082285001
1 1 1 1 0 30.5 340 7646358001
1 0 1 3 1 35 340 7646358001
0 1 1 1 1 24.6 341 7689455001
1 0 1 4 1 34.3 341 7689455001
1 1 1 1 1 26.5 342 4431613001
1 0 1 1 1 37.4 342 4431613001
0 1 0 2 0 27.6 342 1347717001
1 0 1 3 0 38.6 342 1347717001
1 1 1 3 1 27.2 342 3654712001
1 0 1 1 1 28.4 342 3654712001
1 1 1 3 0 28.1 342 0787640001
0 0 1 1 1 22.8 342 0787640001
1 1 0 2 0 18.4 343 0349843001
1 0 1 1 0 28.3 343 0349843001
0 1 1 2 0 20.5 343 0498649001
1 0 0 3 0 26.7 343 0498649001
1 1 1 2 0 28 343 4113576001
1 0 1 2 0 33 343 4113576001
1 1 1 1 0 26 344 0740452001
1 0 1 1 0 24.6 344 0740452001
1 1 1 1 0 25.9 344 0604678001
0 0 1 0 0 24.4 344 0604678001
0 1 1 1 1 33.5 344 1786326001
1 0 1 1 0 26.8 344 1786326001
1 1 1 2 0 29.6 344 1043506001
1 0 0 3 1 25.8 344 1043506001
1 1 0 1 0 27.9 346 7380708001
1 0 0 2 0 28.6 346 7380708001
1 1 1 1 0 22.3 346 0888234001
1 0 1 1 1 21.5 346 0888234001
1 1 0 2 0 26 346 0229728001
1 0 0 1 0 21.1 346 0229728001
1 1 0 5 0 39.7 348 7358246001
1 0 1 2 0 26 348 7358246001
0 1 1 2 0 22.9 348 0000297001
1 0 1 1 0 24.3 348 0000297001
0 1 1 3 0 24.2 348 0475412001
1 0 1 1 0 26.6 348 0475412001
1 1 1 1 1 29.9 348 1013134001
1 0 1 2 1 21.6 348 1013134001
1 1 1 2 0 26.2 348 7341382001
1 0 1 1 1 19.4 348 7341382001
1 1 1 3 0 28.6 349 4272857001
1 0 1 1 0 36.5 349 4272857001
1 1 0 3 0 27.1 350 0668217001
0 0 1 3 0 33.2 350 0668217001
1 1 1 3 0 30.5 350 3809467001
1 0 1 2 0 24.3 350 3809467001
1 1 1 1 0 28.3 350 0778984001
1 0 0 1 1 19.3 350 0778984001
1 1 0 3 0 35.5 351 3795112001
1 0 1 1 0 30.1 351 3795112001
0 1 1 2 0 30.4 351 3044158001
1 0 0 2 0 33.4 351 3044158001
1 1 1 4 1 24.6 351 7823425001
1 0 1 1 0 22.9 351 7823425001
1 1 1 2 0 25.4 352 4552602001
1 0 1 3 0 27.4 352 4552602001
0 1 1 2 0 28.7 352 1450779001
0 0 1 1 1 24.3 352 1450779001
1 1 0 4 0 32.3 353 4318973001
1 0 0 2 0 28 353 4318973001
1 1 1 1 1 23.2 353 1598115001
1 0 0 1 1 23 353 1598115001
1 1 0 2 0 30.2 354 0433106001
1 0 1 3 0 27.7 354 0433106001
1 1 1 1 0 21.2 354 1139965001
0 0 1 1 0 25.4 354 1139965001
1 1 0 2 0 19.8 354 1222371001
1 0 1 1 0 23 354 1222371001
0 1 1 2 0 34.4 354 4445757001
1 0 1 1 1 25.2 354 4445757001
1 1 0 2 0 22.7 355 1283969001
1 0 1 1 0 18.1 355 1283969001
1 1 1 2 0 22.4 355 1043704001
1 0 0 2 0 36.3 355 1043704001
1 1 1 1 1 23.9 356 4505209001
1 0 1 2 0 24.6 356 4505209001
1 1 0 1 1 28.9 356 0824127001
0 0 0 1 1 19.4 356 0824127001
1 1 0 1 0 27.5 357 0899981001
1 0 0 1 0 17.6 357 0899981001
0 1 0 3 1 32.9 357 7528269001
1 0 1 1 1 25.7 357 7528269001
0 1 1 2 0 28.6 357 0832313001
1 0 1 1 1 23.8 357 0832313001
1 1 0 4 0 23.9 357 0272879001
1 0 1 2 0 24 357 0272879001
1 1 1 3 0 32.9 357 7561140001
1 0 0 1 0 22.2 357 7561140001
1 1 1 2 0 27.3 358 0479518001
1 0 1 2 1 28.8 358 0479518001
1 1 1 1 1 29.5 358 4170218001
1 0 1 0 1 23.7 358 4170218001
1 1 1 2 1 27.8 358 4585355001
1 0 1 2 0 29.3 358 4585355001
1 1 0 1 0 24.8 359 2875246001
1 0 1 1 0 30 359 2875246001
1 1 1 3 1 22.1 359 7863144001
0 0 1 1 1 27.9 359 7863144001
1 1 1 2 1 26.9 360 1479542001
0 0 1 3 0 29.5 360 1479542001
1 1 0 2 1 21.4 360 7455470001
0 0 0 1 0 38.8 360 7455470001
1 1 0 2 1 20.2 362 7819252001
1 0 1 2 0 25.7 362 7819252001
1 1 1 2 0 22.8 362 0793113001
1 0 1 2 0 27.8 362 0793113001
1 1 0 2 1 16.7 363 4436784002
0 0 0 4 0 38.7 363 4436784002
1 1 1 4 0 27.6 363 1189895001
1 0 0 5 1 30.2 363 1189895001
1 1 1 3 0 29.3 363 4454461001
1 0 1 3 0 30.3 363 4454461001
1 1 0 1 0 27.3 364 4269196001
1 0 0 2 0 22.4 364 4269196001
0 1 1 1 0 36.4 364 2636802001
1 0 1 4 0 26.3 364 2636802001
1 1 1 2 0 28 365 7614179001
1 0 1 0 0 25.8 365 7614179001
0 1 1 2 0 24.7 365 7733409001
1 0 0 1 0 25 365 7733409001
1 1 1 4 0 23.6 365 2591756001
1 0 1 2 0 37.7 365 2591756001
1 1 1 2 0 23.9 366 4663855001
1 0 0 2 1 25.9 366 4663855001
0 1 1 4 0 24.6 366 3449423001
1 0 1 1 1 20.9 366 3449423001
1 1 1 3 0 36.2 366 1649118001
1 0 1 1 1 21.7 366 1649118001
1 1 1 2 1 24.9 367 0303084001
1 0 0 3 0 23.7 367 0303084001
1 1 1 3 0 29.8 368 7469182001
1 0 1 1 1 18.9 368 7469182001
1 1 1 1 1 36.4 369 4353888001
1 0 0 1 1 29.4 369 4353888001
0 1 1 1 0 27.8 369 0552590001
1 0 0 2 0 24.2 369 0552590001
1 1 0 1 1 27.7 370 0965753001
0 0 1 2 0 24.1 370 0965753001
1 1 1 5 1 38.4 370 3569502001
1 0 0 4 0 25.6 370 3569502001
1 1 1 2 1 22.4 370 7910122001
0 0 1 3 1 28.6 370 7910122001
0 1 1 4 0 27.8 371 4330081001
1 0 1 1 0 22.3 371 4330081001
1 1 0 2 0 24.3 371 7761521001
1 0 1 1 1 25 371 7761521001
0 1 1 4 0 28.9 373 4236738001
1 0 1 2 0 28 373 4236738001
1 1 0 1 0 18.7 373 1056105001
1 0 1 1 1 26.5 373 1056105001
1 1 0 2 1 20.7 374 1070939001
1 0 0 1 0 20.7 374 1070939001
0 1 0 2 1 28.9 375 4313966002
1 0 1 1 1 26.2 375 4313966002
1 1 1 1 0 30 375 1111764001
1 0 1 5 0 27.6 375 1111764001
1 1 1 3 0 25 375 4573325001
1 0 0 1 1 21.4 375 4573325001
1 1 1 2 1 34.6 376 4133641001
1 0 1 1 0 19.3 376 4133641001
1 1 1 2 0 22.1 377 0309077001
1 0 1 1 1 38.6 377 0309077001
0 1 0 1 1 36.4 377 3445678001
0 0 1 3 0 32.2 377 3445678001
1 1 0 1 0 25.4 379 7516753001
0 0 1 1 0 25.3 379 7516753001
1 1 1 5 1 33.5 379 3807550001
1 0 1 1 0 27.3 379 3807550001
1 1 1 1 0 35.8 379 3845311001
0 0 1 4 0 31.9 379 3845311001
1 1 0 1 1 22.4 379 1180128001
1 0 0 2 0 30.1 379 1180128001
1 1 1 1 1 20 380 1151749001
1 0 0 2 0 30.8 380 1151749001
0 1 1 1 0 29 380 4396205001
1 0 0 1 1 23.2 380 4396205001
1 1 1 3 0 25.7 381 7553093001
1 0 0 1 1 22.2 381 7553093001
1 1 1 1 1 22.9 381 0457474001
0 0 1 1 0 30 381 0457474001
1 1 1 2 1 29.7 381 7889677001
1 0 1 0 1 35.6 381 7889677001
1 1 1 2 1 23.5 382 7927597001
1 0 1 7 0 27.6 382 7927597001
1 1 0 2 0 29.3 382 4600958001
1 0 1 4 0 37 382 4600958001
1 1 1 2 0 23.5 383 4554563001
1 0 1 2 1 29.7 383 4554563001
1 1 1 3 0 37.3 383 0969627001
1 0 0 1 1 27.1 383 0969627001
1 1 0 3 0 23.6 384 4642997001
1 0 0 2 1 38.5 384 4642997001
1 1 1 2 1 19.1 385 0834476001
1 0 1 4 0 27.6 385 0834476001
1 1 1 2 0 33.6 385 4199240001
1 0 0 1 1 21.6 385 4199240001
1 1 1 2 0 38 385 3602868001
1 0 1 4 1 33.7 385 3602868001
1 1 1 1 1 26.9 388 4449953001
1 0 1 2 0 24.4 388 4449953001
1 1 0 1 0 25.4 388 4527675001
1 0 1 2 0 22.4 388 4527675001
1 1 1 2 1 24.6 389 7467504001
1 0 1 3 0 32.2 389 7467504001
1 1 0 3 0 29.4 389 0638640001
1 0 0 5 0 36.7 389 0638640001
1 1 1 1 0 30.7 390 7756696001
1 0 1 2 1 23.4 390 7756696001
0 1 1 2 1 31.4 392 7760297001
1 0 0 3 0 25.9 392 7760297001
1 1 1 2 0 23.1 393 7924706001
1 0 1 2 0 31 393 7924706001
1 1 0 3 0 25.7 393 0906350001
1 0 1 2 0 27.8 393 0906350001
1 1 0 4 0 20 393 2790869001
0 0 1 1 1 29.4 393 2790869001
1 1 1 2 0 25.9 394 7828584001
1 0 0 1 1 23.8 394 7828584001
1 1 0 4 1 38.4 394 3936230001
1 0 0 1 0 28.6 394 3936230001
1 1 1 2 1 22.5 394 7310884001
1 0 1 4 0 26.2 394 7310884001
1 1 0 1 0 26.4 395 4397072001
1 0 0 2 0 22.3 395 4397072001
1 1 1 2 0 30.5 396 0399450001
0 0 1 1 1 29 396 0399450001
1 1 1 1 0 31.9 397 4349330001
1 0 1 3 0 34.8 397 4349330001
0 1 1 2 0 25.8 397 0953546001
1 0 1 1 0 27.8 397 0953546001
0 1 1 1 1 33 397 0312675001
1 0 0 1 0 39.7 397 0312675001
1 1 1 4 0 30.8 398 3940910001
1 0 1 2 1 18.5 398 3940910001
1 1 1 2 0 22.5 398 2038289001
1 0 1 2 1 29.4 398 2038289001
1 1 1 1 0 24 399 4678622001
1 0 1 2 0 21.4 399 4678622001
1 1 0 3 1 25.7 400 4484042001
1 0 1 1 1 21 400 4484042001
1 1 1 2 0 23 400 7618710001
1 0 0 2 1 19.3 400 7618710001
1 1 1 3 0 30.6 400 4266316001
0 0 1 1 0 25.3 400 4266316001
1 1 1 3 1 27.7 400 7383448001
1 0 0 1 0 39.5 400 7383448001
1 1 1 4 0 18.3 401 2373300001
0 0 1 1 1 25.2 401 2373300001
1 1 0 5 1 29 402 0596265001
1 0 1 3 1 25.2 402 0596265001
1 1 1 2 1 18.6 402 3942374001
0 0 1 3 0 36.1 402 3942374001
1 1 0 2 0 24.2 402 7673273001
1 0 1 3 0 34.8 402 7673273001
1 1 1 1 1 35.7 402 7970061001
1 0 1 2 1 23 402 7970061001
1 1 0 1 0 26.6 403 0695714001
0 0 1 0 1 36.1 403 0695714001
1 1 1 7 0 27.4 404 4241547001
1 0 1 2 0 31.3 404 4241547001
1 1 0 4 0 27.7 406 4679328001
0 0 1 3 0 25.5 406 4679328001
1 1 0 3 0 33.5 407 1028728001
1 0 1 1 0 19.9 407 1028728001
0 1 1 1 0 22.1 407 1956296001
1 0 0 1 1 33.4 407 1956296001
1 1 1 4 0 22.2 408 0551052001
1 0 1 4 0 33.3 408 0551052001
1 1 0 3 1 22.7 409 4668370001
1 0 1 2 0 26.6 409 4668370001
1 1 1 1 0 25.2 409 3417356001
1 0 1 1 1 31.7 409 3417356001
1 1 0 6 1 32.6 410 4616686001
1 0 1 3 1 27.5 410 4616686001
1 1 1 2 1 30 410 4154045001
1 0 1 2 0 38.2 410 4154045001
1 1 1 2 1 25.9 410 0151532001
1 0 1 6 0 25.3 410 0151532001
1 1 0 3 1 23.9 410 4644990001
1 0 1 3 0 27.9 410 4644990001
1 1 1 2 0 29.5 411 7417639001
1 0 0 0 0 39.6 411 7417639001
1 1 1 2 1 28.7 412 7596894001
1 0 1 1 0 27.3 412 7596894001
1 1 1 2 0 29.9 412 0472830001
0 0 0 2 0 34.5 412 0472830001
0 1 1 2 1 31.1 412 2063409001
1 0 0 1 1 26 412 2063409001
1 1 0 2 0 37.3 413 3590526001
1 0 1 1 1 18.5 413 3590526001
1 1 0 2 1 20.4 413 0647639001
1 0 1 2 0 29.3 413 0647639001
1 1 1 2 1 26.1 414 7837362001
0 0 0 2 0 39.5 414 7837362001
0 1 1 2 0 32.1 415 3832514001
1 0 0 2 0 25.7 415 3832514001
1 1 1 1 1 33.3 415 4015297001
1 0 1 1 0 30 415 4015297001
1 1 1 2 0 25.7 416 4531703001
1 0 1 2 0 36.1 416 4531703001
1 1 1 1 1 24.2 417 7621081001
1 0 1 2 1 27.8 417 7621081001
1 1 1 3 0 28.2 417 7907586001
0 0 1 2 1 22.1 417 7907586001
0 1 1 2 0 23.7 417 0382941001
1 0 1 2 0 32.8 417 0382941001
1 1 1 2 1 26.7 418 4387773002
1 0 0 5 0 35.3 418 4387773002
1 1 1 2 0 27.4 418 1312054001
1 0 1 2 1 38 418 1312054001
1 1 1 1 1 27.8 419 4248235001
1 0 1 3 0 38 419 4248235001
1 1 1 5 0 20.9 422 1116617001
1 0 1 0 1 23.7 422 1116617001
1 1 1 3 1 23 422 0692461001
1 0 1 1 0 34.3 422 0692461001
1 1 1 1 1 33.5 425 4076831001
1 0 0 1 1 22.2 425 4076831001
1 1 1 2 0 27.3 426 7546909001
0 0 1 2 0 20.2 426 7546909001
1 1 0 2 0 30.3 426 4664021001
1 0 1 2 0 23.3 426 4664021001
1 1 1 2 0 35.4 427 3640131001
1 0 1 1 0 35.7 427 3640131001
0 1 1 3 0 26.6 427 0138250001
1 0 1 1 0 23.6 427 0138250001
0 1 0 2 1 21.6 430 1262949001
0 0 1 1 1 27.1 430 1262949001
1 1 1 1 0 28.6 431 7975624001
1 0 0 1 1 20.3 431 7975624001
1 1 0 2 0 21.7 432 0601330001
1 0 0 3 0 30 432 0601330001
0 1 1 1 0 29.1 432 3935660001
0 0 0 1 0 27 432 3935660001
0 1 1 1 1 35.9 432 7856943001
1 0 1 2 1 36.2 432 7856943001
0 1 1 1 0 23.1 433 4613354001
1 0 1 2 1 23.3 433 4613354001
1 1 1 2 1 19.1 433 1154625001
1 0 1 2 0 30 433 1154625001
1 1 0 1 0 26.2 434 7509830001
1 0 1 1 0 21.6 434 7509830001
1 1 1 2 0 22.2 434 0669816001
1 0 0 4 0 28.9 434 0669816001
1 1 1 2 1 21.8 435 0904608001
1 0 1 1 0 28.1 435 0904608001
1 1 1 2 1 25.8 436 4528732001
1 0 1 2 1 25.3 436 4528732001
0 1 1 1 0 29.1 438 0480556001
0 0 1 4 0 27.9 438 0480556001
1 1 1 2 1 20.6 438 0257970001
1 0 1 4 1 24.2 438 0257970001
1 1 1 1 0 28.8 439 4192451001
0 0 0 3 0 31.4 439 4192451001
1 1 0 4 0 25.9 442 4653337001
0 0 0 1 0 24.6 442 4653337001
0 1 1 4 1 26 443 4536424001
1 0 0 1 1 23 443 4536424001
1 1 1 3 0 21.9 448 4637555001
0 0 0 3 0 33.4 448 4637555001
1 1 0 2 0 35.1 449 7495216001
1 0 0 4 0 26.4 449 7495216001
1 1 1 1 1 23.3 450 7357348001
0 0 1 1 1 29.2 450 7357348001
0 1 1 1 0 29.6 450 0033011001
1 0 1 1 1 26.5 450 0033011001
1 1 1 7 1 29.5 452 4157413001
0 0 1 3 1 25.3 452 4157413001
1 1 1 1 1 24.5 452 4257696001
1 0 1 2 0 33.6 452 4257696001
0 1 1 2 1 27.1 453 0448792001
0 0 1 1 1 23.1 453 0448792001
1 1 0 2 0 27.3 454 0543752001
1 0 1 2 1 36.7 454 0543752001
1 1 1 5 1 23.9 455 4364170001
1 0 0 1 0 30.9 455 4364170001
1 1 1 2 1 34.2 456 3919340002
0 0 0 1 0 36.1 456 3919340002
1 1 1 2 0 29.8 459 4576675001
1 0 1 1 0 30.9 460 4576675001
1 1 1 2 0 21.8 460 7304344001
1 0 0 3 0 34.3 460 7304344001
1 1 1 1 1 29.3 461 4468490001
1 0 0 0 0 36.4 461 4468490001
1 1 1 1 1 21.8 462 1214284001
1 0 0 2 0 35.8 462 1214284001
1 1 1 4 1 27.2 463 4445018001
0 0 1 1 1 27.5 463 4445018001
1 1 1 2 0 18.7 464 0768129001
1 0 1 2 1 30.3 464 0768129001
1 1 1 5 0 34.2 465 3745478001
0 0 1 3 0 28 465 3745478001
1 1 0 6 0 37.9 467 0309073001
1 0 0 2 0 18.4 467 0309073001
0 1 1 3 1 21.6 468 0402952001
1 0 1 4 0 22.6 468 0402952001
1 1 1 1 1 32 469 4024885001
1 0 1 1 0 24.2 469 4024885001
0 1 1 3 0 20.6 470 1298413001
1 0 1 5 0 34.5 470 1298413001
1 1 1 3 0 26.8 471 4369139001
1 0 1 1 1 33.3 471 4369139001
0 1 0 2 0 21.7 471 1165135001
1 0 1 1 0 28.4 471 1165135001
1 1 0 4 0 35.6 473 4545881001
1 0 1 2 0 34.3 473 4545881001
0 1 1 2 1 20.5 473 2222443001
0 0 1 1 1 25.1 474 2222443001
1 1 1 4 1 19.2 479 0622801001
1 0 0 2 0 39.5 479 0622801001
1 1 0 2 1 21.5 480 0009762001
0 0 1 3 1 37.7 480 0009762001
1 1 1 2 1 19.5 481 0481810001
1 0 1 5 0 35.6 482 0481810001
0 1 1 2 1 18.8 484 0366566001
1 0 0 3 0 23.7 484 0366566001
1 1 0 5 1 24.3 484 1105867001
1 0 1 1 0 34.6 485 1105867001
1 1 1 4 0 23.2 484 4671542001
1 0 0 2 1 32.4 486 4671542001
1 1 1 6 1 34.4 486 0261797001
1 0 0 1 0 32 486 0261797001
1 1 1 2 1 20.1 489 0767189001
1 0 1 3 0 24.2 489 0767189001
1 1 1 3 1 22.9 491 0621351001
1 0 1 3 1 23.3 491 0621351001
1 1 1 2 1 20.3 492 0347518001
1 0 1 0 0 30.8 492 0347518001
1 1 1 2 1 20.3 493 0627715001
1 0 0 2 0 38.5 493 0627715001
1 1 1 3 1 29.1 495 4501418001
1 0 1 1 0 36.2 495 4501418001
0 1 0 3 0 30.9 495 0849042001
0 0 0 1 1 25 495 0849042001
1 1 0 6 0 38.7 497 4585773001
0 0 1 2 1 23.2 497 4585773001
0 1 1 1 0 28.9 500 0554818001
1 0 1 1 1 31.1 500 0554818001
1 1 0 2 0 24.5 501 0006034001
1 0 1 0 1 36.3 502 0006034001
1 1 0 2 1 21 501 7326438001
1 0 1 1 0 29.9 502 7326438001
1 1 1 2 1 20.6 501 1038707001
1 0 1 2 1 25.9 503 1038707001
0 1 0 2 1 19.5 505 2005924001
1 0 1 3 1 34.4 505 2005924001
1 1 0 2 1 22.2 509 0025548001
1 0 0 2 0 31.6 509 0025548001
1 1 1 3 1 29 509 4587777001
1 0 1 2 1 24.5 509 4587777001
1 1 1 1 0 27.8 514 4423650001
0 0 0 1 0 34 514 4423650001
1 1 1 2 0 26.5 514 7657661001
0 0 0 2 1 36.2 514 7657661001
1 1 1 2 0 31.6 517 7527898001
1 0 1 2 0 33.7 517 7527898001
1 1 1 5 1 18.8 518 1390592001
0 0 1 5 0 31.8 518 1390592001
1 1 1 3 0 25.5 518 0595713001
1 0 0 3 0 34.9 518 0595713001
1 1 1 3 0 32.6 519 7986099001
1 0 0 4 0 26.4 519 7986099001
1 1 1 1 1 30.4 522 4047295001
0 0 0 2 0 23.6 522 4047295001
1 1 1 1 1 29.7 523 0593304001
1 0 0 3 0 20.5 523 0593304001
1 1 0 3 0 31.1 527 4611523001
1 0 0 4 1 28.7 527 4611523001
1 1 0 2 1 23.8 528 2761409001
1 0 1 3 0 21.3 529 2761409001
1 1 0 4 0 27.5 529 1571893001
0 0 1 4 0 29 529 1571893001
0 1 1 4 1 22.9 530 4654829001
1 0 1 1 1 21.1 531 4654829001
0 1 1 1 0 34 531 3965621001
1 0 0 3 0 28.9 532 3965621001
0 1 1 3 0 29.9 539 4608525001
1 0 1 2 1 24.2 540 4608525001
1 1 1 1 1 30.6 541 7942021001
0 0 1 1 1 35 541 7942021001
1 1 1 4 1 24 541 4616216001
1 0 0 2 0 36.4 541 4616216001
1 1 1 1 1 20.8 542 0366237001
1 0 0 2 0 36.2 542 0366237001
0 1 1 1 1 25 545 0654636001
1 0 0 3 0 18.5 545 0654636001
1 1 1 7 0 25.5 546 0255298001
1 0 1 3 0 32.1 546 0255298001
0 1 0 4 0 22.4 553 0031085001
0 0 1 2 0 25.6 553 0031085001
1 1 1 2 0 26.4 555 4521316001
0 0 1 1 0 38.4 555 4521316001
0 1 1 2 0 22.9 555 3511878001
1 0 0 2 1 27.6 556 3511878001
0 1 0 4 0 29.2 555 0349788001
1 0 1 1 0 33.7 557 0349788001
1 1 1 1 1 37.5 557 4018161001
1 0 1 2 0 21.1 557 4018161001
0 1 1 3 0 21.2 560 0703201001
1 0 1 3 1 23.9 562 0703201001
1 1 0 3 0 28 568 7822472001
1 0 1 1 1 29.5 568 7822472001
0 1 0 2 1 20.6 572 0457692001
1 0 1 2 0 26.3 574 0457692001
1 1 1 1 1 32.9 572 7499375001
1 0 1 3 0 39.5 575 7499375001
1 1 1 2 0 19.3 572 3205137001
1 0 0 3 0 39 576 3205137001
1 1 0 2 1 31.1 582 0533835001
1 0 0 1 1 37.3 582 0533835001
1 1 1 2 0 21.2 587 0284348001
1 0 1 2 0 28.4 587 0284348001
1 1 1 4 1 34.4 588 2603487001
1 0 1 1 0 30.6 589 2603487001
1 1 1 2 0 34.8 590 4211815001
1 0 0 1 1 26.5 590 4211815001
1 1 1 3 0 26.1 590 4362058001
1 0 1 3 0 28.1 590 4362058001
0 1 1 5 1 24.7 593 0799286001
1 0 0 0 0 16.7 593 0799286001
1 1 1 2 0 28.5 593 4395990001
0 0 1 1 0 26.2 594 4395990001
1 1 1 4 0 34.8 594 4095631001
1 0 0 3 0 31.3 597 4095631001
0 1 1 1 1 22.4 595 7589734001
1 0 0 3 0 31.9 597 7589734001
1 1 0 1 0 24 600 4269724001
1 0 1 1 0 24 600 4269724001
1 1 1 1 0 28.5 606 4250372001
1 0 1 2 0 21.9 611 4250372001
1 1 0 3 0 26.9 606 7508049001
1 0 1 3 0 29 612 7508049001
1 1 1 3 0 23.9 610 0511471001
1 0 0 0 0 39.7 613 0511471001
1 1 0 1 1 26.3 616 4423159001
1 0 1 3 0 35.9 617 4423159001
1 1 0 3 0 20.6 618 7999289001
0 0 1 2 0 23.2 619 7999289001
1 1 0 1 1 33.2 619 3853904001
0 0 1 2 0 36 620 3853904001
1 1 0 3 0 22.2 631 4538389001
1 0 1 1 0 23.9 631 4538389001
0 1 1 2 0 23.5 634 0960675001
1 0 0 2 0 35.1 637 0960675001
1 1 0 5 0 17.6 634 2134923001
1 0 0 4 0 32.4 637 2134923001
1 1 1 1 1 34.8 640 4239421001
1 0 1 2 1 20.7 648 4239421001
0 1 1 2 0 39.2 646 3720111001
1 0 1 2 0 30.4 651 3720111001
1 1 1 1 1 30.7 661 4262298001
1 0 0 3 0 23.6 663 4262298001
0 1 1 5 0 30.5 661 4342868001
1 0 1 0 0 32.4 665 4342868001
1 1 0 6 0 25 663 1846667001
0 0 1 1 0 31 665 1846667001
1 1 0 1 0 21.9 665 0724795001
1 0 0 2 1 36.1 666 0724795001
0 1 1 1 1 22.9 666 0616697001
1 0 1 2 0 35.9 670 0616697001
1 1 1 5 0 28.7 670 4679253001
1 0 0 3 0 34.4 672 4679253001
1 1 1 4 0 28.4 671 7532705003
0 0 1 2 0 22.6 674 7532705003
1 1 0 1 1 31.4 673 0249980001
1 0 1 3 1 34.2 676 0249980001
1 1 0 3 0 30 686 4250105001
1 0 1 2 0 31.2 686 4250105001
0 1 1 5 0 38.8 686 3398318001
1 0 1 1 1 28.1 688 3398318001
1 1 1 3 1 25.5 687 0217890001
1 0 1 2 1 27.6 690 0217890001
0 1 1 1 0 30.8 701 4673520001
1 0 0 1 0 39.2 701 4673520001
1 1 0 2 0 24.2 705 1380868001
1 0 0 6 0 39.1 707 1380868001
1 1 1 2 0 38.4 716 3756940001
1 0 1 6 0 37.5 718 3756940001
1 1 1 1 1 31.1 716 4522443001
1 0 1 1 0 25 726 4522443001
1 1 1 2 0 23.9 722 4609235001
1 0 0 3 0 30.7 727 4609235001
1 1 0 1 0 33.2 742 4233045001
1 0 0 1 0 30.4 742 4233045001
1 1 0 1 0 37.6 746 3733192001
1 0 1 4 0 36.6 751 3733192001
1 1 0 3 0 24.3 751 4528136001
1 0 1 2 0 35.9 758 4528136001
1 1 0 3 0 23.2 759 0174247001
0 0 1 1 0 28.7 777 0174247001
1 1 1 2 0 28.3 760 4437624001
1 0 1 1 0 22.8 785 4437624001
1 1 1 1 0 24.2 763 4670354001
1 0 0 3 0 36.8 786 4670354001
1 1 1 7 0 32.7 767 2607241001
1 0 1 2 0 36.5 787 2607241001
1 1 1 8 0 31 769 4456719001
1 0 1 4 1 31.7 795 4456719001
0 1 1 1 0 29.9 771 0329727001
1 0 1 7 0 36.7 795 0329727001
0 1 0 4 1 18.3 771 2846679001
0 0 1 6 0 33.8 799 2846679001
1 1 1 4 0 28.4 773 4505893001
0 0 1 2 0 39.5 803 4505893001
0 1 1 2 0 39.9 796 0032567001
1 0 1 2 0 34.7 823 0032567001
1 1 0 6 0 20.4 820 4017093001
0 0 1 1 0 28.5 826 4017093001
1 1 1 3 1 25.9 821 7794857001
1 0 0 3 0 29.7 849 7794857001
1 1 1 2 0 31.2 824 0543777001
0 0 1 2 0 33.1 863 0543777001
1 1 1 3 0 33.4 845 3898075001
1 0 1 3 0 33.4 864 3898075001
1 1 0 1 0 38.4 852 3727115001
1 0 0 0 0 32.7 869 3727115001
1 1 1 1 0 33 871 3962052001
0 0 0 0 0 37.5 882 3962052001
1 1 1 3 0 28.2 872 7311680001
1 0 1 2 0 39.6 887 7311680001
1 1 0 1 0 28.2 882 4342798001
1 0 1 3 0 30.3 898 4342798001
1 1 1 8 0 38.5 884 3521667001
0 0 1 1 0 18.6 901 3521667001
1 1 0 4 0 39.8 936 3834402001
1 0 0 1 0 34.1 943 3834402001
0 1 1 3 0 34.8 1044 3715671001
1 0 0 3 0 35 1146 3715671001
0 1 1 2 0 35.4 1085 0009614001
1 0 1 4 0 18.9 1294 0009614001
1 1 1 10 0 21.3 1422 2600041001
0 0 1 5 0 38.6 1459 2600041001
1 1 1 8 0 25 1780 0370229001
1 0 1 2 0 32.4 1785 0370229001
;

/*
-----------------
PROGNOSI Data Set
-----------------

 Data described in Chapter 9 of P.D. Allison, "Logistic Regression
 Using the SAS System: Theory and Application."                 */

data prognosi;
input lengthpx ptage ptsex ezcompt mdlikept surgeon claims minutes;
datalines;
12 20 0 5 4 1 2 7
0 24 0 4 4 1 7 6
1 26 0 3 3 1 2 20
0 57 0 5 4 1 2 15
24 38 1 5 3 1 4 5
4 33 1 5 4 1 0 5
3 58 0 5 5 1 2 15
3 51 0 5 5 1 3 5
15 51 1 5 3 1 6 6
2 26 1 3 3 1 2 20
2 50 0 5 4 1 0 10
24 54 1 5 5 1 0 .
0 28 0 4 4 1 3 10
8 54 1 2 3 1 3 17
6 71 1 5 4 1 0 15
20 49 1 4 4 1 0 7
14 58 1 5 5 1 0 30
9 53 0 4 3 1 3 10
0 71 1 4 4 1 4 20
4 18 0 4 3 1 0 20
2 32 1 5 3 1 8 .
11 19 0 5 5 1 4 15
0 72 0 5 4 1 3 30
21 35 1 5 5 1 0 15
1 43 1 3 3 1 4 5
0 67 0 5 5 0 0 5
2 82 1 5 5 0 0 15
0 70 0 4 4 0 0 15
4 75 1 3 4 0 2 10
0 87 1 2 3 0 0 15
0 74 1 5 5 0 2 20
0 83 0 4 4 0 0 14
0 47 1 5 5 0 3 12
0 81 0 4 5 0 2 15
0 42 1 2 2 0 0 30
2 50 0 4 4 0 0 10
1 60 1 5 5 0 0 10
0 42 1 5 4 0 2 8
2 76 1 5 3 0 0 20
10 54 0 5 4 0 0 15
0 48 1 4 3 0 4 25
0 61 0 5 4 0 0 20
0 53 0 4 3 0 0 25
4 72 1 5 5 0 2 20
0 52 0 4 3 0 3 10
1 75 1 2 3 0 0 12
0 51 0 5 5 0 0 .
0 62 0 3 3 0 3 20
9 68 1 3 3 0 2 15
1 48 0 5 4 1 5 5
6 59 1 5 4 1 5 12
1 44 1 5 4 1 3 20
0 26 1 4 4 1 0 20
0 32 1 5 4 1 0 15
5 53 0 5 4 1 3 10
0 70 1 5 5 1 3 12
2 53 1 5 5 1 0 8
6 44 1 5 4 1 11 8
17 50 1 5 5 1 0 15
5 63 0 5 4 1 5 5
2 74 1 5 5 1 0 10
0 26 1 5 5 1 3 15
7 41 1 5 4 1 3 5
12 35 0 5 4 1 3 25
8 51 0 3 1 1 0 10
20 72 1 5 5 1 4 18
3 56 0 4 4 1 0 15
0 84 1 5 5 1 0 10
0 58 0 5 2 1 0 15
0 32 0 4 3 1 0 10
9 65 1 5 5 1 0 15
5 63 0 2 3 1 6 15
0 42 0 5 5 1 0 3
7 32 0 5 4 1 3 5
3 38 1 4 4 1 2 15
4 57 1 4 4 1 4 15
6 57 1 5 4 1 0 10
1 52 0 3 2 1 6 15
0 30 0 5 3 1 0 10
0 25 0 4 4 1 4 15
7 25 0 4 4 1 5 20
3 67 1 3 3 1 5 10
8 41 0 3 2 1 2 18
2 40 1 5 4 1 0 15
0 41 0 5 5 1 3 20
9 39 0 3 3 1 0 10
0 38 1 3 2 1 2 15
0 46 0 5 4 1 0 15
7 62 0 5 5 1 0 20
2 76 1 5 4 1 3 10
1 44 0 3 3 0 2 10
0 34 0 5 5 0 3 45
2 61 0 4 4 0 4 .
0 60 0 5 5 0 0 12
4 44 1 5 5 0 2 45
0 42 1 5 5 0 3 15
4 78 0 4 5 0 2 15
0 86 1 3 4 0 0 30
0 38 0 4 3 0 4 10
0 64 1 5 4 0 2 6
9 73 1 2 4 0 3 12
0 22 0 4 4 0 2 5
4 47 0 4 4 0 5 13
0 29 0 4 3 0 2 25
0 87 0 2 4 0 0 15
0 81 0 4 5 0 3 20
6 78 0 4 4 0 0 10
0 71 0 3 3 0 2 5
0 49 0 2 3 0 2 20
0 60 0 4 4 0 3 12
1 69 0 5 5 0 0 17
2 73 1 5 5 0 0 15
0 58 0 4 5 0 0 22
0 44 1 5 4 0 0 15
0 55 1 4 3 0 0 30
1 71 0 4 3 0 0 20
6 22 1 5 4 0 0 15
0 40 0 5 4 0 3 15
1 84 0 2 5 0 0 20
0 75 0 4 4 0 2 10
2 53 1 3 3 0 2 15
2 68 0 4 4 0 3 10
2 49 1 5 3 0 0 15
2 73 0 5 4 0 0 10
0 56 0 4 2 0 0 15
;

/*------------
ROBUST Macro
------------*/

/*********************************************************************
MACRO ROBUST produces robust estimates of the covariance matrix for
the coefficients from PROC LOGISTIC or PROC PHREG when the data are
clustered. One common application is to longitidunal data with each
individual treated as a cluster.  IML is required.

The macro uses the method of Halbert White (1982) "Maximum likelihood
estimation of misspecified models," Econometrica 50: 1-25.

Author:  Paul D. Allison, University of Pennsylvania
          allison@ssc.upenn.edu

Adapted from an IML program written by Terry Therneau, Mayo Clinic.

For PROC LOGISTIC, you must specify the OUTEST=name1 and
COVOUT options on the PROC statement. You must also use the OUTPUT
statement with OUT=name2 and DFBETAS=namelist.  The namelist should
have one name for each term in the model, including the intercept.
There must also be a variable in the data set containing a unique
value (either character or numeric) for each cluster. The macro is
invoked after running the LOGISTIC procedure.

For PROC PHREG, you must specify OUTEST=name1 on the PROC
statement. (COVOUT is unncessary).  You must also use the OUTPUT
statement with OUT=name2 and DFBETA=namelist.  The namelist should
have one name for each variable in the model. There must also be a
variable in the data set containing a unique value (either character
or numeric) for each cluster. This variable must be added to the
OUTPUT data set by using the ID statement.  The macro is
invoked after running the PHREG procedure.

The macro has the following parameters:

OUTEST   Name of data set used in the OUTEST= option.
OUT      Name of data set used in the OUT= option.
ID       Name of variable containing a unique value for each cluster
DF       List of names used in the DFBETAS or DFBETA option.

Examples of usage:

proc logistic outest=a covout;
  model y = x z w;
  output out=b dfbetas=dint dx dz dw;
run;
%robust(outest=a, out=b, id=subjid, df=dint dx dz dw)

proc phreg outest=a;
  model y*d(0) = x z w;
  id subjid;
  output out=b dfbeta= dx dz dw;
run;
%robust(outest=a, out=b, id=subjid, df=dx dz dw)

BE CAREFUL: 
On the OUTPUT statement, it's DFBETAS in LOGISTIC but DFBETA in PHREG.
(The former is standardized, the latter is not).
Also PHREG does NOT have an intercept.
**************************************************************
**************************************************************/

%macro robust(outest=a, out=_last_, id=id, df=);

proc sort data=&out;
  by &id;
run;
proc means data=&out noprint;
  by &id;
  var &df;
  output out=_out1_(keep=&df) sum=&df;
run;
data _out1_;
set;
array d (*) &df;
if d(1)=. then delete;
run;

data _reduce_;
  set &outest;
  array abc(*) _character_;
  length name $8;
  call vname(abc(1),name);
  if name ne '_LINK_' and _type_ eq 'COV' then delete;
  drop  _lnlike_;
run;

proc iml;
  use _reduce_ where (_type_='COV');
  read all into cov;
  use _reduce_ where (_type_='PARMS');
  read all into b[colname=vname];
  if ncol(cov)=0 then se=1;
  else se=sqrt(diag(cov));
  use _out1_;
  read all into x;
  x=x*se;
  v=x`*x;
  se=sqrt(vecdiag(v));
  wald=(b`/se)##2;
  p=1-probchi(wald,1);
  chi=wald||p;
  c={"Chi Square" "p-value"};
  reset noname fuzz=.000001;
  print, "Robust Variance Matrix",,
     v[colname=vname rowname=vname];
  print, "Standard Errors",, se[rowname=vname];
  print, "Wald Statistics",, chi[rowname=vname colname=c];
quit;
run;

%mend robust;


/*************************************************************************
PROGRAMS
************************************************************************/


/* The following program is found on page 6 of   */
/* "Logistic Regression Using the SAS System."   */

PROC REG DATA=my.penalty;
  MODEL death=blackd whitvic serious;
RUN;


/* The following program is found on page 18 of   */
/* "Logistic Regression Using the SAS System."    */

PROC LOGISTIC DATA=my.penalty DESCENDING;
  MODEL death=blackd whitvic serious;
RUN;

/* The following program is found on page 21 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
  MODEL death=blackd whitvic serious / DIST=BINOMIAL;
RUN;
/* The following program is found on page 24 of  */
/* "Logistic Regression Using the SAS System."   */

PROC GENMOD DATA=my.penalty;
  CLASS culp;
  MODEL death = blackd whitvic culp / D=B;
RUN;

/* The following program is found on page 25 of   */
/* "Logistic Regression Using the SAS System."   */

PROC GENMOD DATA=my.penalty;
  MODEL death = blackd whitvic culp blackd*whitvic / D=B;
RUN;

/* The following program is found on page 32 of   */
/* "Logistic Regression Using the SAS System."   */

PROC LOGISTIC DATA=my.penalty DES;
  MODEL death = blackd whitvic culp / CLPARM=BOTH;
RUN;

/* The following program is found on page 33 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
  MODEL death = blackd whitvic culp / D=B WALDCI LRCI;
RUN;

/* The following program is found on page 40 of   */
/* "Logistic Regression Using the SAS System."    */

DATA compsep;
  INPUT x y;
  DATALINES;
1 0
2 0
3 0
4 1
5 1
6 1
;
PROC LOGISTIC DES;
  MODEL y = x;
RUN;

PROC GENMOD DATA=compsep;
 MODEL y = x / D=B;
RUN;

/* The following program is found on page 41 of   */
/* "Logistic Regression Using the SAS System."    */

DATA quasisep;
  INPUT x y;
  DATALINES;
1 0
2 0
3 0
4 0
4 1
5 1
6 1
;
PROC LOGISTIC DES;
  MODEL y = x;
PROC GENMOD;
  MODEL y = x /D=B;
RUN;

/* The following program is found on page 43 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
  WHERE blackd=0;
  CLASS culp;
  MODEL death = culp serious / D=B TYPE3;
RUN;

/* The following program is found on page 45 of   */
/* "Logistic Regression Using the SAS System."    */

DATA;
  SET my.penalty;
  IF culp=1 THEN culp=2;
PROC GENMOD;
  WHERE blackd=0;
  CLASS culp;
  MODEL death=culp serious /D=B;
RUN;

/* The following program is found on page 46 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
  WHERE blackd=0 AND culp > 1;
  CLASS culp;
  MODEL death=culp serious /D=B;
RUN;

/* The following program is found on page 47 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
  WHERE blackd=0;
  CLASS culp;
  MODEL death=culp serious /D=B;
  CONTRAST 'culp1 v. culp5' CULP 1 0 0 0 -1;
RUN;

/* The following program is found on page 49 of   */
/* "Logistic Regression Using the SAS System."    */

PROC REG DATA=my.penalty;
  MODEL death = blackd whitvic serious1 serious2 / TOL VIF; 
RUN;

/* The following program is found on page 50 of   */
/* "Logistic Regression Using the SAS System."    */

PROC LOGISTIC DES DATA=my.penalty;
  MODEL death = blackd whitvic serious1 serious2;
  OUTPUT OUT=a PRED=phat;
DATA b;
  SET a;
  w = phat*(1-phat);
PROC REG DATA=b;
  WEIGHT w;
  MODEL death = blackd whitvic serious1 serious2 / TOL VIF; 
RUN;

/* The following program is found on page 52 of   */
/* "Logistic Regression Using the SAS System."    */

PROC LOGISTIC DES DATA=my.penalty;
  MODEL death = blackd whitvic culp / AGGREGATE SCALE=NONE;
RUN;

/* The following program is found on page 53 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
CLASS culp;
MODEL death = blackd whitvic culp blackd*whitvic blackd*culp
              whitvic*culp blackd*whitvic*culp / D=B;
RUN;

/* The following program is found on page 54 of   */
/* "Logistic Regression Using the SAS System."    */

PROC LOGISTIC DES DATA=my.penalty;
  MODEL death = blackd whitvic culp / LACKFIT;
RUN;

/* The following program is found on page 60 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
  MODEL death = culp blackd whitvic / D=B OBSTATS RESIDUALS;
  MAKE 'OBSTATS' OUT=a;
RUN;

/* The following program is found on page 63 of   */
/* "Logistic Regression Using the SAS System."    */

PROC LOGISTIC DES DATA=my.penalty;
  MODEL death = culp blackd whitvic;
  OUTPUT OUT=a(KEEP= death pred up lo chi dev) P=pred U=up L=lo 
     RESCHI=chi RESDEV=dev;

/* The following program is found on page 65 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GPLOT DATA=b;
  PLOT dev*pred / VAXIS=AXIS1 HAXIS=AXIS1;
  SYMBOL V=DOT HEIGHT=.35;
  AXIS1 MINOR=NONE WIDTH=2 MAJOR=(WIDTH=2);
RUN;

/* The following program is found on page 71 of   */
/* "Logistic Regression Using the SAS System."    */

PROC LOGISTIC DES DATA=my.penalty;
  MODEL death = culp blackd whitvic / LINK=PROBIT;
RUN;

/* The following program is found on page 83 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=my.penalty;
  MODEL death = blackd / D=B;
RUN;

/* The following program is found on pages 83-84 of   */
/* "Logistic Regression Using the SAS System."    */

DATA tab4_1a;
  INPUT f blackd death;
  DATALINES;
22 0 1
28 1 1
52 0 0
45 1 0
;
PROC GENMOD DATA=tab4_1a;
  FREQ f;
  MODEL death = blackd / D=B;
RUN;

/* The following program is found on page 84 of   */
/* "Logistic Regression Using the SAS System."    */

DATA tab4_1b;
  INPUT death total blackd;
  DATALINES;
22 74 0
28 73 1
;
PROC GENMOD DATA=tab4_1b;
  MODEL death/total = blackd / D=B;
RUN;

/* The following program is found on page 85 of   */
/* "Logistic Regression Using the SAS System."    */

PROC LOGISTIC DATA=tab4_1b;
  MODEL death/total = blackd / AGGREGATE SCALE=N;
RUN;

/* The following program is found on page 86 of   */
/* "Logistic Regression Using the SAS System."    */

PROC FREQ DATA=tab4_1a;
  WEIGHT f;
  TABLES blackd*death / CHISQ CMH;
RUN;

/* The following program is found on page 88 of   */
/* "Logistic Regression Using the SAS System."    */

DATA interco;
  INPUT white male yes no;
  total=yes+no;
  DATALINES;
1 1 43 134
1 0 26 149
0 1 29 23
0 0 22 36
;
PROC GENMOD DATA=interco;
  MODEL yes/total=white male / D=B;
RUN;

/* The following program is found on page 89 of   */
/* "Logistic Regression Using the SAS System."    */

DATA;
  CHI=1-PROBCHI(.0583,1);
  PUT CHI;
RUN;

/* The following program is found on page 90 of   */
/* "Logistic Regression Using the SAS System."    */


PROC GENMOD DATA=interco;
  MODEL yes/total=white male white*male/ D=B;
RUN;

/* The following program is found on page 92 of   */
/* "Logistic Regression Using the SAS System."    */

DATA working;
  INPUT france manual famanual total working;
  DATALINES;
1   1   1  107  85
1   1   0   65  44
1   0   1   66  24
1   0   0  171  17
0   1   1   87  24
0   1   0   65  22
0   0   1   85   1
0   0   0  148   6
;
PROC GENMOD DATA=working;
  MODEL working/total = france manual famanual / D=B;
RUN;

/* The following program is found on page 93 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=working;
  MODEL working/total = france manual famanual 
    france*manual france*famanual manual*famanual / D=B;
RUN;

/* The following program is found on page 97-98 of   */
/* "Logistic Regression Using the SAS System."      */

DATA wisc;
  INPUT iq parent ses total coll;
  DATALINES;    
1   1   1   353     4
1   1   2   234     2
1   1   3   174     8
1   1   4    52     4
1   2   1    77    13
1   2   2   111    27
1   2   3   138    47
1   2   4    96    39
2   1   1   216     9
2   1   2   208     7
2   1   3   126     6
2   1   4    52     5
2   2   1   105    33
2   2   2   159    64
2   2   3   184    74
2   2   4   213   123
3   1   1   138    12
3   1   2   127    12
3   1   3   109    17
3   1   4    50     9
3   2   1    92    38
3   2   2   185    93
3   2   3   248   148
3   2   4   289   224
4   1   1    77    10
4   1   2    96    17
4   1   3    48     6
4   1   4    25     8
4   2   1    92    49
4   2   2   178   119
4   2   3   271   198
4   2   4   468   414
; 
PROC GENMOD DATA=wisc;
  CLASS iq ses;
  MODEL coll/total=iq ses parent / D=B TYPE3;
RUN;

/* The following program is found on page 99 of   */
/* "Logistic Regression Using the SAS System."    */

PROC GENMOD DATA=wisc;
  CLASS iq ses;
  MODEL coll/total=iq|ses|parent @2/ D=B TYPE3;
RUN;

/* The following program is found on page 104-105 of   */
/* "Logistic Regression Using the SAS System."         */

DATA my.nihdoc;
  INPUT nih docs pdoc;
  DATALINES; 
.5 8 1
.5 9 3
.835 16 1
.998 13 6
1.027 8 2
2.036 9 2
2.106 29 10
2.329 5 2
2.523 7 5
2.524 8 4
2.874 7 4
3.898 7 5
4.118 10 4
4.130 5 1
4.145 6 3
4.242 7 2
4.280 9 4
4.524 6 1
4.858 5 2
4.893 7 2
4.944 5 4
5.279 5 1
5.548 6 3
5.974 5 4
6.733 6 5
7 12 5
9.115 6 2
9.684 5 3
12.154 8 5
13.059 5 3
13.111 10 8
13.197 7 4
13.433 86 33
13.749 12 7
14.367 29 21
14.698 19 5
15.440 10 6
17.417 10 8
18.635 14 9
21.524 18 16
;
PROC GENMOD DATA=my.nihdoc;
  MODEL pdoc/docs=nih / D=B;
RUN;

/* The following program is found on page 107 of   */
/* "Logistic Regression Using the SAS System."     */

PROC LOGISTIC DATA=my.nihdoc;
  MODEL pdoc/docs=nih / D=B AGGREGATE SCALE=WILLIAMS;
RUN;

/* The following program is found on page 110 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=my.nihdoc;
  MODEL pdoc/docs=nih docs/ D=B;
RUN;

/* The following program is found on page 115 of   */
/* "Logistic Regression Using the SAS System."     */

PROC CATMOD DATA=my.wallet;
  DIRECT male business punish explain;
  MODEL wallet = male business punish explain / NOITER;
RUN;

/* The following program is found on page 120 of   */
/* "Logistic Regression Using the SAS System."     */

MODEL wallet = _response_ male business punish explain /      
      NOITER;

/* The following program is found on page 120 of   */
/* "Logistic Regression Using the SAS System."     */

CONTRAST 'all'   @1 male 1     @2 male -1,
                 @1 business 1 @2 business -1,
                 @1 punish 1   @2 punish -1,
                 @1 explain 1  @2 explain -1;

/* The following program is found on page 121 of   */
/* "Logistic Regression Using the SAS System."     */

MODEL wallet = male business punish explain male*business
  male*punish male*explain business*punish business*explain
  punish*explain / NOITER;

/* The following program is found on page 122 of   */
/* "Logistic Regression Using the SAS System."     */

PROC LOGISTIC DATA=my.wallet;
  WHERE wallet NE 2;
  MODEL wallet=male business punish explain;
RUN;
PROC LOGISTIC DATA=my.wallet;
  WHERE wallet NE 1;
  MODEL wallet=male business punish explain;
RUN;  
PROC LOGISTIC DATA=my.wallet;
  WHERE wallet NE 3;
  MODEL wallet=male business punish explain;
RUN; 

/* The following program is found on page 124 of   */
/* "Logistic Regression Using the SAS System."     */

DATA my.afterlif;
  INPUT white female belief freq;
  DATALINES;
1 1 1 371
1 1 2  49
1 1 3  74
1 0 1 250
1 0 2  45
1 0 3  71
0 1 1  64
0 1 2   9
0 1 3  15
0 0 1  25
0 0 2   5
0 0 3  13
;
PROC CATMOD DATA=my.afterlif;
  WEIGHT freq;
  DIRECT white female;
  MODEL belief=white female / NOITER PRED;
RUN;

/* The following program is found on page 126 of   */
/* "Logistic Regression Using the SAS System."     */

PROC CATMOD DATA=my.afterlif;
  WEIGHT freq;
  DIRECT white female;
  POPULATION white female;
  MODEL belief= / NOITER PRED;
RUN;

/* The following program is found on page 134 of   */
/* "Logistic Regression Using the SAS System."     */

PROC LOGISTIC DATA=my.wallet;
  MODEL wallet = male business punish explain;
RUN;

/* The following program is found on page 136 of   */
/* "Logistic Regression Using the SAS System."     */

DATA a;
  SET my.wallet;
  IF wallet=1 THEN wallet=2;
RUN;
PROC LOGISTIC DATA=a;
  MODEL wallet = male business punish explain;
RUN;

/* The following program is found on page 137 of   */
/* "Logistic Regression Using the SAS System."     */

DATA a;
  SET my.wallet;
  IF wallet=3 THEN wallet=2;
RUN;
PROC LOGISTIC DATA=a;
  MODEL wallet = male business punish explain;
RUN;

/* The following program is found on page 143 of   */
/* "Logistic Regression Using the SAS System."     */
        
DATA happy;
  INPUT year married happy count;
  y84 = year EQ 2;
  y94 = year EQ 3;
  DATALINES;
1 1 1 473
1 1 2 493
1 1 3  93
1 0 1  84
1 0 2 231
1 0 3  99
2 1 1 332
2 1 2 387
2 1 3  62
2 0 1 150
2 0 2 347
2 0 3 117
3 1 1 571
3 1 2 793
3 1 3 112
3 0 1 257
3 0 2 889
3 0 3 234
;

/* The following program is found on page 144 of   */
/* "Logistic Regression Using the SAS System."     */

PROC LOGISTIC DATA=happy;
  FREQ count;
  MODEL happy = married y84 y94 / AGGREGATE SCALE=N;
  TEST y84, y94;
RUN;

/* The following program is found on page 147 of   */
/* "Logistic Regression Using the SAS System."     */

DATA a;
 SET happy;
 lesshap=happy GE 2;
 nottoo=happy EQ 3;
RUN;
PROC LOGISTIC DATA=a;
  FREQ count;
  MODEL lesshap=married y84 y94;
RUN;
PROC LOGISTIC DATA=a;
  FREQ count;
  MODEL nottoo=married y84 y94;
RUN;

/* The following program is found on page 149 of   */
/* "Logistic Regression Using the SAS System."     */

PROC CATMOD DATA=happy;
  WEIGHT count;
  DIRECT married y84 y94;
  RESPONSE ALOGIT;
  MODEL happy = _RESPONSE_ married y84 y94 / WLS;
RUN;

/* The following program is found on page 153-154 of   */
/* "Logistic Regression Using the SAS System."     */

DATA my.afqt;
  INPUT white old faed ed count;
  DATALINES;
1  0  1  1   39
1  0  1  2   29
1  0  1  3    8
1  0  2  1    4
1  0  2  2    8
1  0  2  3    1
1  0  3  1   11
1  0  3  2    9
1  0  3  3    6
1  0  4  1   48
1  0  4  2   17
1  0  4  3    8
1  1  1  1  231
1  1  1  2  115
1  1  1  3   51
1  1  2  1   17
1  1  2  2   21
1  1  2  3   13
1  1  3  1   18
1  1  3  2   28
1  1  3  3   45
1  1  4  1  197
1  1  4  2  111
1  1  4  3   35
0  0  1  1   19
0  0  1  2   40
0  0  1  3   19
0  0  2  1    5
0  0  2  2   17
0  0  2  3    7
0  0  3  1    2
0  0  3  2   14
0  0  3  3    3
0  0  4  1   49
0  0  4  2   79
0  0  4  3   24
0  1  1  1  110
0  1  1  2  133
0  1  1  3  103
0  1  2  1   18
0  1  2  2   38
0  1  2  3   25
0  1  3  1   11
0  1  3  2   25
0  1  3  3   18
0  1  4  1  178
0  1  4  2  206
0  1  4  3   81
DATA first;
  SET my.afqt;
  stage=1;
  advance = ed GE 2;
RUN;
DATA second;
  SET my.afqt;
  stage=2;
  IF ed=1 THEN DELETE;
  advance = ed EQ 3;
RUN;
DATA concat;
  SET first second;
RUN;

/* The following program is found on page 155 of   */
/* "Logistic Regression Using the SAS System."     */

DATA combined;
  SET my.afqt;
   stage=1;
   advance = ed GE 2;
  OUTPUT;
   stage=2;
   IF ed=1 THEN DELETE;
   advance = ed EQ 3;
  OUTPUT;
RUN;
PROC GENMOD DATA=combined;
  FREQ count;
  CLASS faed;
  MODEL advance=stage white old faed / D=B TYPE3;
RUN;

/* The following program is found on page 156 of   */
/* "Logistic Regression Using the SAS System."     */

MODEL advance=stage white old faed stage*white stage*old 
        stage*faed / D=B TYPE3;

/* The following program is found on page 157 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=first;
  FREQ count;
  CLASS faed;
  MODEL advance= white old faed / D=B TYPE3;
RUN;
PROC GENMOD DATA=second;
  FREQ count;
  CLASS faed;
  MODEL advance= white old faed / D=B TYPE3;
RUN;

/* The following program is found on page 162 of   */
/* "Logistic Regression Using the SAS System."     */

DATA my.chocs;
   INPUT id choose dark soft nuts @@;
   DATALINES;
 1 0 0 0 0    1 0 0 0 1   1 0 0 1 0    1 0 0 1 1
 1 1 1 0 0    1 0 1 0 1   1 0 1 1 0    1 0 1 1 1
 2 0 0 0 0    2 0 0 0 1   2 0 0 1 0    2 0 0 1 1
 2 0 1 0 0    2 1 1 0 1   2 0 1 1 0    2 0 1 1 1
 3 0 0 0 0    3 0 0 0 1   3 0 0 1 0    3 0 0 1 1
 3 0 1 0 0    3 0 1 0 1   3 1 1 1 0    3 0 1 1 1
 4 0 0 0 0    4 0 0 0 1   4 0 0 1 0    4 0 0 1 1
 4 1 1 0 0    4 0 1 0 1   4 0 1 1 0    4 0 1 1 1
 5 0 0 0 0    5 1 0 0 1   5 0 0 1 0    5 0 0 1 1
 5 0 1 0 0    5 0 1 0 1   5 0 1 1 0    5 0 1 1 1
 6 0 0 0 0    6 0 0 0 1   6 0 0 1 0    6 0 0 1 1
 6 0 1 0 0    6 1 1 0 1   6 0 1 1 0    6 0 1 1 1
 7 0 0 0 0    7 1 0 0 1   7 0 0 1 0    7 0 0 1 1
 7 0 1 0 0    7 0 1 0 1   7 0 1 1 0    7 0 1 1 1
 8 0 0 0 0    8 0 0 0 1   8 0 0 1 0    8 0 0 1 1
 8 0 1 0 0    8 1 1 0 1   8 0 1 1 0    8 0 1 1 1
 9 0 0 0 0    9 0 0 0 1   9 0 0 1 0    9 0 0 1 1
 9 0 1 0 0    9 1 1 0 1   9 0 1 1 0    9 0 1 1 1
10 0 0 0 0   10 0 0 0 1  10 0 0 1 0   10 0 0 1 1
10 0 1 0 0   10 1 1 0 1  10 0 1 1 0   10 0 1 1 1
;

/* The following program is found on page 163 of   */
/* "Logistic Regression Using the SAS System."     */

DATA chocs;
  SET my.chocs;
  choose=2-choose;
RUN;
PROC PHREG DATA=chocs NOSUMMARY;
  MODEL choose=dark soft nuts / TIES=DISCRETE;
  STRATA id;
RUN;

/* The following program is found on page 169 of   */
/* "Logistic Regression Using the SAS System."     */

DATA travel;
  SET my.travel;
  choice = 2-choice;
  air = mode EQ 1;
  train = mode EQ 2;
  bus = mode EQ 3;
  airhinc = air*hinc;
  airpsize = air*psize;
  trahinc = train*hinc;
  trapsize = train*psize;
  bushinc = bus*hinc;
  buspsize = bus*psize;
RUN;

/* The following program is found on page 170 of   */
/* "Logistic Regression Using the SAS System."     */

PROC PHREG DATA=travel NOSUMMARY;
  MODEL choice = ttme time cost / TIES=DISCRETE;
  STRATA id;
RUN;

/* The following program is found on page 171 of   */
/* "Logistic Regression Using the SAS System."     */

MODEL choice = air bus train airhinc bushinc trahinc airpsize 
  buspsize trapsize/ TIES=DISCRETE;

/* The following program is found on page 172 of   */
/* "Logistic Regression Using the SAS System."     */

PROC CATMOD DATA=travel;
  WHERE choice=1;
  DIRECT hinc psize;
  MODEL mode=hinc psize / NOITER NOPROFILE;
RUN;

/* The following program is found on page 175 of   */
/* "Logistic Regression Using the SAS System."     */

PROC PHREG DATA=travel NOSUMMARY;
  MODEL choice*choice(2) = ttme time cost;
  STRATA id;
RUN;

/* The following program is found on page 176 of   */
/* "Logistic Regression Using the SAS System."     */

PROC PHREG DATA=my.judgernk NOSUMMARY;
  MODEL rank=blackd whitvic death / TIES=DISCRETE;
  STRATA judgid;
RUN;

/* The following program is found on page 182 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=my.ptsd;
  CLASS time;
  MODEL ptsd = control problems sevent cohes time / D=B;
RUN; 

/* The following program is found on page 184 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=my.ptsd;
  CLASS subjid time;
  MODEL ptsd = control problems sevent cohes time / D=B;
  REPEATED SUBJECT=subjid / WITHIN=time TYPE=UN CORRW;
RUN;

/* The following program is found on page 190 of   */
/* "Logistic Regression Using the SAS System."     */

DATA ptsd;
  SET my.ptsd;
  ptsd=2-ptsd;
  t1 = time EQ 1;
  t2 = time EQ 2;
RUN;
PROC PHREG DATA=ptsd NOSUMMARY;
  MODEL ptsd = control problems sevent cohes t1 t2 /   
     TIES=DISCRETE;
  STRATA subjid;
RUN;

/* The following program is found on page 194 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=my.postdoc;
  CLASS docid;
  MODEL pdoc = age mar doc ag und arts cits / D=B;
  REPEATED SUBJECT=docid / TYPE=EXCH;
RUN;

/* The following program is found on page 196 of   */
/* "Logistic Regression Using the SAS System."     */

DATA postdoc;
  SET my.postdoc;
  pdoc=2-pdoc;
RUN;
PROC PHREG DATA=postdoc NOSUMMARY;
  MODEL pdocd = age mar ag und arts cits / TIES=DISCRETE;
  STRATA docid;
RUN;

/* The following program is found on page 200 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=my.casecont;
  CLASS casenum;
  MODEL pubhouse=staybaby black kids doubleup age days / D=B;
  REPEATED SUBJECT=casenum / TYPE=UN CORRW;
RUN; 

/* The following program is found on page 202 of   */
/* "Logistic Regression Using the SAS System."     */

DATA b;
  SET my.casecont;
  pubhouse=1-pubhouse;
RUN;
PROC PHREG DATA=b NOSUMMARY;
 MODEL pubhouse= staybaby black kids doubleup age / 
         TIES=DISCRETE;
 STRATA casenum;
RUN;

/* The following program is found on page 205 of   */
/* "Logistic Regression Using the SAS System."     */

DATA c;
  SET my.casecont;
  staybaby=1-staybaby;
RUN;
PROC PHREG DATA=c NOSUMMARY;
  MODEL staybaby=black kids doubleup age;
  STRATA casenum;
RUN;

/* The following program is found on page 207 of   */
/* "Logistic Regression Using the SAS System."     */

DATA ptsd;
  SET my.ptsd;
  n=1;
RUN;

%GLIMMIX(DATA=ptsd, STMTS=%STR(

  CLASS subjid time;
  MODEL ptsd/n = control problems sevent cohes time / 
     SOLUTION;
  RANDOM subjid;

))

/* The following program is found on page 209 of   */
/* "Logistic Regression Using the SAS System."     */

DATA postdoc;
  SET my.postdoc;
  n=1;
RUN;

%GLIMMIX(DATA=postdoc,STMTS=%STR(

  CLASS docid;
  MODEL pdoc/n=age mar doc ag und arts cits / SOLUTION;
  RANDOM docid;

))

/* The following program is found on page 211 of   */
/* "Logistic Regression Using the SAS System."     */

%GLIMMIX(DATA=postdoc,STMTS=%STR(

  CLASS docid;
  MODEL pdoc/n=age mar doc ag und arts cits/SOLUTION;
  RANDOM docid docid*ag;

))

/* The following program is found on page 214 of   */
/* "Logistic Regression Using the SAS System."     */

PROC MEANS DATA=my.ptsd NWAY NOPRINT;
  CLASS subjid;
  VAR control problems sevent;
  OUTPUT OUT=means MEAN=mcontrol mproblem msevent;
PROC SORT DATA=my.ptsd;
  BY subjid;
PROC SORT DATA=a;
  BY subjid;
DATA combine;
  MERGE my.ptsd means;
  BY subjid;
  dcontrol=control-mcontrol;
  dproblem=problems-mproblem;
  dsevent=sevent-msevent;
RUN; 

/* The following program is found on page 215 of   */
/* "Logistic Regression Using the SAS System."     */

%GLIMMIX(DATA=combine, STMTS=%STR(

  CLASS subjid;
  MODEL ptsd/n = dcontrol dproblem dsevent mcontrol mproblem 
       msevent cohes t2 t3 / SOLUTION;
  RANDOM subjid;

))

/* The following program is found on page 216 of   */
/* "Logistic Regression Using the SAS System."     */

CONTRAST 'spec test' dcontrol 1 mcontrol -1, 
     dproblem 1 mproblem -1, dsevent 1 msevent -1;

/* The following program is found on page 220-221 of   */
/* "Logistic Regression Using the SAS System."         */

PROC GENMOD DATA=my.postdoc;
  MODEL arts = age mar doc ag und / DIST=POISSON;
PROC GENMOD DATA=my.postdoc;
  MODEL cits = age mar doc ag und / D=P;
RUN;

/* The following program is found on page 223 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=my.postdoc;
  MODEL arts = age mar doc ag und / D=P PSCALE;
PROC GENMOD DATA=my.postdoc;
  MODEL cits = age mar doc ag und / D=P PSCALE;
RUN;

/* The following program is found on page 225 of   */
/* "Logistic Regression Using the SAS System."     */

DATA postdoc;
  SET my.postdoc;
  lcits=log(cits+.5);
RUN; 
PROC GENMOD DATA=postdoc;
  MODEL lcits = age mar doc ag und;
RUN;

/* The following program is found on page 226 of   */
/* "Logistic Regression Using the SAS System."     */

%HILBENB(DSIN=my.postdoc,YVAR=arts,XVARS=age mar doc ag und)
%HILBENB(DSIN=my.postdoc,YVAR=cits,XVARS=age mar doc ag und)

/* The following program is found on page 229-230 of   */
/* "Logistic Regression Using the SAS System."        */

DATA prog2;
  SET my.prognosi;
  lmin=LOG(minutes);
RUN;
PROC GENMOD DATA=prog2;
  MODEL lengthpx=ptage ptsex ezcompt mdlikept surgeon claims / 
     OFFSET=lmin D=P;
RUN;

/* The following program is found on page 236 of   */
/* "Logistic Regression Using the SAS System."     */

DATA penalty;
  INPUT n death black;
  DATALINES;
28 1 1
22 1 0
45 0 1
52 0 0
;
PROC GENMOD DATA=penalty;
  MODEL n = death black death*black / DIST=POISSON;
RUN;

/* The following program is found on page 238 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=penalty;
  WEIGHT n;
  MODEL death=black / D=BINOMIAL LINK=LOGIT;
RUN;

/* The following program is found on page 238 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=penalty;
  WEIGHT n;
  MODEL black=death / D=BINOMIAL LINK=LOGIT;
RUN;

/* The following program is found on page 240 of   */
/* "Logistic Regression Using the SAS System."     */

DATA wisctab;
  SET wisc;
  college=1; 
  freq=coll;
  OUTPUT;
  college=0; 
  freq=total-coll;
  OUTPUT;
  DROP total coll;
PROC PRINT;
RUN;  

/* The following program is found on page 242 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=wisctab;
  CLASS iq ses;
  MODEL freq=iq|ses|parent college iq*college ses*college   
       parent*college / D=P TYPE3;
RUN;

/* The following program is found on page 247 of   */
/* "Logistic Regression Using the SAS System."     */

DATA happy;
  INPUT year married happy count;
  happyq=happy;
  DATALINES;
1 1 1 473
1 1 2 493
1 1 3  93
1 0 1  84
1 0 2 231
1 0 3  99
2 1 1 332
2 1 2 387
2 1 3  62
2 0 1 150
2 0 2 347
2 0 3 117
3 1 1 571
3 1 2 793
3 1 3 112
3 0 1 257
3 0 2 889
3 0 3 234
;
PROC GENMOD DATA=happy;
  CLASS year happy;
  MODEL count=year|married happy year*happyq married*happyq /
    D=P TYPE3;
RUN;

/* The following program is found on page 250 of   */
/* "Logistic Regression Using the SAS System."     */

MODEL count=year|married happy year*happyq married*happyq
    married*year*happyq / D=P TYPE3;

/* The following program is found on page 250 of   */
/* "Logistic Regression Using the SAS System."     */

MODEL count=year|married happy year*happy married*happy /
    D=P TYPE3;

/* The following program is found on page 251-252 of   */
/* "Logistic Regression Using the SAS System."        */

DATA happy2;
  SET happy;
  yearq=year;
  pretty=happy eq 2;
RUN;
PROC GENMOD DATA=happy2;
  CLASS year happy;
  MODEL count=year|married happy yearq*pretty married*happyq 
    / D=P TYPE3;
RUN;

/* The following program is found on page 253-254 of   */
/* "Logistic Regression Using the SAS System."       */

DATA mobility;
    INPUT n dad son;
    DATALINES;
50  1 1
45  1 2
8   1 3
18  1 4
8   1 5
28  2 1
174 2 2
84  2 3
154 2 4
55  2 5
11  3 1
78  3 2
110 3 3
223 3 4
96  3 5
14  4 1
150 4 2
185 4 3
714 4 4
447 4 5
0   5 1
42  5 2
72  5 3 
320 5 4
411 5 5
;
PROC GENMOD DATA=mobility;
  CLASS dad son;
        MODEL n = dad son /D=P;
RUN;

/* The following program is found on page 255 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=mobility;
  WHERE dad NE son;
  CLASS dad son;
        MODEL n = dad son /D=P;
RUN;

/* The following program is found on page 255 of   */
/* "Logistic Regression Using the SAS System."     */

DATA b;
  SET mobility;
  up=son GT dad;
PROC GENMOD DATA=b;
  WHERE dad NE son;
  CLASS dad son;
        MODEL n = dad son son*up dad*up/D=P;
RUN;

/* The following program is found on page 256 of   */
/* "Logistic Regression Using the SAS System."     */

DATA c;
  SET mobility;
  band=ABS(dad-son);
PROC GENMOD DATA=c;
  WHERE dad NE son;
  CLASS dad son band;
      MODEL n = dad son band /D=P;
RUN;

/* The following program is found on page 257 of   */
/* "Logistic Regression Using the SAS System."     */

DATA d;
  SET mobility;
  sonq=son;
  dadq=dad;
PROC GENMOD DATA=d;
  WHERE dad NE son;
  CLASS dad son;
        MODEL n = dad son sonq*dadq /D=P OBSTATS;
RUN;

/* The following program is found on page 262 of   */
/* "Logistic Regression Using the SAS System."     */

DATA zero;
  INPUT x y z f;
  DATALINES;
1    1    1    20
1    0    1     5
1    1    0     5
1    0    0     5
0    1    1     4
0    0    1    11
0    1    0     0
0    0    0     0
;
PROC GENMOD DATA=zero;
  FREQ f;
  MODEL y = x z / D=B;
RUN;

/* The following program is found on page 263 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=zero;
  MODEL f=x z y x*z y*z y*x / D=P OBSTATS;
RUN;

/* The following program is found on page 265 of   */
/* "Logistic Regression Using the SAS System."     */

PROC GENMOD DATA=zero;
  WHERE f NE 0;
  MODEL f=x z y x*z y*z y*x / D=P;
RUN;


